unit Banner;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ExtCtrls,imglist,picturelist,igriegaclasses;

type
  TBannerType=(rtPrograming,rtAuto);
  TBanner = class(TImage)
  private
    FBannerType:TBannerType;
    FTimer:TTimer;
    FInterval: Cardinal;
    FPictureList:TPictureList;
    FSelected:Integer;
    procedure SetBannerType(Value:TBannerType);
    procedure SetInterval(Value:Cardinal);
    procedure SetSelected(Value:integer);
    { Private declarations }
  protected

    procedure SubOnTimer(Sender:TObject);
    procedure Notification (AComponent: TComponent; Operation: TOperation); override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
    { Public declarations }
  published
    property BannerType:TBannerType read FBannerType write SetBannerType default rtPrograming;
    property Interval:Cardinal read FInterval write SetInterval default 5000;
    property Selected:integer read FSelected write SetSelected;
    Property PictureList:TPicturelist Read FPictureList Write FPicturelist;
    property Action;

    { Published declarations }
  end;

Implementation

constructor TBanner.Create(AOwner: TComponent);
begin
   inherited;
   FBannerType:=rtPrograming;
   Ftimer:=TTimer.Create(self);
   FTimer.Enabled:=false;
   Ftimer.OnTimer:=SubOnTimer;
   FInterval:=5000;
   Ftimer.Interval := FInterval;
end;
destructor TBanner.destroy;
begin
   if assigned(FTimer) then
   begin
      Ftimer.OnTimer:=nil;
      FTimer.Free;
   end;
   inherited;
end;
procedure TBanner.Notification (AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    if Assigned(FPicturelist) and (AComponent = PictureList) then
       PictureList := nil;
  end;
end;
procedure TBanner.SetInterval(Value:Cardinal);
begin
   if Value<>FInterval then
   begin
      FInterval:=Value;
      FTimer.Interval:=Value;
   end;
end;
procedure TBanner.SubOnTimer(Sender:TObject);
begin
   selected:=selected+1
end;
procedure TBanner.SetBannerType(Value:TBannerType);
begin
   if value<>FBannerType then
   begin
       FBannerType:=Value;
       if not (csDesigning in ComponentState)then
          if FBannerType=rtAuto then
             Ftimer.Enabled:=true
          else
             FTimer.Enabled:=false;
   end;
end;

procedure TBanner.SetSelected(Value:integer);
begin
   if assigned(FPictureList) then
   begin
      if (value<0) or (value >= fpicturelist.Pictures.Count) then
         value:=0;
      if value < fpicturelist.Pictures.Count then
      begin
         Picture:=picturelist.Picture(Value);
         fselected:=Value;
      end;
   end;
end;

end.
