unit CalcComp;

interface

uses
  Windows, Messages, SysUtils, Classes,MATH, Controls,Buttons, ExtCtrls,StdCtrls,Graphics,dialogs,menus,funciones;
//  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,buttons,graphics;
type
   TFunc=(bfSin,bfCos,bfTan,bfArcSin,bfArcCos,bfArcTan,bfLn,bfLog10,bfPI,bfE,bfSqrt,bf2,bf3,bfx);
const
   bcaptions:array[0..24] of string=('MC','7','8','9','/','C',
                                    'MR','4','5','6','*','CE',
                                    'M-','1','2','3','-','%',
                                    'M+',',','0','=','+','','Funciones');
   btypes:array[0..24] of byte=(0,1,1,1,2,0,
                                0,1,1,1,2,0,
                                0,1,1,1,2,2,
                                0,1,1,2,2,2,2);
   bnumbers=['0'..'9',',',''];
   boperations=['+','-','/','*','M','%','='];
   bMemOper=['+','-','C','R'];
   maxfunc=13;
   bfunc:array[0..maxfunc] of TFunc=(bfPI,bfE,bfSin,bfCos,bfTan,bfArcSin,bfArcCos,bfArcTan,bfLn,bfLog10,bfSqrt,bf2,bf3,bfx);
   bfuncCap:array[0..maxfunc] of string=('PI','e','Seno','Coseno','Tangente','ArcoSeno','ArcoCoseno','ArcoTangente',
                  'Logaritmo Neperiano','Log10','Raz Cuadrada','Cuadrado(x^2)','Cubo(x^3)','x^y');
type
  TCalc = class(TCustomPanel)
  private
     FButtons: array[0..24] of TSpeedButton;
     FEdit:TEdit;
     FOper1,
     FOper2,
     Foper3 : double;
     FOper,
     FOperA:char;
     FMemor:Double;
     FClear:Boolean;
     FFlat:Boolean;
     FDecimal:Integer;
     FExtended:boolean;
     FAncho:integer;
     FAlto:Integer;
     FError:Boolean;
     FPopupMenu:TPopupMenu;
     FEditReadOnly:boolean;
     FFont:TFont;
     FMenuItems:array[0..maxfunc] of TMenuItem;
     procedure WMSize(var Message: TWMSize); message WM_SIZE;
     Procedure CapClick(Sender: TObject);
//     Procedure CapKey(Sender: TObject; var Key: Char);
     Procedure SetEdit(value:TEdit);
     procedure SetFlat(Value:boolean);
     Procedure SetExtended(Value:Boolean);
     procedure ClickButton(Sender: TObject);
     procedure ClickMenuItem(Sender: TObject);
     procedure FontChanged(AFont: TObject);
     procedure SetDecimal(value:Integer);
     procedure SetMemor(value:Double);
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
  public
    constructor create(AOwner:TComponent);override;
    Destructor Destroy;override;
    Property Memory:Double read FMemor write SetMemor;
  published
     property Edit:TEdit read fedit write SetEdit;
     Property Flat:Boolean read FFlat write SetFlat;
     property Decimal:Integer read FDecimal write SetDecimal;
     property Extended:Boolean read FExtended write SetExtended;
     property Font:TFont read FFont write FFont;
     property Color;
     property Width;
     property Height;
     Property Visible;
     Property Enabled;
//     property TabStop;
  end;

implementation

constructor TCalc.create(AOwner:TComponent);
var
   cont:integer;
   ancho,alto:integer;
begin
    inherited create(AOwner);
//    OnKeyPress:=CapKey;
    FOper:='+';
    FOperA:=' ';
    FOper1:=0;
    FOper2:=0;
    FOper3:=0;
    FMemor:=0;
    FClear:=false;
    FFlat:=false;
    FExtended:=false;
    FEditReadOnly:=false;
    FAncho:=6;
    FAlto:=4;
    ancho:=width div FAncho;
    alto:=height div FAlto;
    width:=ancho*6;
    height:=alto*5;
    FDecimal:=2;
    Ferror:=false;
    FPopupMenu:=tpopupmenu.Create(self);
    FPopupMenu.AutoPopup:=false;
    FFont:=tfont.Create;
    FFont.OnChange:=FontChanged;
    For cont:=0 to maxfunc do
    begin
       FMenuItems[cont]:=tmenuitem.Create(self);
       FMenuItems[cont].OnClick:=ClickMenuItem;
       FMenuItems[cont].Caption:=bfunccap[cont];
       FPopupmenu.Items.Add(FMenuItems[cont]);
    end;
    FPopupmenu.Items[2].Break:=mbBarBreak;
    FPopupmenu.Items[8].Break:=mbBarBreak;
    for cont:=0 to 24 do
    begin
       FButtons[cont]:=TSpeedButton.Create(self);
       FButtons[cont].Parent:=self;
       FButtons[cont].ParentFont:=false;
       FButtons[cont].Left:=(cont mod 6)*ancho;
       FButtons[cont].top:=(cont div 6)*alto;
       FButtons[cont].Width:=ancho;
       FButtons[cont].Height:=alto;
       FButtons[cont].Caption:=bcaptions[cont];
       FButtons[cont].OnClick:=CapClick;
//       FButtons[cont].OnKeyPress:=CapKey;
       FButtons[cont].Flat:=FFlat;
       if cont=24 then
       begin
          FButtons[cont].Onclick:=clickbutton;
          FButtons[cont].Width:=Width;
          FButtons[cont].PopupMenu:=fpopupmenu;
          if fExtended then
             FButtons[cont].Visible:=true;
       end;
       if btypes[cont]=1 then
          FButtons[cont].Font.color:=clblack
       else
          FButtons[cont].Font.Color:=clRed;
    end;

    FButtons[6].ShowHint:=true;
    FButtons[6].Hint:=floattostr(roundto(FMemor,-fdecimal));
    self.Caption:='';
end;
destructor TCalc.destroy;
var
   cont:integer;
begin
   for cont:=0 to 24 do
      fbuttons[cont].Free;
   fpopupmenu.Items.Clear;
   fpopupmenu.Free;
   inherited;
end;
procedure TCalc.WMSize(var Message: TWMSize);
var
   cont:integer;
   ancho,alto:integer;
begin
    inherited;
    ancho:=width div FAncho;
    alto:=height div FAlto;
    width:=ancho*FAncho;
    height:=alto*FAlto;
    for cont:=0 to 24 do
    begin
       FButtons[cont].Left:=(cont mod 6)*ancho;
       FButtons[cont].top:=(cont div 6)*alto;
       FButtons[cont].Width:=ancho;
       FButtons[cont].Height:=alto;
    end;
    FButtons[24].Width:=Width;
end;
Procedure TCalc.CapClick(Sender: TObject);
   procedure Operation;
   begin
   try
      case foper of
         '+': Foper1:=roundto(Foper1+FOper2,-fdecimal);
         '-': FOper1:=roundto(Foper1-FOper2,-fdecimal);
         '*': FOper1:=roundto(Foper1*FOper2,-fdecimal);
         '/': FOper1:=roundto(Foper1/FOper2,-fdecimal);
         '^': begin
                FOper2:=roundto(Power(Foper3,FOper2),-fdecimal);
                FOper:=FOperA;
                case foper of
                  '+': Foper1:=roundto(Foper1+FOper2,-fdecimal);
                  '-': FOper1:=roundto(Foper1-FOper2,-fdecimal);
                  '*': FOper1:=roundto(Foper1*FOper2,-fdecimal);
                  '/': FOper1:=roundto(Foper1/FOper2,-fdecimal);
                end;
                FOper3:=0;
                FOperA:=' ';
              end;
      END;
   except
      on exception do
      begin
         showmessage('Error en la operacin');
         FOper1:=0;
         FOper2:=0;
         FOper:='+';
      end;
   end;
   end;
   procedure OperationM;
   begin
       case tspeedbutton(sender).Caption[2] of
         '+':FMemor:=roundto(FMemor+StrToFloat(Fedit.Text),-fdecimal);
         '-':FMemor:=roundto(FMemor-StrToFloat(Fedit.Text),-fdecimal);
         'C':FMemor:=0;
         'R':Fedit.Text:=Floattostr(FMemor);
       end;
       FButtons[6].Hint:=floattostr(roundto(FMemor,-fdecimal));
   end;
begin
   if tspeedbutton(sender).Caption[1] in bnumbers then
   begin
      if assigned(fedit) then
      begin
         if tspeedbutton(sender).Caption='' then
            Fedit.Text:=floattostr(-strtofloat(Fedit.Text))
         else
         begin
            if fClear then
            begin
              fedit.Text:='';
              FClear:=false;
            end;
            if fedit.Text='0' then
               fedit.Text:=iif(tspeedbutton(sender).Caption=',',fedit.Text+decimalseparator,tspeedbutton(sender).Caption)
            else
            begin
               fedit.Text:=fedit.Text+iif(tspeedbutton(sender).Caption=',',iif(pos(decimalseparator,fedit.Text)=0,decimalseparator,''),tspeedbutton(sender).Caption);
            end;
         end;
      end;
   end
   else
      if tspeedbutton(sender).Caption[1] in boperations then
      begin
         if tspeedbutton(sender).Caption[1]<>'M' then
         begin
            if tspeedbutton(sender).Caption[1]<>'%' then
            begin
              FOper2:=roundto(StrToFloat(Fedit.Text),-fdecimal);
              Operation;
              if tspeedbutton(sender).Caption[1]='=' then
              begin
                 FOper:='+';
                 FOper2:=FOper1;
                 FOper1:=0;
                 fedit.Text:=floattostr(FOper2);
              end
              else
              begin
                 FOper:=tspeedbutton(sender).Caption[1];
                 fedit.Text:=floattostr(FOper1);
              end;
            end
            else
               try
                  Fedit.Text:=floattostr(roundto(FOper1*strtofloat(Fedit.Text)/100,-fdecimal));
               except
                  on exception do
                  begin
                     showmessage('Error en la operacin');
                     FOper1:=0;
                     FOper2:=0;
                     FOper:='+';
                  end;
               end;
         end
         else
         begin
            OperationM;
         end;
         FClear:=true;
      end
      else
      if tspeedbutton(sender).Caption='C' then
      begin
         fedit.Text:='0';
      end
      else
        if tspeedbutton(sender).Caption='CE' then
        begin
           FOPER1:=0;
           FOPER2:=0;
           FOper:='+';
           fedit.Text:='0';
        end;
end;
procedure TCalc.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then //and (Acomponent.ClassName='TEdit') then
     if (Fedit <> nil) and (acomponent.Name=fedit.Name) then
        Fedit := nil;
end;
(*procedure TCalc.CapKey(Sender:TObject;var Key: Char);
var
   SP:TSpeedButton;
begin
   try
      SP:=TSpeedButton.Create(self);
      SP.Caption:=Key;
      CapClick(SP);
      SP.Free;
   finally
       Key:=#0;
   end;
end;
*)
procedure TCalc.SetEdit(value:TEdit);
begin
   if assigned(value) then
   begin
     FOper1:=0;
     FOper2:=0;
     FOper:='+';
     FClear:=false;
     if assigned(fedit) then
     begin
        if (value.Name<>fedit.Name) then
        begin
           fedit.ReadOnly:=feditreadonly;
           fedit:=value;
           feditreadonly:=fedit.ReadOnly;
           if Fedit.Text<>'' then
             try
                Fedit.Text:=floattostr(roundto(strtofloat(Fedit.Text),-fdecimal));
             except
                on exception do
                  fedit.Text:='0';
             end
           else
              fedit.Text:='0';
        end;
     end
     else
     begin
        fedit:=value;
        feditreadonly:=fedit.ReadOnly;
        fedit.ReadOnly:=true;
        try
           Fedit.Text:=floattostr(roundto(strtofloat(Fedit.Text),-fdecimal));
        except
           on exception do
              fedit.Text:='0';
        end;
     end
   end
   else
      if assigned(fedit) then
      begin
         fedit.ReadOnly:=feditreadonly;
         fedit:=nil;
      end;
end;
procedure TCalc.SetFlat(Value:boolean);
var
   cont: integer;
begin
   if value<>FFlat then
   begin
      FFlat:=Value;
      for cont:=0 to 24 do
         FButtons[cont].Flat:=FFlat;
   end;
end;
procedure TCalc.Clickbutton(Sender: TObject);
var t:TPoint;
begin
   t.X:=FButtons[24].left;
   t.Y:=FButtons[24].top;
   t:= clienttoscreen(t);
   FButtons[24].PopupMenu.popup(t.X,t.Y);
end;
procedure TCalc.ClickMenuItem(Sender: TObject);
begin
   try
   case bfunc[tmenuitem(sender).menuindex] of
      bfSqrt  :Fedit.Text:=floattostr(roundto(sqrt(strtofloat(Fedit.Text)),-fdecimal));
      bfSin   :Fedit.Text:=floattostr(roundto(sin(strtofloat(Fedit.Text)),-fdecimal));
      bfCos   :Fedit.Text:=floattostr(roundto(cos(strtofloat(Fedit.Text)),-fdecimal));
      bfTan   :Fedit.Text:=floattostr(roundto(tan(strtofloat(Fedit.Text)),-fdecimal));
      bfArcSin:Fedit.Text:=floattostr(roundto(arcsin(strtofloat(Fedit.Text)),-fdecimal));
      bfArcCos:Fedit.Text:=floattostr(roundto(arccos(strtofloat(Fedit.Text)),-fdecimal));
      bfArcTan:Fedit.Text:=floattostr(roundto(arctan(strtofloat(Fedit.Text)),-fdecimal));
      bfLn    :Fedit.Text:=floattostr(roundto(ln(strtofloat(Fedit.Text)),-fdecimal));
      bfLog10 :Fedit.Text:=floattostr(roundto(log10(strtofloat(Fedit.Text)),-fdecimal));
      bfPI    :Fedit.Text:=floattostr(roundto(pi,-fdecimal));
      bfE     :Fedit.Text:=floattostr(roundto(Exp(1.0),-fdecimal));
      bf2     :Fedit.Text:=floattostr(roundto(Power(strtofloat(Fedit.Text),2),-fdecimal));
      bf3     :Fedit.Text:=floattostr(roundto(Power(strtofloat(Fedit.Text),3),-fdecimal));
      bfx     :begin
                  FOperA:=Foper;
                  Foper:='^';
                  FOper3:=roundto(strtofloat(Fedit.Text),-fdecimal);
               end;
   end;
   except
      on exception do
      begin
         showmessage('Error en la operacin');
         FOper1:=0;
         FOper2:=0;
         FOper:='+';
      end;
   end;
   fClear:=true;
end;
Procedure TCalc.SetExtended(Value:Boolean);
var
   cont:integer;
   ancho,alto:integer;
begin
   if FExtended<>value then
   begin
      FExtended:=value;
      if FExtended then
         falto:=falto+1
      else
         falto:=falto-1;
    ancho:=width div FAncho;
    alto:=height div FAlto;
    width:=ancho*FAncho;
    height:=alto*FAlto;
    for cont:=0 to 24 do
    begin
       FButtons[cont].Left:=(cont mod 6)*ancho;
       FButtons[cont].top:=(cont div 6)*alto;
       FButtons[cont].Width:=ancho;
       FButtons[cont].Height:=alto;
       if (cont=24) and fExtended then
       begin
          fbuttons[24].Visible:=true;
          FButtons[cont].Width:=Width;
       end
       else
          fbuttons[24].Visible:=false;
    end;
   end;
end;
procedure TCalc.FontChanged(AFont: TObject);
var
   cont: integer;
begin
   fFont.assign(tfont(Afont));
   for cont:=0 to 24 do
   begin
      FButtons[cont].Font:=tfont(AFont);
      if btypes[cont]=1 then
         FButtons[cont].Font.color:=clblack
      else
         FButtons[cont].Font.Color:=clRed;
   end;
end;
procedure TCalc.SetDecimal(value:Integer);
begin
   if (FDecimal<>value) and (value>=0) and (value<=10) then
      FDecimal:=value;
end;
procedure TCalc.SetMemor(value:Double);
begin
   fmemor:=value;
   FButtons[6].Hint:=floattostr(roundto(FMemor,-fdecimal));
end;
end.
