unit CheckBoxEnable;

interface

uses
  Windows,dialogs, Messages, SysUtils, Classes, Controls, StdCtrls,funciones;

type
  TCheckBoxEnable = class(TCustomCheckBox)
  private
     FControls:TControls;
     FSelfDisable:Boolean;
    { Private declarations }
  protected
      procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
      procedure Click; override;
    { Protected declarations }
  public
     constructor Create(Aowner:TComponent);override;
     Destructor Destroy;override;
    { Public declarations }
  published
    property Controls:TControls read FControls write FControls;
    property SelfDisable:Boolean read FSelfDisable write FSelfDisable default false;
    property Action;
    property Alignment;
    property AllowGrayed;
    property Anchors;
    property BiDiMode;
    property Caption;
    property Checked;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property State;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Published declarations }
  end;
procedure Register;

implementation

constructor TCheckBoxEnable.Create(Aowner:TComponent);
begin
   inherited;
   Width:=121;
   FSelfDisable:=False;
   FControls:=TControls.Create(self);
end;
Destructor TCheckBoxEnable.Destroy;
begin
   FControls.Clear;
   FControls.Free;
   inherited;
end;
procedure TCheckBoxEnable.Notification(AComponent: TComponent;
  Operation: TOperation);
var
   i:integer;
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
     for i:=0 to Fcontrols.Count-1 do
        if assigned(Fcontrols[i].Control) and (acomponent.Name=Fcontrols[i].Control.Name) then
        begin
           FControls.Delete(i);
           break;
        end;
end;
procedure TCheckBoxEnable.Click;
var
   i:integer;
begin
  inherited;
  for i:=0 to FControls.Count-1 do
     if assigned(FControls[i].Control) then
        if (FControls[i].Control.Name=self.Name) then
        begin
           if FSelfDisable then
              Enabled:=checked;
        end
        else
           FControls[i].Control.Enabled:=checked;
end;

procedure Register;
begin
  RegisterComponents('i-griegavcl', [TCheckBoxEnable]);
end;

end.
