unit CheckBoxOnOff;

interface

uses
  Windows,dialogs, Messages, SysUtils, Classes, Controls, StdCtrls,funciones,typinfo;
const
  PropValStrings:Array[0..15] of string=('Enabled','Visible','AutoScroll','DockSite',
                                      'Scaled','ShowHint','TabStop','ReadOnly',
                                      'ParentColor','ParentFont','OEMConvert',
                                      'Other','ParentCtl3D','Checked','Ctl3D',
                                      'ParentShowHint');
type
  TPropVal=(Enabled,Visible,AutoScroll,DockSite,Scaled,ShowHint,TabStop,ReadOnly,ParentColor,ParentFont,
            OEMConvert,Other,ParentCtl3D,Checked,Ctl3D,ParentShowHint);
  TCheckBoxOnOff = class(TCustomCheckBox)
  private
     FControls:TControls;
     FSelfDisable:Boolean;
     FPropVal:TPropVal;
     FOtherVal:String;
    { Private declarations }
  protected
      procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
      procedure Click; override;
    { Protected declarations }
  public
     constructor Create(Aowner:TComponent);override;
     Destructor Destroy;override;
    { Public declarations }
  published
    property Controls:TControls read FControls write FControls;
    property SelfDisable:Boolean read FSelfDisable write FSelfDisable default false;
    property PropVal:TPropVal read FPropVal write FPropVal default Other;
    property OtherVal:String read FOtherVal write FOtherVal;
    property Action;
    property Alignment;
    property AllowGrayed;
    property Anchors;
    property BiDiMode;
    property Caption;
    property Checked;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property State;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Published declarations }
  end;
procedure Register;

implementation

constructor TCheckBoxOnOff.Create(Aowner:TComponent);
begin
   inherited;
   Width:=121;
   FSelfDisable:=False;
   FControls:=TControls.Create(self);
   FPropVal:=Other;
   FOtherVal:='Enabled';
end;
Destructor TCheckBoxOnOff.Destroy;
begin
   FControls.Clear;
   FControls.Free;
   inherited;
end;
procedure TCheckBoxOnOff.Notification(AComponent: TComponent;
  Operation: TOperation);
var
   i:integer;
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
     for i:=0 to Fcontrols.Count-1 do
        if assigned(Fcontrols[i].Control) and (acomponent.Name=Fcontrols[i].Control.Name) then
        begin
           FControls.Delete(i);
           break;
        end;
end;
procedure TCheckBoxOnOff.Click;
var
   i:integer;
   v:string;
   vchecked:string;
begin
  inherited;
  vchecked:=iif(checked,'True','False');
  if fpropval=Other then
     v:=FOtherval
  else
     v:=propvalstrings[ord(fpropval)];
  for i:=0 to FControls.Count-1 do
     if assigned(FControls[i].Control) then
      if GetPropInfo(FControls[i].Control,v)<>nil then
        if (FControls[i].Control.Name=self.Name) then
        begin
              try
                 if FSelfDisable then
                    SetEnumProp(self, v, vchecked);
              except
              end;
        end
        else
           try
              SetEnumProp(FControls[i].Control, v, vchecked);
           except
           end;
end;

procedure Register;
begin
  RegisterComponents('i-griegavcl', [TCheckBoxOnOff]);
end;

end.
