unit DBDispanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, DisPanel,DB,DBTables,DBCtrls;

type
  TDBDispanel = class(TCustomDisPanel)
  private
     FDataLink:TFieldDataLink;
     FDefaultText:String;
     Function GetDataField:string;
     Procedure SetDataField(const Value:string);
     Function GetDataSource:TDataSource;
     procedure SetDataSource(Value:TDataSource);
     Procedure DataChange(Sender:TObject);
     Procedure SetDefaultText(Value : String);
     procedure CMGetDataLink(var Message: TMessage); message CM_GETDATALINK;
  protected
     Procedure Notification(AComponent:TComponent;Operation:TOperation); override;
  public
     Constructor Create(AOwner : TComponent);override;
     Destructor Destroy;override;
  published
     Property DataField : String read GetDataField write SetDataField;
     Property Datasource : TDataSource read GetDataSource write SetDataSource;
     property DefaultText:String read FDefaultText write SetDefaultText;
     property Alignment;
     property TextAlign;
     property PictureVAlign;
     property Color;
     Property BorderSides;
     property BorderColor;
     property GradColor;
     property Bevel;
     property Border;
     property BorderWidth;
     property Picture;
     property PosXPicture;
     property PosXText;
     property Gradient;
     Property GradDirection;
     property Caption;
     property TextFont;
     property WordWrap;
     property BiDiMode;
     property Action;
     property Align;
     property Anchors;
     property Visible;
     property Enabled;
     property Constraints;
     property DragCursor;
     property DragKind;
     property DragMode;
     property Font;
     property ParentBiDiMode;
     property ParentFont;
     property ParentShowHint;
     property PopupMenu;
     property ShowHint;
     property OnClick;
     property OnContextPopup;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEndDock;
     property OnEndDrag;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnStartDock;
     property OnStartDrag;
  end;

procedure Register;

implementation
constructor TDBDispanel.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   ControlStyle:=controlStyle-[csReplicatable];
   FDataLink:=TFieldDataLink.Create;
   FDataLink.OnDataChange:=DataChange;
end;
destructor TDBDispanel.destroy;
begin
   FDataLink.Free;
   FDataLink:=nil;
   inherited Destroy;
end;
function TDBDispanel.GetDataField:String;
begin
   Result:=FDataLink.FieldName;
end;
procedure TDBDispanel.SetDataField(const value:string);
begin
   FDataLink.FieldName:=Value;
end;
function TDBDispanel.GetDataSource:TDataSource;
begin
   Result:=FDataLink.DataSource;
end;
Procedure TDBDispanel.SetDataSource(value:tdatasource);
begin
   if FDataLink.DataSource<>Value then
   begin
      FDataLink.DataSource:=Value;
      If Value<>nil then
         Value.FreeNotification(self);
   end;
end;
Procedure TDBDispanel.Notification(AComponent:TComponent;Operation:TOperation);
begin
   inherited Notification(Acomponent,Operation);
   if (Operation=opRemove) AND (FDataLink<>nil) and (AComponent=DataSource) then
      DataSource:=nil;
end;
Procedure TDBDispanel.DataChange(Sender : TObject);
begin
   if FDataLink.Field=nil then
      Text:=DefaultText
   else
      Text:=FDataLink.Field.Asstring;
end;
Procedure TDBDispanel.SetDefaultText(Value : String);
begin
   if FDefaultText<>Value then
   begin
      FDefaultText:=Value;
      if FDataLink.Field=nil then
         Text:=FDefaultText;
   end;
end;
procedure TDBDispanel.CMGetDataLink(var Message: TMessage);
begin
  Message.Result := Integer(FDataLink);
end;
//----------------------------------
procedure Register;
begin
  RegisterComponents('i-vcl DB', [TDBDispanel]);
end;

end.
