unit DBEditB;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Mask, buttons,DBCtrls,Graphics,editbdefs;

type
  TCustomDBEditb = class(TDBEdit)
  private
     FButton:TSpeedButton;
     FOnButtonClick : TOnButtonClick;
     FWidthButton:Integer;
     FSide:TSide;
     FAlignment: TAlignment;
     FButtonType:TEditButtons;
     procedure SetEditRect;
     procedure ClickButton(Sender: TObject);
     procedure SetTextButton(value: TCaption);
     Function GetTextButton:TCaption;
     procedure SetWidthButton(value: Integer);
     procedure SetImageButton(value:TBitmap);
     Function GetImageButton:TBitmap;
     Procedure SetFlatButton(value:boolean);
     Function GetFlatButton:boolean;
     Function GetTransButton:Boolean;
     Procedure SetTransButton(Value:Boolean);
     procedure SetFontButton(value:TFont);
     Function GetFontButton:TFont;
     Procedure SetSide(Value:TSide);
     Procedure SetAlignment(value:TAlignment);
     procedure SetButtonType(value:TEditButtons);
     procedure WMSize(var Message: TWMSize); message WM_SIZE;
     procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    { Private declarations }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    property OnButtonClick : TOnButtonClick read FOnButtonClick write FOnButtonClick;
    property TextButton :TCaption read GetTextButton write setTextButton;
    property WidthButton:integer read FWidthButton write SetWidthButton;
    property ImageButton:TBitmap read GetImageButton write SetImageButton;
    property FlatButton:Boolean read GetFlatButton write SetFlatButton;
    property TransparentButton:Boolean read GetTransButton write SetTransButton;
    property FontButton:TFont read GetFontButton write SetFontButton;
    property Side:TSide read FSide write SetSide default sbRight;
    property Alignment: TAlignment read FAlignment write SetAlignment;
    Property ReadOnly;
    Property ButtonType:TEditButtons read FButtonType write SetButtonType;
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  published
    { Published declarations }
  end;

  TDBEditB = class(TCustomDBEditb)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DataField;
    property DataSource;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property OnButtonClick;
    property TextButton;
    property WidthButton;
    property ImageButton;
    property FlatButton;
    property TransparentButton;
    property FontButton;
    property Side;
    property Alignment;

    { Published declarations }
  end;

procedure Register;

implementation
constructor TCustomDBEditb.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FAlignment:=taLeftJustify;
  fbutton:=TSpeedButton.Create(self);
  FButton.Width := 15;
  FButton.Height := Height-2;
  FButton.Top:=1;
  FButton.Left:=1;
  FButton.Visible := True;
  FButton.Parent := Self;
  fbutton.OnClick:=clickbutton;
  fbutton.Flat:=true;
  fbutton.Transparent:=false;
  fbutton.Cursor:=crArrow;
  FSide:=sbRight;
  FWidthButton:=trunc((fbutton.Width*100/width));
  Fbuttontype:=ebNone;
end;
destructor TCustomDBEditb.Destroy;
begin
   fbutton.Free;
   inherited;
end;
procedure TCustomDBEditb.SetButtonType(value:TEditButtons);
var
  tmpimage:TBitmap;
begin
 if FButtonType<>value then
   if Value<>ebNone then
   begin
      tmpimage:=TBitmap.Create;
      try
        tmpimage.Handle:=LoadBitmap(hinstance,
                                 pchar(EditButtonsNames[ord(value)-1]));
        self.ImageButton.Assign(tmpimage);
        DeleteObject(tmpimage.Handle);
      finally
        tmpimage.Free;
      end;
      FButtonType:=Value;
   end
   else
   begin
      FButtonType:=ebNone;
      self.ImageButton:=nil;
   end;
end;
procedure TCustomDBEditb.Clickbutton(sender:tobject);
begin
   if assigned(fonbuttonclick) then
   begin
      fonbuttonclick(sender);
   end;
   fbutton.Parent.SetFocus;
end;
procedure TCustomDBEditb.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN or ES_MULTILINE  or AlignText[FAlignment] or ES_AUTOHSCROLL;
end;
procedure TCustomDBEditb.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

procedure TCustomDBEditb.SetEditRect;
var
  Loc: TRect;
begin
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));
  if fside=sbLeft then
  begin
     Loc.Bottom := ClientHeight + 1;
     Loc.Right := ClientWidth - 2;
     Loc.Top := 0;
     Loc.Left := FButton.Width + 2;
  end
  else
  begin
     Loc.Bottom := ClientHeight + 1;
     Loc.Right := ClientWidth - 2 - fbutton.Width;
     Loc.Top := 0;
     Loc.Left := 0;
  end;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;
procedure TCustomDBEditb.WMSize(var Message: TWMSize);
begin
  inherited;
  SetWidthButton(FWidthButton);
  if ctl3d then
     fbutton.Height:=height-5
  else
     fbutton.Height:=height-2;
  SetEditRect;
end;
procedure TCustomDBEditb.WMPaint(var Message: TWMPaint);
begin
  if FSide=sbLeft then
     fbutton.Left:=1
  else
     fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
  SetWidthButton(FWidthButton);
  if ctl3d then
     fbutton.Height:=height-5
  else
     fbutton.Height:=height-2;
  SetEditRect;
  inherited;  
end;
procedure TCustomDBEditb.SetTextButton(value:TCaption);
begin
   if value<>fbutton.Caption then
      fbutton.caption:=value;
end;
Function TCustomDBEditb.GetTextButton:TCaption;
begin
   result:=fbutton.caption;
end;
procedure TCustomDBEditb.SetWidthButton(value: Integer);
var
   n:integer;
begin
   if (value>0) and (value<75) then
   begin
      fWidthButton:=value;
      n:=trunc((width*value)/100);
      if (n<>FButton.Width) then
      begin
         fbutton.Width:=n;
         if FSide=sbLeft then
            fbutton.Left:=1
         else
            fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
      end;
   end;
   SetEditRect;
   self.Invalidate;
end;
procedure TCustomDBEditb.SetImageButton(value:TBitmap);
begin
   fbutton.Glyph.Assign(value);
   fbutton.NumGlyphs:=1;
   fbutton.Invalidate;
end;
Function TCustomDBEditb.GetImageButton:TBitmap;
begin
   result:= fbutton.Glyph;
end;
Procedure TCustomDBEditb.SetFlatButton(value:boolean);
begin
   if value<>fbutton.Flat then
   begin
      fbutton.Flat:=value;
      fbutton.Invalidate;
   end;
end;
Function TCustomDBEditb.GetFlatButton:boolean;
begin
   result:=fbutton.flat;
end;
Function TCustomDBEditb.GetTransButton:Boolean;
begin
   result:=fbutton.transparent;
end;
Procedure TCustomDBEditb.SetTransButton(Value:Boolean);
begin
   if value<>fbutton.transparent then
   begin
      fbutton.Transparent:=value;
      fbutton.Invalidate;
   end;
end;
procedure TCustomDBEditb.SetFontButton(value:TFont);
begin
   fbutton.Font.Assign(value);
   fbutton.Invalidate;
end;
Function TCustomDBEditb.GetFontButton:TFont;
begin
   result:=fbutton.Font;
end;
Procedure TCustomDBEditb.SetSide(Value:TSide);
begin
   if fside<>value then
   begin
      fside:=value;
      if value=sbLeft then
         fbutton.Left:=1
      else
         fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
      invalidate;
      SetEditRect;
   end;
end;
Procedure TCustomDBEditb.SetAlignment(value:TAlignment);
begin
   if FAlignment<>value then
   begin
      FAlignment:=value;
      ReCreateWnd;
   end;
end;
procedure Register;
begin
  RegisterComponents('i-vcl DB', [TDBEditB]);
end;

end.
