unit DBImageclick;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ExtCtrls,imglist,DB,DBTables,DBCtrls,ImageClick;

type
  TDBimageClick=Class(TImageClick)
  private
     FDataLink:TFieldDataLink;
     FReadOnly:Boolean;
     Function GetDataField:string;
     Procedure SetDataField(const Value:string);
     Function GetDataSource:TDataSource;
     procedure SetDataSource(Value:TDataSource);
     Procedure UpdateData(Sender:TObject);
     Procedure DataChange(Sender:TObject);
     procedure CMGetDataLink(var Message: TMessage); message CM_GETDATALINK;     
  protected
     Procedure Notification(AComponent:TComponent;Operation:TOperation); override;
     procedure SetSelected(Value:integer);override;
     Procedure Click; override;
  public
     Constructor Create(AOwner : TComponent);override;
     Destructor Destroy;override;
  published
     Property ReadOnly : Boolean read FReadOnly write FReadOnly default False;
     Property DataField : String read GetDataField write SetDataField;
     Property Datasource : TDataSource read GetDataSource write SetDataSource;
  end;
Implementation
//---------------------------------
constructor TDBImageClick.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   ControlStyle:=controlStyle-[csReplicatable];
   FReadOnly:=False;
   FDataLink:=TFieldDataLink.Create;
   FDataLink.OnDataChange:=DataChange;
   FDataLink.OnUpdateData:=UpdateData;
end;
destructor TDBImageClick.destroy;
begin
   FDataLink.Free;
   FDataLink:=nil;
   inherited Destroy;
end;
function TDBImageClick.GetDataField:String;
begin
   Result:=FDataLink.FieldName;
end;
procedure TDBImageClick.SetDataField(const value:string);
begin
   FDataLink.FieldName:=Value;
end;
function TDBImageClick.GetDataSource:TDataSource;
begin
   Result:=FDataLink.DataSource;
end;
Procedure TDBImageClick.SetDataSource(value:tdatasource);
begin
   if FDataLink.DataSource<>Value then
   begin
      FDataLink.DataSource:=Value;
      If Value<>nil then
         Value.FreeNotification(self);
   end;
end;
Procedure TDBImageClick.Notification(AComponent:TComponent;Operation:TOperation);
begin
   inherited Notification(Acomponent,Operation);
   if (Operation=opRemove) AND (FDataLink<>nil) and (AComponent=DataSource) then
      DataSource:=nil;
end;
Procedure TDBImageClick.DataChange(Sender : TObject);
begin
   if FDataLink.Field=nil then
      Selected:=0
   else
      Selected:=FDataLink.Field.AsInteger;
end;
Procedure TDBImageClick.UpdateData(Sender : TObject);
begin
   FdataLink.Field.AsInteger:=Selected;
end;
Procedure TDBImageClick.SetSelected(Value:integer);
begin
   if (csDesigning in ComponentState) or (FDataLink=nil)  then
      exit
   else
      begin
         inherited;
         if not FReadOnly then
            FDataLink.Modified;
      end;
end;
Procedure TDBImageClick.Click;
begin
   if (csDesigning in ComponentState)  or FReadOnly or (FDataLink=nil) or (not fdatalink.Edit) then
      exit
   else
   begin
      inherited;
      FDataLink.Modified;
   end;
end;
procedure TDBImageClick.CMGetDataLink(var Message: TMessage);
begin
  Message.Result := Integer(FDataLink);
end;
//----------------------------------
end.
