unit DisPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,graphics,
  igriegastrs,igriegaclasses,funciones;

type
  TCustomDisPanel = class(TGraphicControl)
  private
     FColor:TColor;
     FGradColor:TColor;
     FBorder:Boolean;
     FBorderWidth:integer;
     FBorderColor:TColor;
     FBorderSides:TBorderLine;
     FPicture:TPicture;
     FPosXPicture:Integer;
     FPosXText:Integer;
     FText:TCaption;
     FTextFont:TFont;
     FAlignment,
     FTextAlign: TAlignment;
     FPictureVAlign:TVAlign;
     FBevel:TBoxBevel;
//     FFocusRect:Integer;
     FGrad:Boolean;
     FGradDir:TDirection;
     FWordWrap:Boolean;
     procedure SetBevel(Value:TBoxBevel);
     procedure SetColor(Value:TColor);
     procedure SetGradColor(Value:TColor);
     procedure SetBorderColor(Value:TColor);
     procedure SetBorder(Value:Boolean);
     procedure SetPicture(Value:TPicture);
     procedure SetBorderWidth(Value:integer);
     procedure SetPosXPicture(Value:Integer);
     procedure SetPosXText(Value:Integer);
     procedure SetText(Value:TCaption);
     procedure SetTextFont(Value:TFont);
     procedure FontChanged(Sender: TObject);
     procedure SetAlignment(Value: TAlignment);
     procedure SetTextAlign(Value: TAlignment);
     procedure SetGrad(Value:Boolean);
     procedure SetGradDir(Value:TDirection);
     procedure SetPictureVAlign(Value:TVAlign);
     procedure SetWordWrap(Value:Boolean);
     procedure CMBorderChanged(var Message: TMessage); message CM_BORDERCHANGED;
    { Private declarations }
  protected
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMBiDiModeChanged(var Message: TMessage); message CM_BIDIMODECHANGED;
    procedure Paint; override;
    { Protected declarations }
  public
     constructor Create(AOwner:TComponent);override;
     destructor Destroy;override;
    { Public declarations }
     property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
     property TextAlign: TAlignment read FTextAlign write SetTextAlign default taLeftJustify;
     property PictureVAlign:TVAlign read FPictureVAlign write SetPictureVAlign default vaMiddle;
     property Color:TColor read FColor Write SetColor default clWhite;
     Property BorderSides:TBorderLine read FBorderSides write FBorderSides;
     property BorderColor:TColor read FBorderColor Write SetBorderColor default clBlack;
     property GradColor:TColor read FGradColor Write SetGradColor default $0080FFFF;
     property Bevel:TBoxBevel read FBevel write SetBevel default bbNone;
     property Border:Boolean read FBorder Write SetBorder default False;
     property BorderWidth:integer read FBorderWidth Write SetBorderWidth default 1;
     property Picture:TPicture read FPicture Write SetPicture;
     property PosXPicture:Integer read FPosXPicture Write SetPosXPicture default 10;
     property PosXText:integer read FPosXText Write SetPosXText default 50;
     property Gradient:Boolean read FGrad write SetGrad default True;
     Property GradDirection:TDirection read FGradDir write SetGradDir default dVertical;
     property Text:TCaption read FText Write SetText;
     property TextFont:TFont read FTextFont Write SetTextFont;
     property WordWrap:Boolean read FWordWrap write SetWordWrap default true;

  published
    { Published declarations }
  end;
  TDispanel=Class(TCustomDisPanel)
  published
     property Alignment;
     property TextAlign;
     property PictureVAlign;
     property Color;
     Property BorderSides;
     property BorderColor;
     property GradColor;
     property Bevel;
     property Border;
     property BorderWidth;
     property Picture;
     property PosXPicture;
     property PosXText;
     property Gradient;
     Property GradDirection;
     property Caption;
     property Text;
     property TextFont;
     property WordWrap;
     property BiDiMode;
     property Action;
     property Align;
     property Anchors;
     property Visible;
     property Enabled;
     property Constraints;
     property DragCursor;
     property DragKind;
     property DragMode;
     property Font;
     property ParentBiDiMode;
     property ParentFont;
     property ParentShowHint;
     property PopupMenu;
     property ShowHint;
     property OnClick;
     property OnContextPopup;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEndDock;
     property OnEndDrag;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnStartDock;
     property OnStartDrag;
  end;
Function _BiDiMode(Alignment: TAlignment;BiDi:TBiDiMode):TAlignment;
procedure Register;

implementation

Function _BiDiMode(Alignment: TAlignment;BiDi:TBiDiMode):TAlignment;
begin
  Result :=Alignment;
  if (SysLocale.MiddleEast) and (BiDi= bdRightToLeft) then
  case Alignment of
    taLeftJustify:  Result := taRightJustify;
    taRightJustify: result := taLeftJustify;
  end;
end;
constructor TCustomDisPanel.Create(AOwner:TComponent);
begin
   inherited;
   FPicture:=TPicture.Create;
   Width:=160;
   FTextFont:=TFont.Create;
   FTextFont.OnChange:=FontChanged;
   FTextFont.Color:=$00505050;
   FTextFont.Style:=[fsBold];
   FColor:= clWhite;
   Visible:=True;
   Enabled:=True;
   ControlStyle:=[csSetCaption,csClickEvents,csCaptureMouse,csDoubleClicks,csReflector,csActionClient,csOpaque];
   FBorder:=False;
   FBorderWidth:=1;
   FPosXPicture:=10;
   FPosXText:=50;
   FText:='';
   Font.Style:=[fsBold];
   FAlignment:=taLeftJustify;
   FTextAlign:=taLeftJustify;
   FBevel:=bbNone;
//   FFocusRect:=0;
   FGradDir:=dVertical;
   FGrad:=True;;
   FGradColor:=$0080FFFF;
   FBorderSides:=TBorderLine.Create(Self);
   FPictureVAlign:=vaMiddle;
   FWordWrap:=True;
end;
destructor TCustomDisPanel.Destroy;
begin
   Picture.Free;
   FTextFont.Free;
   inherited;
end;
procedure TCustomDisPanel.SetWordWrap(Value:Boolean);
begin
   if FWordWrap<>value then
   begin
      FWordWrap:=Value;
      invalidate;
   end;
end;
procedure TCustomDisPanel.SetPictureVAlign(Value:TVAlign);
begin
   if FPictureVAlign<> value then
   begin
      FPictureVAlign:=Value;
      invalidate;
   end;
end;
procedure TCustomDisPanel.CMBorderChanged(var Message: TMessage);
begin
   inherited;
   invalidate;
end;

procedure TCustomDisPanel.SetBevel(Value:TBoxBevel);
begin
   if FBevel<>Value then
   begin
      FBevel:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetPicture(Value:TPicture);
begin
   FPicture.Assign(Value);
   repaint;
end;
procedure TCustomDisPanel.Paint;
   //----------------------------
   // Local Functions definition
   //----------------------------
   function deFLAGS:UINT;
   var
      tmp:UINT;
   begin
      tmp:=0;
      if BorderSides.top and BorderSides.Bottom and BorderSides.Right and BorderSides.Left then
         tmp:=BF_RECT
      else
      begin
         if BorderSides.Top then tmp:=tmp or BF_TOP;
         if BorderSides.Bottom then tmp:=tmp or BF_BOTTOM;
         if BorderSides.Right then tmp:=tmp or BF_RIGHT;
         if BorderSides.Left then tmp:=tmp or BF_LEFT;
      end;
      result:=tmp;
   end;
   procedure rectangleR(Ax0,Ay0,Ax1,Ay1:integer);
   begin
      with BorderSides do
         if top and Bottom and Right and Left then
            CANVAS.Rectangle(Ax0,Ay0,Ax1,Ay1)
         ELSE
         with canvas do
         begin
            MoveTo(Ax0,Ay0);
            if Top then LineTo(Ax1-1,Ay0)
            else MoveTo(Ax1-1,Ay0);
            if Right then LineTo(Ax1-1,Ay1-1)
            else MoveTo(Ax1-1,Ay1-1);
            if Bottom then LineTo(Ax0,Ay1-1)
            else MoveTo(Ax0,Ay1-1);
            if Left then LineTo(Ax0,Ay0);
         end;
   end;
   procedure DrawBorder;
   var   x,y,w,h:integer;
         R:TRect;
   begin
      with canvas do
      begin
         R:=clientrect;
         Pen.Width:=BorderWidth;
         Pen.Color:=BorderColor;
         X := r.Left+(Pen.Width div 2);
         Y := X;
         W := (r.Right-r.Left) - Pen.Width+1;
         H := (r.bottom-r.top) - Pen.Width+1;
         rectangleR(x,y,x+w,y+h);
      end;
   end;
   procedure Bevel(R:TRect;Bev:TBoxBevel);
   begin
      with canvas do
      case Bev of
         bbNone:DrawBorder;
         bbRaised: drawedge(Handle,R,BDR_RAISEDOUTER,BF_SOFT or deFLAGS);
         bbLowered:drawedge(Handle,R,BDR_SUNKENOUTER,BF_SOFT or deFLAGS);
         bbRaisedLine:drawedge(Handle,R,EDGE_BUMP,deFLAGS);
         bbLoweredLine:drawedge(Handle,R,EDGE_ETCHED,deFLAGS);
         bbEdgeBump:drawedge(Handle,R,EDGE_BUMP,BF_SOFT or deFLAGS);
         bbEdgeEtChed:drawedge(Handle,R,EDGE_ETCHED,BF_SOFT or deFLAGS);
      end
   end;
   //------------------------------------
   // End of local functions definitions
   //------------------------------------
const
   AAlignment : array[taLeftJustify..taCenter] of uchar=(DT_LEFT,DT_RIGHT,DT_CENTER);
var
   R:TRect;
   Flags:Integer;
   despvtop,desphLeft,
   despvbottom,desphRight:Integer;
   X, Y, W, H: Integer;
   BevelE:TBoxBevel;
   cgrad:TColor;
   c:TGradColors;
begin
   setlength(c,2);
   despvtop:=3;
   despvBottom:=3;
   DesphLeft:=0;
   DesphRight:=0;
   if border then
   begin
      if bordersides.Top then
         despvTop:=despvTop+BorderWidth;
      if bordersides.Bottom then
         despvBottom:=despvBottom+BorderWidth;
      if bordersides.Left then
         DesphLeft:=BorderWidth;
      if bordersides.Right then
         DesphRight:=BorderWidth;
   end;
   with Canvas do
   begin
      Font:=self.Font;
      Pen.Width:=BorderWidth;
      Pen.Color:=BorderColor;
      pen.Style:=psSolid;
      Bevele:=self.Bevel;
      Brush.Style:=bsSolid;
      Brush.Color:=Color;
      cgrad:=gradcolor;
      X := Pen.Width div 2;
      Y := X;
      W := Width - Pen.Width + 1;
      H := Height - Pen.Width +1;
      //---------------
      // Gradient
      //---------------
      if Gradient then
      begin
         c[0]:=CGrad;
         c[1]:=brush.Color;
         drawgradient(canvas,height,width,c,ord(GradDirection));
      end
      else
         FillRect(ClientRect);
      //-----------
      // Picture
      //-----------
      if Assigned(Picture.Graphic) then
      begin
         Picture.Graphic.Transparent:=True;
         if Picture.Graphic.ClassName='TBitmap' then
            Picture.Bitmap.TransparentMode:=tmAuto;
         Case PictureVAlign of
            vaMiddle:Draw(PosXPicture+desphleft,((Height-Picture.Graphic.Height) div 2),Picture.Graphic);
            vaTop:Draw(PosXPicture+desphleft,0+despvtop,Picture.Graphic);
            vaBottom:Draw(PosXPicture+desphleft,(Height-Picture.Graphic.Height-despvBottom),Picture.Graphic);
         end;
      end;
      //----------------
      // Texts
      //----------------
      setbkmode(Handle,TRANSPARENT);
      Flags:=AAlignment[_BiDiMode(Alignment,BiDiMode)] or DT_NOPREFIX or DT_END_ELLIPSIS;
      R:=Rect(posxText+desphleft,despvtop,width-desphRight,height-despvbottom);
      DrawText(Handle, PChar(Caption), -1, R, Flags);
      Flags:=iif(WordWrap ,DT_WORDBREAK,0) or AAlignment[_BiDiMode(TextAlign,BiDiMode)] or DT_NOPREFIX or DT_EDITCONTROL;
      R:=Rect(posxText+desphleft,TextHeight(Caption)+despvtop,width-desphRight,height-despvbottom);
      font:=TextFont;
      DrawText(Handle, PChar(Text), -1, R, Flags);
      Brush.Style:=bsClear;
      if Border then
         bevel(rect(x,y,x+w,y+h),Bevele);
   end;
end;

procedure TCustomDisPanel.CMBiDiModeChanged(var Message: TMessage);
begin
   inherited;
   if (SysLocale.MiddleEast) and (Message.wParam = 0) then Invalidate;
end;
procedure TCustomDisPanel.SetColor(Value:TColor);
begin
   if FColor<>Value then
   begin
      FColor:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetGradColor(Value:TColor);
begin
   if FGradColor<>Value then
   begin
      FGradColor:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetBorderColor(Value:TColor);
begin
   if FBorderColor<>Value then
   begin
      FBorderColor:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetBorder(Value:Boolean);
begin
   if FBorder<>Value then
   begin
      FBorder:=Value;
      Invalidate;
   end;
end;

procedure TCustomDisPanel.SetBorderWidth(Value:integer);
begin
   if FBorderWidth<>Value then
   begin
      if Value>0 then
         FBorderWidth:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetPosXPicture(Value:integer);
begin
   if FPosXPicture<>Value then
      if value>=0 then
      begin
         FPosXPicture:=Value;
         invalidate;
      end
      else
         if (csDesigning in ComponentState) then
            raise Exception.CreateResFmt(@SInvalidValueErrMsg,[sValuege0]);
end;
procedure TCustomDisPanel.SetPosXText(Value:Integer);
begin
   if FPosXText<>Value then
      if Value>0 then
      begin
         FPosXText:=Value;
         invalidate;
      end
      else
         if (csDesigning in ComponentState) then
            raise Exception.CreateResFmt(@SInvalidValueErrMsg,[sValuegt0]);

end;
procedure TCustomDisPanel.SetText(Value: TCaption);
begin
   if FText<>Value then
   begin
      FText:=Value;
      invalidate;
   end;
end;
procedure TCustomDisPanel.CMTextChanged(var Message: TMessage);
begin
   inherited;
   invalidate;
end;
procedure TCustomDisPanel.SetTextFont(Value:TFont);
begin
   FTextFont.Assign(Value);
end;
procedure TCustomDisPanel.FontChanged(Sender: TObject);
begin
   Invalidate;
end;
procedure TCustomDisPanel.SetAlignment(Value: TAlignment);
begin
   if FAlignment<>Value then
   begin
      FAlignment:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetTextAlign(Value: TAlignment);
begin
   if FTextAlign<>Value then
   begin
      FTextAlign:=Value;
      Invalidate;
   end;
end;
procedure TCustomDisPanel.SetGrad(Value:Boolean);
begin
   if FGrad<>Value then
   begin
      FGrad:=value;
      invalidate;
   end;
end;
procedure TCustomDisPanel.SetGradDir(Value:TDirection);
begin
   if FGradDir<>Value then
   begin
      FGradDir:=value;
      invalidate;
   end;
end;
procedure Register;
begin
  RegisterComponents('i-vcl Panels', [TDisPanel]);
end;

end.


