unit DlgCharMap;

interface

uses
  Windows, Messages, SysUtils, Classes,charmap,Graphics,forms,controls;

type
  TFontSet=(fsScreen,fsPrinter);
  TCharMapOpc=(cmoSource,cmoFonts);
  TCharMapOpcs=set of TCharMapOpc;
  TCharMapDialog = class(TComponent)
  private
    FReturnChar:Char;
    FFont:TFont;
    FPosition:TPosition;
    FOnClose,
    FOnShow:TNotifyEvent;
    FFontSet:TFontset;
    FOptions:TCharMapOpcs;
    { Private declarations }
  protected
    { Protected declarations }
  public
     constructor Create(Aowner:TComponent); override;
     Destructor Destroy; override;
     property ReturnChar:Char read FReturnChar;
     Function Execute:Boolean;
    { Public declarations }
  published
     property Font:TFont read FFont Write FFont;
     property Position:TPosition read FPosition Write FPosition;
     property OnShow:TNotifyEvent read FOnShow write FOnShow;
     property OnClose:TNotifyEvent read FOnClose write FOnClose;
     property Fontset:TFontSet read FFontset write FFontset default fsScreen;
     property Options:TCharMapOpcs read FOptions write FOptions default [cmoSource,cmoFonts];
    { Published declarations }
  end;

procedure Register;

implementation
Constructor tCharMapDialog.Create(Aowner:TComponent);
begin
   inherited;
   FFont:=Tfont.Create;
   FFontSet:=fsScreen;
   FOptions:=[cmoSource,cmoFonts]
end;
destructor tCharMapDialog.Destroy;
begin
   FFont.Free;
   FReturnChar:=' ';
   inherited;
end;
Function tCharMapDialog.Execute:Boolean;
Var
   F:TfrmCharMap;
begin
   if assigned(FOnShow) then
      FOnShow(self);
   f:=TfrmCharMap.Create(self);
   f.Position:=Position;
   F.pnlChar.Caption:=ReturnChar;
   if FontSet=fsScreen then
      F.rbPantalla.Checked:=true
   else
      F.rbImpresora.Checked:=true;
   if f.cbFonts.Items.IndexOf(Font.Name)<>-1 then
      f.cbFonts.ItemIndex:=f.cbFonts.Items.IndexOf(Font.Name)
   else
      f.cbFonts.ItemIndex:=0;
   f.grchar.Font.Name:=f.cbFonts.Items[f.cbFonts.ItemIndex];
   F.pnlChar.Font.Name:=f.cbFonts.Items[f.cbFonts.ItemIndex];
   if not(cmoSource in Options) then
   begin
      F.rbPantalla.Enabled:=false;
      f.rbImpresora.Enabled:=false;
   end
   else
   begin
      F.rbPantalla.Enabled:=true;
      f.rbImpresora.Enabled:=true;
   end;
   if not(cmoFonts in Options) then
      f.cbFonts.Enabled:=false
   else
      f.cbFonts.Enabled:=true;
   if f.ShowModal=mrok then
   begin
      font.Name:=f.cbFonts.Items[f.cbFonts.ItemIndex];
      if F.pnlChar.Caption<>'' then
         FReturnChar:=F.pnlChar.Caption[1]
      else
         FReturnChar:=' ';
      if F.rbPantalla.Checked then
         FontSet:=fsScreen
      else
         FontSet:=fsPrinter;
      result:=true;
   end
   else
      result:=false;
   if assigned(FOnClose) then
      FOnClose(self);
end;
procedure Register;
begin
  RegisterComponents('i-vcl Dialogs', [TCharMapDialog]);
end;

end.
