unit EditCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,graphics, StdCtrls, Editb,calcComp,math,editbdefs;

type
  TEditCalc = class(TCustomEditb)
  private
     FCalc:TCalc;
     FCalcExt:Boolean;
     FCalcFlat:Boolean;
     FCalcDec:Integer;
     FCalcColor:TColor;
     FMemor:Double;
     procedure SetDecimal(value:integer);
     procedure CMExit(var Message: TCMLostFocus); message CM_EXIT;
     procedure buttonclick(Sender: TObject);
     procedure SetCalcColor(value:TColor);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure KeyPress(var Key: Char);override;
  public
     constructor Create(AOwner: TComponent); override;
     procedure click;override;
  published
    property ButtonType;
    property CalcExt:Boolean Read FCalcExt write FCalcExt;
    property CalcFlat:Boolean read FCalcFlat write FCalcFlat;
    property CalcDec:integer read FCalcDec write SetDecimal;
    property CalcColor:TColor read FCalcColor write SetCalcColor;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property TextButton;
    property WidthButton;
    property ImageButton;
    property FlatButton;
    property TransparentButton;
    property FontButton;
    property Side;
  end;


implementation

constructor TEditCalc.Create(AOwner: TComponent);
{var
  tmpimage:TBitmap;}
begin
   inherited;
   OnButtonClick:=buttonclick;
   FCalcExt:=false;
   FCalcDec:=2;
   FCalcFlat:=true;
   Text:='0';
   FMemor:=0;
   FCalcColor:=clBtnFace;
   ButtonType:=ebCalculator;
{   tmpimage:=TBitmap.Create;
    try
      tmpimage.Handle:=LoadBitmap( 0,
                                 makeintresource(OBM_COMBO) );
      self.ImageButton.Assign(tmpimage);
      DeleteObject(tmpimage.Handle);
    finally
      tmpimage.Free;
    end;}
end;
procedure TEditCalc.buttonclick(Sender: TObject);
begin
   if assigned(fcalc) then
   begin
      FMemor:=fcalc.Memory;
      fcalc.Edit:=nil;
      fcalc.Free;
      fcalc:=nil;
   end
   else
   begin
      fcalc:=tcalc.create(self);
      fcalc.Top:=top+height+1;
      fcalc.Left:=left;
      FCalc.Flat:=true;
      FCalc.Color:=FCalcColor;
      fcalc.Width:=max(width,100);
      fcalc.Height:=120;
      fcalc.Parent:=Parent;
      fcalc.Visible:=true;
      fcalc.Extended:=FCalcExt;
      fcalc.Flat:=FCalcFlat;
      FCalc.Decimal:=FCalcDec;
      fcalc.Edit:=tedit(self);
      FCalc.Memory:=fMemor;
   end;
end;
procedure TEditCalc.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN or ES_MULTILINE  or ES_RIGHT;
end;

procedure TEditCalc.click;
begin
   if assigned(fcalc) then
   begin
      FMemor:=fcalc.Memory;
      fcalc.Edit:=nil;
      fcalc.Free;
      fcalc:=nil;
   end;
end;
procedure TEditCalc.CMExit(var Message: TCMLostFocus);
begin
   if assigned(fcalc) then
   begin
      FMemor:=fcalc.Memory;
      fcalc.Edit:=nil;
      fcalc.Free;
      fcalc:=nil;
   end;
   inherited;
end;
procedure TEditCalc.SetDecimal(value:Integer);
begin
   if (FCalcDec<>value) and (value>=0) and (value<=10) then
      FCalcDec:=value;
end;
procedure TEditCalc.KeyPress(var Key: Char);
begin
   if key in ['0'..'9',decimalseparator,#8] then
   begin
      if (key=decimalseparator) and (pos(decimalseparator,self.Text)<>0) then
      begin
         key:=#0
      end;
   end
   else
      key:=#0;
   inherited keypress(key);
end;
procedure TEditCalc.SetCalcColor(value:TColor);
begin
   if FCalcColor<>value then
   begin
      fcalccolor:=value;
      if assigned(fcalc) then
         fcalc.Color:=self.FCalcColor;
   end;
end;
end.
