unit EditOpenDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Editb,dialogs,
  BrowseOpenDialog,propshell,shellapi,funciones,igriegaclasses,editbdefs;

type
  TTypeEditOpenDialog=(teoOpenFile,teoDirectory);
  TOnResult=procedure(Sender:TObject;Result:Boolean) of object;
  TPropOpenDialog=Class(TPersistent)
  private
    FDialog: TOpenDialog;
    procedure SetDefaultExt(value:string);
    function GetDefaultExt:string;
    procedure SetFilter(value:string);
    function GetFilter:string;
    procedure SetFilterIndex(value:integer);
    function GetFilterIndex:integer;
    procedure SetOptions(value:TOpenOptions);
    function GetOptions:TOpenOptions;
    procedure SetOptionsEx(value:TOpenOptionsEx);
    Function GetOptionsEx:TOpenOptionsEx;
    Procedure SetFileName(Value:TFileName);
    function GetFileName:TFilename;
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
    property DefaultExt:String read GetDefaultExt Write SetDefaultExt;
    property Filter:String Read GetFilter write SetFilter;
    property FilterIndex:Integer Read GetFilterIndex write SetFilterIndex;
    property Options:TOpenOptions read GetOptions write SetOptions;
    property OptionsEx: TOpenOptionsEx read GetOptionsEx write SetOptionsEx;
    property Filename:TFileName read GetFileName write SetFileName;
  end;

  TPropBrowseOpenDialog=Class(TPersistent)
  private
    FDialog: TBrowseOpenDialog;
    procedure SetTitle(value:string);
    function GetTitle:string;
    procedure SetRootFolder(value:TRootFolder);
    Function GetRootFolder:TRootFolder;
  protected
  public
    constructor Create;
    destructor Destroy;override;
  published
     property Title:string read GetTitle Write SetTitle;
     Property RootFolder:TRootFolder read GetRootFolder write SetRootFolder;
  end;

  TEditOpenDialog = class(TCustomEditb)
  private
    FDlg1:TPropOpenDialog;
    FDlg2:TPropBrowseOpenDialog;
    FTypeDialog:TTypeEditOpenDialog;
    FOnResult:TOnResult;
    FShowCmd:TShowcmd;
    procedure buttonclick(Sender: TObject);
    { Private declarations }
  protected
    { Protected declarations }
  public
    constructor Create(AOwner:TComponent);override;
    Destructor Destroy;override;
    Function GetDir:String;
    Function GetExt:String;
    Function GetFile:String;
    Function GetDrive:String;
    Function ShortPathName:String;
    Function GetExec:String;
    Function Exec(Oper:String='Open';Parameters:String=''):Boolean;
    Procedure Execute;
    { Public declarations }
  published
   property ShowCmd:TShowCmd read FShowCmd write FShowCmd default scSHOWNORMAL;
   Property ButtonType;
   property TypeDialog:TTypeEditOpenDialog read FTypeDialog write FTypeDialog default teoOpenFile;
   property TextButton;
   property WidthButton;
   property ImageButton;
   property FlatButton;
   property TransparentButton;
   property FontButton;
   property Font;
   property BevelEdges;
   property BevelInner;
   property BevelKind default bkNone;
   property BevelOuter;
   property BorderStyle;
   property Ctl3D;
   property Color;
   property Side;
   property Alignment;
   property FileDialog:TPropOpenDialog read FDlg1 write FDlg1;
   property DirectoryDialog:TPropBrowseOpenDialog read FDlg2 write FDlg2;
   property Text;
   property OnResult:TOnResult read FOnresult write FOnResult;
    { Published declarations }
  end;

//procedure Register;

implementation

{procedure Register;
begin
  RegisterComponents('i-griegavcl', [TEditOpenDialog]);
end;}
Constructor TEditOpenDialog.Create(AOWner:TComponent);
begin
   inherited;
   FDlg1:=TPropOpenDialog.create;
   FDlg2:=TPropBrowseOpenDialog.Create;
   OnButtonClick:=buttonclick;
   autosize:=false;
   FTypeDialog:=teoOpenFile;
   ButtonType:=ebOpen;
   FShowCmd:=scSHOWNORMAL;
end;
destructor TEditOpenDialog.Destroy;
begin
   FDlg1.Free;
   FDlg2.Free;
   inherited;
end;
Procedure TEditOpenDialog.Execute;
begin
   self.buttonclick(self);
end;
procedure TEditOpenDialog.buttonclick(Sender: TObject);
begin
   if typedialog=teoOpenFile then
   begin
      FDlg1.FDialog.InitialDir:=Text;
      if FDlg1.FDialog.Execute then
      begin
         text:=FDlg1.FDialog.FileName;
         if assigned(FOnresult) then FOnResult(self,true);
      end
      else
         if assigned(FOnresult) then FOnResult(self,false);
   end
   else
   begin
      FDlg2.FDialog.InitialDir:=text;
      If FDlg2.FDialog.Execute then
      begin
         text:=FDlg2.FDialog.OutDir;
         if assigned(FOnresult) then FOnResult(self,true);
      end
      else
         if assigned(FOnresult) then FOnResult(self,false);
   end;
end;
constructor TPropOpenDialog.Create;
begin
   inherited;
   FDialog:=topendialog.Create(nil);
end;
destructor TPropOpenDialog.Destroy;
begin
   FDialog.free;
   inherited;
end;
procedure TPropOpenDialog.SetDefaultExt(value:string);
begin
   if FDialog.DefaultExt<>value then
      FDialog.DefaultExt:=value;
end;
function TPropOpenDialog.GetDefaultExt:string;
begin
   result:= FDialog.DefaultExt;
end;
procedure TPropOpenDialog.SetFilter(value:string);
begin
   if FDialog.Filter<>value then
      FDialog.Filter:=value;
end;
function TPropOpenDialog.GetFilter:string;
begin
   result:= FDialog.Filter;
end;
procedure TPropOpenDialog.SetFilterIndex(value:integer);
begin
   if FDialog.FilterIndex<>value then
      FDialog.FilterIndex:=value;
end;
function TPropOpenDialog.GetFilterIndex:Integer;
begin
   result:= FDialog.FilterIndex;
end;
procedure TPropOpenDialog.SetOptions(value:TOpenOptions);
begin
   FDialog.Options:=value;
end;
function TPropOpenDialog.GetOptions:TOpenOptions;
begin
   result:= FDialog.options;
end;
procedure TPropOpenDialog.SetOptionsEx(value:TOpenOptionsEx);
begin
   FDialog.OptionsEx:=value;
end;
Function TPropOpenDialog.GetOptionsEx:TOpenOptionsEx;
begin
   result:= FDialog.OptionsEx;
end;
Procedure TPropOpenDialog.SetFileName(Value:TFilename);
begin
   if FDialog.FileName<>Value then
      FDialog.FileName:=Value;
end;
Function TPropOpenDialog.GetFileName:TFilename;
begin
   result:=FDialog.FileName;
end;
constructor TPropBrowseOpenDialog.Create;
begin
   inherited;
   FDialog:=tBrowseopendialog.Create(nil);
end;
destructor TPropBrowseOpenDialog.Destroy;
begin
   FDialog.free;
   inherited;
end;
procedure TPropBrowseOpenDialog.SetTitle(value:string);
begin
   if FDialog.Title<>value then
      FDialog.Title:=value;
end;
function TPropBrowseOpenDialog.GetTitle:string;
begin
   result:= FDialog.Title;
end;
procedure TPropBrowseOpenDialog.SetRootFolder(value:TRootFolder);
begin
   Fdialog.RootFolder:=value;
end;
Function TPropBrowseOpenDialog.GetRootFolder:TRootFolder;
begin
   result:=Fdialog.RootFolder;
end;
Function TEditOpenDialog.GetDir:String;
begin
   result:=extractfiledir(Text);
end;
Function TEditOpenDialog.GetExt:String;
begin
   result:=extractfileExt(Text);
end;
Function TEditOpenDialog.GetFile:String;
begin
   result:=extractfilename(Text);
end;
Function TEditOpenDialog.GetDrive:String;
begin
   result:=extractFileDrive(Text);
end;
Function TEditOpenDialog.ShortPathName:String;
begin
   result:=ExtractShortPathName(text);
end;
Function TEditOpenDialog.GetExec:String;
var
   ExecFile:PChar;
begin
   if text<>'' then
   begin
      getmem(execfile,max_path);
      findexecutable(pchar(text),nil,ExecFile);
      result:=String(ExecFile);
      freemem(execfile,max_path);
   end;
end;
Function TEditOpenDialog.Exec(Oper:String='Open';Parameters:String=''):Boolean;
var
   vshow:Integer;
begin
   vshow:=ShowNumber(ShowCmd);
   result:=(shellexecute(Parent.Handle,pchar(oper),pchar(text),pchar(parameters),pchar(GetDir),vshow))<=32
end;
end.
