unit Editb;

interface

uses
  Windows, Messages, SysUtils,dialogs, Classes, Controls, StdCtrls,buttons,graphics,editbdefs;
{const
  AlignText:array[taLeftJustify..taCenter] of DWORD =(ES_LEFT,ES_RIGHT,ES_CENTER);
  EditButtonsNames:array[0..17] of string=('BTNCHECKED','BTNSEARCH','BTNRECYCLE','BTNEDIT','BTNCANCEL',
                                     'BTNREFRESH','BTNNEW','BTNFIRST','BTNLAST','BTNPREVIOUS',
                                     'BTNNEXT','BTNCALENDAR','BTNCALCULATOR','BTNCOPY',
                                     'BTNSEARCHNEXT','BTNOPEN','BTNPRINTER','BTNSAVE');
type
  TEditButtons=(ebNone,ebChecked,ebSearch,ebRecycle,ebEdit,ebCancel,ebRefresh,ebNew,ebFirst,ebLast,ebPrevious,ebNext,ebCalendar,ebCalculator,ebCopy,
                ebSearchNext,ebOpen,ebPrinter,ebSave);
  TOnButtonClick = procedure(Sender : TObject) of object;
  TSide=(sbLeft,sbRight);
}
type
  TCustomEditb = class(TCustomEdit)
  private
     FButton:TSpeedButton;
     FButtonVisible:boolean;
     FOnButtonClick : TOnButtonClick;
     FWidthButton:Integer;
     FSide:TSide;
     FAlignment: TAlignment;
     FButtonType:TEditButtons;
     procedure SetEditRect;
     procedure ClickButton(Sender: TObject);
     procedure SetTextButton(value: TCaption);
     Function GetTextButton:TCaption;
     procedure SetWidthButton(value: Integer);
     procedure SetImageButton(value:TBitmap);
     Function GetImageButton:TBitmap;
     Procedure SetFlatButton(value:boolean);
     Function GetFlatButton:boolean;
     Function GetTransButton:Boolean;
     Procedure SetTransButton(Value:Boolean);
     procedure SetFontButton(value:TFont);
     Function GetFontButton:TFont;
     Procedure SetSide(Value:TSide);
     Procedure SetAlignment(value:TAlignment);
     procedure SetButtonType(value:TEditButtons);
     procedure SetButtonVisible(Value:Boolean);
     procedure WMSize(var Message: TWMSize); message WM_SIZE;
     procedure WMPaint(var Message: TWMPaint); message WM_PAINT;

    { Private declarations }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    property OnButtonClick : TOnButtonClick read FOnButtonClick write FOnButtonClick;
    property TextButton :TCaption read GetTextButton write setTextButton;
    property WidthButton:integer read FWidthButton write SetWidthButton;
    property ImageButton:TBitmap read GetImageButton write SetImageButton;
    property FlatButton:Boolean read GetFlatButton write SetFlatButton;
    property TransparentButton:Boolean read GetTransButton write SetTransButton;
    property FontButton:TFont read GetFontButton write SetFontButton;
    property Side:TSide read FSide write SetSide default sbRight;
    property Alignment: TAlignment read FAlignment write SetAlignment;
    Property ReadOnly;
    Property ButtonType:TEditButtons read FButtonType write SetButtonType;
    Property ButtonVisible:Boolean read FButtonVisible Write SetButtonVisible
                                                              default true;
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  published
    { Published declarations }
  end;
  TEditb = class(TCustomEditb)
  published
    property ButtonType;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property OnButtonClick;
    property TextButton;
    property WidthButton;
    property ImageButton;
    property FlatButton;
    property TransparentButton;
    property FontButton;
    property Side;
    property Alignment;
    property ButtonVisible;
  end;
implementation
constructor TCustomEditb.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FAlignment:=taLeftJustify;
  fbutton:=TSpeedButton.Create(self);
  FButton.Width := 15;
  FButton.Height := Height-2;
  FButton.Top:=1;
  FButton.Left:=1;
  FButton.Visible := True;
  FButton.Parent := Self;
  fbutton.OnClick:=clickbutton;
  fbutton.Flat:=true;
  fbutton.Transparent:=false;
  fbutton.Cursor:=crArrow;
  FSide:=sbRight;
  FWidthButton:=trunc((fbutton.Width*100/width));
  Fbuttontype:=ebNone;
  FButtonVisible:=true;
end;
destructor TCustomEditb.Destroy;
begin
   fbutton.Free;
   inherited;
end;
procedure TCustomEditb.SetButtonVisible(Value:Boolean);
begin
   if FButtonVisible<>Value then
   begin
      FButtonVisible:=Value;
      FButton.Visible:=Value;
      invalidate;
   end;
end;
procedure TCustomEditb.SetButtonType(value:TEditButtons);
var
  tmpimage:TBitmap;
begin
 if FButtonType<>value then
   if Value<>ebNone then
   begin
      tmpimage:=TBitmap.Create;
      try
        tmpimage.Handle:=LoadBitmap(hinstance,
                                 pchar(EditButtonsNames[ord(value)-1]));
        self.ImageButton.Assign(tmpimage);
        DeleteObject(tmpimage.Handle);
      finally
        tmpimage.Free;
      end;
      FButtonType:=Value;
   end
   else
   begin
      FButtonType:=ebNone;
      self.ImageButton:=nil;
   end;
end;
procedure TCustomEditb.Clickbutton(sender:tobject);
begin
   if assigned(fonbuttonclick) then
   begin
      fonbuttonclick(sender);
   end;
   fbutton.Parent.SetFocus;
end;
procedure TCustomEditb.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN or ES_MULTILINE  or
                  AlignText[FAlignment] or ES_AUTOHSCROLL;
end;
procedure TCustomEditb.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

procedure TCustomEditb.SetEditRect;
var
  Loc: TRect;
begin
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));
  if ButtonVisible then
  begin
     if fside=sbLeft then
     begin
        Loc.Bottom := ClientHeight + 1;
        Loc.Right := ClientWidth - 2;
        Loc.Top := 0;
        Loc.Left := FButton.Width + 2;
     end
     else
     begin
        Loc.Bottom := ClientHeight + 1;
        Loc.Right := ClientWidth - 2 - fbutton.Width;
        Loc.Top := 0;
        Loc.Left := 0;
     end;
  end
  else
     loc:=clientrect;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;
procedure TCustomEditb.WMSize(var Message: TWMSize);
begin
  inherited;
  if ButtonVisible then
  begin
     SetWidthButton(FWidthButton);
     if ctl3d then
        fbutton.Height:=height-5
     else
        fbutton.Height:=height-2;
     SetEditRect;
  end;
end;
procedure TCustomEditb.WMPaint(var Message: TWMPaint);
begin
  if ButtonVisible then
  begin
     if FSide=sbLeft then
        fbutton.Left:=1
     else
        fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
     SetWidthButton(FWidthButton);
     if ctl3d then
        fbutton.Height:=height-5
     else
        fbutton.Height:=height-2;
  end;
  SetEditRect;
  inherited;
end;
procedure TCustomEditb.SetTextButton(value:TCaption);
begin
   if value<>fbutton.Caption then
      fbutton.caption:=value;
end;
Function TCustomEditb.GetTextButton:TCaption;
begin
   result:=fbutton.caption;
end;
procedure TCustomEditb.SetWidthButton(value: Integer);
var
   n:integer;
begin
   if (value>0) and (value<75) then
   begin
      fWidthButton:=value;
      n:=trunc((width*value)/100);
      if (n<>FButton.Width) then
      begin
         fbutton.Width:=n;
         if FSide=sbLeft then
            fbutton.Left:=1
         else
            fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
      end;
   end;
   SetEditRect;
   self.Invalidate;
end;
procedure TCustomEditb.SetImageButton(value:TBitmap);
begin
   fbutton.Glyph.Assign(value);
   fbutton.NumGlyphs:=1;
   fbutton.Invalidate;
end;
Function TCustomEditb.GetImageButton:TBitmap;
begin
   result:= fbutton.Glyph;
end;
Procedure TCustomEditb.SetFlatButton(value:boolean);
begin
   if value<>fbutton.Flat then
   begin
      fbutton.Flat:=value;
      fbutton.Invalidate;
   end;
end;
Function TCustomEditb.GetFlatButton:boolean;
begin
   result:=fbutton.flat;
end;
Function TCustomEditb.GetTransButton:Boolean;
begin
   result:=fbutton.transparent;
end;
Procedure TCustomEditb.SetTransButton(Value:Boolean);
begin
   if value<>fbutton.transparent then
   begin
      fbutton.Transparent:=value;
      fbutton.Invalidate;
   end;
end;
procedure TCustomEditb.SetFontButton(value:TFont);
begin
   fbutton.Font.Assign(value);
   fbutton.Invalidate;
end;
Function TCustomEditb.GetFontButton:TFont;
begin
   result:=fbutton.Font;
end;
Procedure TCustomEditb.SetSide(Value:TSide);
begin
   if fside<>value then
   begin
      fside:=value;
      if value=sbLeft then
         fbutton.Left:=1
      else
         fbutton.Left:=(ClientWidth - 2 -fbutton.Width);
      invalidate;
      SetEditRect;
   end;
end;
Procedure TCustomEditb.SetAlignment(value:TAlignment);
begin
   if FAlignment<>value then
   begin
      FAlignment:=value;
      ReCreateWnd;
   end;
end;
end.
