{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit ExcelDatos;

interface

uses
  Windows, Messages, SysUtils, Classes,Graphics,db,{fontlist,}dialogs,comobj,OleServer,comctrls,forms,stdctrls,Buttons,
  ExtCtrls,controls,func_export,FieldsType{$IFDEF D6_OR_HIGHER}
   ,variants,funciones
{$ENDIF};

type
TOnBeforeConnectEvent = procedure(Sender : TObject;var Cancel:boolean) of object;
//TOnExportFieldEvent = procedure(Sender : TObject; FieldName:string; var Fielddata:variant; var cancel:boolean) of object;
//TOnNewRecordBeforeExport = procedure(Sender : TObject; dataset:tdataset;var Cancel:boolean) of object;
TExcelOpen = (xoNewExcel,xoNewWorkBook,xoNewWorkSheet,xoActiveSheet);
TFontStyles = set of TFontStyle;
TFontxl=Class(TPersistent)
   private
      FName:string;
      FColor:TColor;
      FSize:Integer;
      FStyle:TFontStyles;
   published
      property Name:string Read FName write FName;
      property Color:Tcolor read FColor Write FColor;
      property Size:Integer Read FSize Write FSize;
      property Style:TFontStyles Read FStyle Write FStyle;
   public
      constructor create;
end;

TExcelOpcs=(eoTitle,eoCondition,eoTitleBar);
TExcelOpc=set of TExcelOpcs;
TExcelXY=class(TPersistent)
  private
     FX:longint;
     FY:longint;
  published
     property X:longint read FX write FX default 1;
     property Y:longint read FY write FY default 1;
  public
     constructor create;
end;
  TPB1 = class(TForm)
    PB: TProgressBar;
  end;
  TfrmParam = class(TForm)
    gbExcel: TGroupBox;
    rbNewExcel: TRadioButton;
    rbNewBook: TRadioButton;
    rbNewSheet: TRadioButton;
    rbActive: TRadioButton;
    gbTitulo: TGroupBox;
    chTitle: TCheckBox;
    btnFontTitle: TButton;
    LTitle: TLabel;
    gbCondition: TGroupBox;
    Lcondition: TLabel;
    chCondition: TCheckBox;
    btnFontCondition: TButton;
    btnAceptar: TBitBtn;
    btnCancelar: TBitBtn;
    fdTitle: TFontDialog;
    fdCondition: TFontDialog;
    chBarTitle: TCheckBox;
    sx:TEdit;
    sy:TEdit;
    procedure btnFontTitleClick(Sender: TObject);
    procedure btnFontConditionClick(Sender: TObject);
    procedure btnAceptarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
TExceldatos=class(TFieldsType)
   private
   fconnect:boolean;
   fTitle:string;
   FFontTitle:TFontxl;
   FFontCondition:TFontxl;
   FNameSheet:string;
   FNameBook:string;
   FFont:tfont;
   FCondition:string;
   FStart:TExcelXY;
   FA:TExcelXY;
   FOptions:TexcelOpc;
   FExcelApp:variant;
   FFormaAper:texcelopen;
   FBooks:TstringList;
   FSheets:Tstringlist;
   FBook:variant;
   FSheet:variant;
   FVisible:boolean;
   FfrmParam:TfrmParam;
   FPB:TPB1;
   FOnBeforeConnect : TOnBeforeConnectEvent;
   FOnExportTitleBarField : TOnExportFieldEvent;
   FOnExportDataField : TOnExportFieldEvent;
   FOnNewRecordBeforeExport : TOnNewRecordBeforeExport;
   procedure SetConnect(Value:boolean);
   procedure SetVisible(Value:boolean);
   function GetBooks:TstringList;
   function GetSheets:TstringList;
   procedure SetNameBook(Value:string);
   procedure SetNameSheet(Value:string);
   procedure PrintTitleBarField(field:Tfield);
   procedure PrintDataField(field:Tfield);
   procedure ShowPB;   
   published
      property Title:string read FTitle write FTitle;
      property Font:tfont read ffont write ffont;
      Property FontTitle:TFontxl read FFontTitle write FFontTitle;
      Property FontCondition:TFontxl read FFontCondition write FFontCondition;
      property Condition:string read FCondition write FCondition;
      property Start:TExcelXY read FStart write FStart;
      property Options:TexcelOpc read FOptions write FOptions default [eoTitle,eoTitleBar];
      property FormaAper:texcelopen read fformaaper write FFormaAper;
      property OnBeforeConnect : TOnBeforeConnectEvent read FOnBeforeConnect write FOnBeforeConnect;
      property OnExportTitleBarField : TOnExportFieldEvent read FOnExportTitleBarField write FOnExportTitleBarField;
      property OnExportDataField : TOnExportFieldEvent read FOnExportDataField write FOnExportDataField;
      property OnNewRecordBeforeExport : TOnNewRecordBeforeExport read FOnNewRecordBeforeExport write FOnNewRecordBeforeExport;
   public
      property connect:boolean read fconnect write SetConnect;
      property NameSheet:string read FNameSheet write SetNameSheet;
      property NameBook:string read FNameBook write SetNameBook;
      property Visible:boolean read fvisible write setvisible;
      procedure Export(Name:string{;var p:TProgressBar});
      procedure Rename(value:string);
      Function ShowParam:TModalResult;
      property Books:TstringList read GetBooks {write FBooks};
      property Sheets:TstringList read GetSheets;
      property Book:variant read FBook write FBook;
      property Sheet:variant read FSheet write FSheet;
      property ExcelApp:variant read FExcelApp {write FExcelApp};
      property A:TExcelXY read FA write FA;
      Constructor create(AOwner: TComponent);override;
      Destructor destroy;override;
end;



implementation
{$R PARAM.DFM}
{$R PRogressBar.DFM}

constructor TFontxl.create;
begin
   inherited create;
   fsize:=18;
   fcolor:=clRed;
   fstyle:=[fsBold];
   fName:='Arial';
end;
constructor texcelxy.create;
begin
   inherited;
   FX:=1;
   FY:=1;
end;
Constructor TExcelDatos.create(AOwner: TComponent);
begin
   inherited;
   FStart:=texcelxy.Create;
   FA:=texcelxy.Create;
   ffont:=tfont.Create;
   ffontTitle:=Tfontxl.Create;
   fBooks:=tstringList.Create;
   fSheets:=tstringList.Create;
   FfrmParam:=TfrmParam.Create(self);
   FPB:=tpb1.Create(self);
   ffontCondition:=Tfontxl.Create;
   FOptions:=[eoTitle,eoTitleBar];
   FExcelapp:=null;
   FBook:=null;
   FSheet:=null;
end;
procedure TExcelDatos.SetVisible(Value:boolean);
begin
   if not varisnull(fexcelapp) then
   begin
      fvisible:=value;
      fexcelapp.visible:=value;
   end;
end;
procedure TExcelDatos.Export(Name:string{; var p:TProgressBar});
const
  // SheetType
  xlChart = -4109;
  xlWorksheet = -4167;
  // WBATemplate
  xlWBATWorksheet = -4167;
  xlWBATChart = -4109;
  // Page Setup
  xlPortrait = 1;
  xlLandscape = 2;
  xlPaperA4 = 9;
  // Format Cells
  xlBottom = -4107;
  xlLeft = -4131;
  xlRight = -4152;
  xlTop = -4160;
  // Text Alignment
  xlHAlignCenter = -4108;
  xlVAlignCenter = -4108;
  // Cell Borders
  xlThick = 4;
  xlThin = 2;
  xlContinuous = 1;
  xlEdgeBottom = 9;
var
    i,j:integer;
    Nameh:string;
    vx:longint;
    registros:longint;
    c:tcanvas;
    cancel:boolean;
begin
    c:=tcanvas.Create;
    c.Handle:=(owner as tform).handle;
    if not connect then
       connect:=true;
    if not assigned(table) then
       showmessage('No ha asignado una tabla')
    else
    begin
       table.DisableControls;
       if fconnect then
       begin
       try
          ShowPb;
          Nameh:=varastype(Sheet.name,varString);
          Sheet.name:=iif(Name>'',Name,Nameh);
          Start.FY:=iif(start.Y=-1,excelapp.activecell.row,start.y);
          Start.FX:=iif(Start.X=-1,excelapp.activecell.column,Start.X);
          fa.X:=fStart.X;
          fa.Y:=fStart.Y;
          if eoTitle in Options then
          begin
             Sheet.cells[a.y,a.x]:=trim(Title);
             Sheet.cells[a.y,a.x].font.size:=FontTitle.Size;
             Sheet.cells[a.y,a.x].font.bold:=fsBold in FontTitle.Style;
             Sheet.cells[a.y,a.x].font.italic:=fsItalic in FontTitle.Style;
             Sheet.cells[a.y,a.x].font.Underline:=fsUnderline in FontTitle.Style;
             Sheet.cells[a.y,a.x].font.color:=FontTitle.Color;
             c.font.Name:=Sheet.cells[a.y,a.x].font.name;
             c.font.size:=FontTitle.Size;
             c.font.style:=fonttitle.Style;
          end;
          a.y:=a.y+1;
          if (Condition>'') and (eoCondition in Options) then
          begin
             Sheet.cells[a.y,a.x]:=trim(Condition);
             Sheet.cells[a.y,a.x].font.size:=FontCondition.Size;
             Sheet.cells[a.y,a.x].font.bold:=fsBold in FontCondition.Style;
             Sheet.cells[a.y,a.x].font.italic:=fsItalic in FontCondition.Style;
             Sheet.cells[a.y,a.x].font.Underline:=fsunderline in FontCondition.Style;
             Sheet.cells[a.y,a.x].font.color:=FontCondition.Color;
             a.y:=a.y+1;
          end;
          vx:=a.x;
          if eoTitleBar in Options then
          begin
             for i:=0 to Table.Fields.Count-1 do
                printtitlebarfield(Table.Fields[i]);
             a.y:=a.y+1;
          end;
         a.x:=vx;
         registros:=Table.RecordCount;
         fpb.PB.Max:=registros;
         Table.First;
         for i:=1 to registros do
         begin
           fpb.PB.position:=i;
           cancel:=false;
           if assigned(FOnNewRecordBeforeExport) then
              FOnNewRecordBeforeExport(self,table,cancel);
           if not cancel then
           begin
              Application.ProcessMessages;
              fpb.Activate;
              fpb.Invalidate;
              for j:=0 to Table.Fields.Count-1 do
                 PrintDataField(Table.Fields[j]);
              a.y:=a.y+1;
              a.x:=vx;
           end;
           Table.next;
         end;
         fpb.Hide;
       except
          showmessage('Error en comunicacion');
          fpb.Hide;
       end;
       end;
   end;
   c.Free;
   table.EnableControls;
end;
procedure TExcelDatos.PrintTitleBarField(field:Tfield);
const
  // SheetType
  xlChart = -4109;
  xlWorksheet = -4167;
  // WBATemplate
  xlWBATWorksheet = -4167;
  xlWBATChart = -4109;
  // Page Setup
  xlPortrait = 1;
  xlLandscape = 2;
  xlPaperA4 = 9;
  // Format Cells
  xlBottom = -4107;
  xlLeft = -4131;
  xlRight = -4152;
  xlTop = -4160;
  // Text Alignment
  xlHAlignCenter = -4108;
  xlVAlignCenter = -4108;
  // Cell Borders
  xlThick = 4;
  xlThin = 2;
  xlContinuous = 1;
  xlEdgeBottom = 9;
var cancel:boolean;
    valor:variant;
    index:integer;
begin
   if fields.Locate(field.fieldname,index) then
   begin
      cancel:=false;
      valor:=field.FieldName;
      if Assigned(FOnExportTitleBarField) then
         FOnExportTitleBarField(Self,field.FieldName,valor, Cancel);
      if not cancel then
      begin
           Sheet.cells[a.Y,a.X]:=valor;  //Field.FieldName;
           Sheet.cells[a.Y,a.X].borders[xlEdgeBottom].linestyle:= xlContinuous;
           Sheet.cells[a.Y,a.X].borders[xlEdgeBottom].Weight:=xlThick;
           Sheet.cells[a.Y,a.X].interior.colorindex:=15;
           Sheet.cells[a.Y,a.X].font.bold:=true;
           a.X:=a.x+1;
      end;
   end;
end;
procedure TExcelDatos.PrintDataField(field:Tfield);
const
  // SheetType
  xlChart = -4109;
  xlWorksheet = -4167;
  // WBATemplate
  xlWBATWorksheet = -4167;
  xlWBATChart = -4109;
  // Page Setup
  xlPortrait = 1;
  xlLandscape = 2;
  xlPaperA4 = 9;
  // Format Cells
  xlBottom = -4107;
  xlLeft = -4131;
  xlRight = -4152;
  xlTop = -4160;
  // Text Alignment
  xlHAlignCenter = -4108;
  xlVAlignCenter = -4108;
  // Cell Borders
  xlThick = 4;
  xlThin = 2;
  xlContinuous = 1;
  xlEdgeBottom = 9;
var cancel:boolean;
    valor:variant;
    index:integer;
begin
   if fields.Locate(field.fieldname,index) then
   begin
      cancel:=false;
      valor:=field.Value;
      if Assigned(FOnExportDataField) then
         FOnExportDataField(Self,field.FieldName,valor, Cancel);
      if not cancel then
      begin
          Sheet.cells[a.y,a.x].font.size:=Font.Size;
          Sheet.cells[a.y,a.x].font.bold:=fsBold in Font.Style;
          Sheet.cells[a.y,a.x].font.italic:=fsItalic in Font.Style;
          Sheet.cells[a.y,a.x].font.Underline:=fsUnderline in Font.Style;
          Sheet.cells[a.y,a.x].font.color:=font.Color;
          Sheet.cells[a.y,a.x].font.NAME:=font.NAME;
           case field.DataType of
              ftInteger:Sheet.cells[a.Y,a.X]:=VarAsType(valor,varInteger);
              ftFloat:Sheet.cells[a.Y,a.X]:=VarAsType(valor,varDouble);
              ftDate:Sheet.cells[a.Y,a.X]:=varastype(valor,VarDate)
           else
              Sheet.cells[a.y,a.X]:=vartostr(valor);
           end;
           a.x:=a.x+1;
      end;
   end;
end;

procedure texceldatos.SetNameBook(value:string);
var i:integer;
begin
   if not varisnull(fexcelapp) then
   for i:=1 to fexcelapp.workbooks.count do
   if uppercase(trim(fexcelapp.workbooks[i].name))=uppercase(trim(value)) then
   begin
      fexcelapp.windows[value].activate;
      fNameBook:=value;
      fBook:=fexcelapp.workbooks[i];
      fSheet:=fBook.activesheet;
      fNameSheet:=fSheet.name;
      Start.FY:=iif(start.Y=-1,excelapp.activecell.row,start.y);
      Start.FX:=iif(Start.X=-1,excelapp.activecell.column,Start.X);
      fa.X:=fStart.X;
      fa.Y:=fStart.Y;
   end;
end;
procedure texceldatos.Rename(value:string);
begin
   if not varisnull(fSheet) then
   begin
      fSheet.name:=value;
      setNameSheet(value);
   end;
end;
function texceldatos.GetSheets:tstringlist;
var i:integer;
begin
   fsheets.Clear;
   if not varisnull(fexcelapp) and not varisnull(fBook) then
   begin
      for i:=1 to fBook.worksheets.count do
         fsheets.Add(trim(fBook.worksheets[i].name));
   end;
   result:=fsheets;
end;

procedure texceldatos.SetNameSheet(value:string);
var i:integer;
begin
   if not varisnull(fexcelapp) and not varisnull(fBook) then
   for i:=1 to fBook.worksheets.count do
   if uppercase(trim(fBook.worksheets[i].name))=uppercase(trim(value)) then
   begin
      fBook.sheets[value].activate;
      fSheet:=fBook.activesheet;
      Start.FY:=iif(start.Y=-1,excelapp.activecell.row,start.y);
      Start.FX:=iif(Start.X=-1,excelapp.activecell.column,Start.X);
      FA.x:=fStart.x;
      FA.y:=fStart.y;
      fNameSheet:=value;
      break;
   end;
end;
function texceldatos.getbooks:TstringList;
var
   i:integer;
begin
   fbooks.Clear;
   if fconnect and (not varisnull(FExcelApp)) then
   begin
      fBook:=FExcelApp.activeworkbook;
      fSheet:=fBook.activesheet;
      FNameSheet:=fSheet.name;
      FNameBook:=fBook.name;
      for i:=1 to fexcelapp.workbooks.count do
         FBooks.Add(fexcelapp.worKbooks[i].name);
   end
   else
   begin
         fBook:=null;
         fSheet:=null;
         fexcelapp:=null;
   end;
   result:=fbooks;
end;
procedure texceldatos.SetConnect(Value:boolean);
const
  xlWBATWorksheet = -4167;
var
  i:integer;
  cancel:boolean;
begin
   cancel:=false;
   if value then
      if Assigned(FOnBeforeConnect) then
          FOnBeforeConnect(Self,cancel);
   if not cancel then
   begin
   fconnect:=value;
   if value then
      case fformaaper of
      xoNewExcel:
         begin
            try
               FExcelApp := CreateOleObject('Excel.Application');
               FExcelApp.Workbooks.Add;//(xlWBatWorkSheet);
             except
                showmessage('No se puede abrir Excel');
                fconnect:=false;
             end;
         end;
      xoActiveSheet:
             try
                FExcelApp := GetActiveOleObject('Excel.Application');
             except
                if not varisnull(FExcelApp) then
                begin
                   FExcelApp.DisplayAlerts := False;  // Discard unsaved files....
                   FExcelApp.Quit;
                end;
                showmessage('Error.Esta abierto Excel?');
                fconnect:=false;
             end;
      xoNewWorkBook:
             try
                FExcelApp := GetActiveOleObject('Excel.Application');
                FExcelApp.Workbooks.Add;//(xlWBatWorkSheet);
             except
                if not varisnull(FExcelApp) then
                begin
                   FExcelApp.DisplayAlerts := False;  // Discard unsaved files....
                   FExcelApp.Quit;
                end;
                showmessage('Error.Esta abierto Excel?');
                fconnect:=false;
             end;
      xoNewWorkSheet:
             try
                FExcelApp := GetActiveOleObject('Excel.Application');
                FExcelApp.ActiveWorkbook.worksheets.Add(null,null);
             except
                if not varisnull(FExcelApp) then
                begin
                   FExcelApp.DisplayAlerts := False;  // Discard unsaved files....
                   FExcelApp.Quit;
                end;
                showmessage('Error.Esta abierto Excel?');
                fconnect:=false;
             end
      else
         if not VarIsEmpty(FExcelApp) and (fformaaper=xoNewExcel) then
         begin
             FExcelApp.DisplayAlerts := False;  // Discard unsaved files....
             FExcelApp.Quit;
         end;
      end;
      if fconnect and (not varisnull(FExcelApp)) then
      begin
         fBook:=FExcelApp.activeworkbook;
         fSheet:=fBook.activesheet;
         FNameSheet:=fSheet.name;
         FNameBook:=fBook.name;
         FBooks.Clear;
         for i:=1 to fexcelapp.workbooks.count do
            FBooks.Add(fexcelapp.worKbooks[i].name);
         Start.FY:=iif(start.Y=-1,excelapp.activecell.row,start.y);
         Start.FX:=iif(Start.X=-1,excelapp.activecell.column,Start.X);
         FA.x:=fStart.x;
         FA.y:=fStart.y;
      end
      else
      begin
         fBook:=null;
         fSheet:=null;
         fexcelapp:=null;
      end;
   end;
end;
Destructor Texceldatos.destroy;
begin
   if Fconnect and (fformaaper=xoNewExcel) then
   begin
      FExcelApp.DisplayAlerts := True;  // Discard unsaved files....
      FExcelApp.Quit;
   end;
   FfrmParam.free;
   ffont.Free;
   FPB.Free;
   FA.Free;
   FStart.Free;
   fFontTitle.Free;
   ffontCondition.Free;
   fBooks.Free;
   fSheets.Free;   
   fBook:=null;
   fSheet:=null;
   fexcelapp:=null;
   inherited;
end;
Procedure TexcelDatos.ShowPB;
begin
   fpb.PB.Min:=0;
   fpb.PB.Position:=0;
   fpb.show;
   fpb.Invalidate;
end;
Function TExcelDatos.ShowParam:TModalResult;
begin
   case FFormaAper of
      xoNewExcel:     ffrmparam.rbNewexcel.Checked:=true;
      xoNewWorkBook:  ffrmparam.rbNewbook.Checked:=true;
      xoNewWorkSheet: ffrmparam.rbNewsheet.checked:=true;
      xoActiveSheet:  ffrmparam.rbActive.Checked:=true;
   end;
   ffrmparam.chtitle.Checked:=iif(eoTitle in foptions,true,false);
   ffrmparam.chcondition.Checked:=iif(eoCondition in foptions,true,false);
   ffrmparam.chbartitle.Checked:=iif(eoTitleBar in foptions,true,false);
   ffrmparam.fdtitle.Font.Name:=FontTitle.Name;
   ffrmparam.fdtitle.Font.Size:=fonttitle.Size;
   ffrmparam.fdtitle.Font.Style:=fonttitle.Style;
   ffrmparam.fdtitle.Font.Color:=fonttitle.Color;
   ffrmparam.fdCondition.Font.name:=FontCondition.Name;
   ffrmparam.fdCondition.Font.Size:=ffontCondition.Size;
   ffrmparam.fdCondition.Font.Style:=fontCondition.Style;
   ffrmparam.fdCondition.Font.Color:=fontCondition.Color;
   ffrmparam.Lcondition.Font:=ffrmparam.fdCondition.Font;
   ffrmparam.LTitle.Font:=ffrmparam.fdTitle.Font;
   ffrmparam.sx.text:=inttostr(start.x);
   ffrmparam.sy.text:=inttostr(start.y);
   if ffrmparam.Showmodal=idok then
   begin
      if ffrmparam.rbNewexcel.Checked then
         formaaper:=xoNewExcel
      else if ffrmparam.rbnewbook.Checked then
         formaaper:=xoNewWorkBook
      else if ffrmparam.rbNewSheet.checked then
         formaaper:=xoNewWorkSheet
      else
         formaaper:=xoActivesheet;
      fonttitle.Name:=ffrmparam.fdtitle.Font.Name;
      fonttitle.Size:=ffrmparam.fdTitle.Font.Size;
      fonttitle.FColor:=ffrmparam.fdtitle.font.Color;
      fonttitle.Style:=ffrmparam.fdTitle.font.Style;
      fontcondition.Name:=ffrmparam.fdcondition.Font.Name;
      fontcondition.Size:=ffrmparam.fdcondition.Font.Size;
      fontcondition.FColor:=ffrmparam.fdcondition.font.Color;
      fontcondition.Style:=ffrmparam.fdcondition.font.Style;
      if ffrmparam.sx.text='' then ffrmparam.sx.text:='-1';
      if ffrmparam.sy.text='' then ffrmparam.sx.text:='-1';
      start.x:=strtoint(ffrmparam.sx.text);
      start.y:=strtoint(ffrmparam.sy.text);
      if ffrmparam.chtitle.Checked then
         options:=options+[eoTitle]
      else
         options:=options-[eoTitle];
      if ffrmparam.chcondition.Checked then
         options:=options+[eoCondition]
      else
         options:=options-[eoCondition];
      if ffrmparam.chBartitle.Checked then
         options:=options+[eoTitleBar]
      else
         options:=options-[eoTitleBar];
      result:=mrok;
   end
   else
      result:=mrcancel;
end;

procedure TfrmParam.btnFontTitleClick(Sender: TObject);
begin
   if fdTitle.Execute then
      ltitle.Font:=fdTitle.Font;
end;

procedure TfrmParam.btnFontConditionClick(Sender: TObject);
begin
   if fdCondition.Execute then
      lCondition.Font:=fdCondition.Font;
end;

procedure TfrmParam.btnAceptarClick(Sender: TObject);
begin
   Modalresult:=idOk;
end;

procedure TfrmParam.btnCancelarClick(Sender: TObject);
begin
   Modalresult:=idcancel;
end;
procedure TfrmParam.FormCreate(Sender: TObject);
begin
end;

end.
