unit FieldsType;

interface
uses
  Db,
  DBTables,windows,
  ComObj,Graphics,fields,forms,controls,
  Messages,Dialogs,sysutils,classes;
type
TFieldsList=class(TStringlist)
   public
      function Locate(cad:string;var Index:integer):Boolean;
end;
TFieldsType=Class(Tcomponent)
   private
      FTable:tdataset;
      FFields:TFieldsList;
   published
      property Table:tdataset read FTable Write FTable;
      property Fields:tFieldslist read FFields write FFields;
   public
      constructor Create(AOwner: TComponent);override;
      destructor destroy;override;
      procedure SetAllFields;
      function Locate(cad:string;var Index:integer):Boolean;
      procedure Edit;
end;

implementation

procedure TFieldsType.Edit;
var
  FieldsEditor: TfrmFields ;
  i,index:integer;

begin
  FieldsEditor := TfrmFields.Create(Application);
  try
     if fields.Count>0 then
     begin
        fieldseditor.L2.Clear;
        fieldseditor.L1.Clear;
        table.FieldDefs.update;
        for i:=0 to table.FieldDefs.count -1 do
        begin
           if fields.Locate(table.FieldDefs[i].Name,index) then
              fieldseditor.L2.Items.Add(table.FieldDefs[i].Name)
           else
              fieldseditor.L1.Items.Add(table.FieldDefs[i].Name);
        end;
     end
     else
     begin
        setallfields;
        fieldseditor.L2.Items.Assign(fields);
     end;
     if FieldsEditor.ShowModal=mrok then
     begin
        fields.clear;
        fields.Assign(fieldseditor.L2.Items);
//        designer.Modified;
     end;
  finally
    FieldsEditor.Free;
  end;
end;

function TFieldsList.Locate(cad:string;var Index:integer):boolean;
var i:integer;
begin
   result:=false;
   index:=-1;
   for i:=0 to self.Count - 1 do
      if uppercase(self.Strings[i])=uppercase(cad) then
      begin
         result:=true;
         index:=i;
         exit
      end;
end;
constructor TFieldsType.Create(AOwner:TComponent);
begin
   inherited;
   ffields:=tfieldslist.Create;
end;
destructor TFieldsType.destroy;
begin
   ffields.Free;
   inherited;
end;
procedure TFieldsType.SetAllFields;
var i:integer;
begin
   if assigned(table){ and table.active} then
   begin
      ffields.Clear;
      table.FieldDefs.Update;
      for i:=0 to table.FieldDefs.Count -1 do
         ffields.Add(table.fielddefs[i].Name);
   end;
end;
function TFieldsType.Locate(cad:string;var Index:integer):Boolean;
begin
    result:=fields.Locate(cad,index);
end;
end.
