{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit HTMLExport;

interface

uses
  Windows, Messages, SysUtils, Classes,Graphics,db,{fontlist,}dialogs,comobj,OleServer,comctrls,forms,stdctrls,Buttons,
  ExtCtrls,controls,fields,HTMLParam,FieldsType{$IFDEF D6_OR_HIGHER}
   ,variants,func_export,funciones
{$ENDIF};

Type
THTMLExport=Class;
TColorText=Class(TPersistent)
   private
      FColor:TColor;
      FbgColor:Tcolor;
   published
      property Color:Tcolor read FColor write FColor;
      property bgColor:Tcolor read FbgColor Write FbgColor;
   public
      constructor Create;
end;
THTMLTable=Class(TPersistent)
   private
      FName:String;
      FBorder:Integer;
      FCellspacing:Integer;
      FCellpadding:Integer;
      FbgColor:Tcolor;
      FBordercolor:Tcolor;
      FDifferent:boolean;
      FDColor1:TColorText;
      FDColor2:TColorText;
   published
      property name:string read FName write FName;
      property border:integer read FBorder write FBorder;
      property cellspacing:Integer read Fcellspacing write Fcellspacing;
      property cellpadding:Integer read Fcellpadding write Fcellpadding;
      property bgcolor:Tcolor read Fbgcolor write Fbgcolor;
      property bordercolor:Tcolor read fbordercolor write fbordercolor;
      property Different:boolean read FDifferent write FDifferent;
      property DColor1:TColorText read FDColor1 write FDColor1;
      property DColor2:TColorText read FDColor2 write FDColor2;
   public
      constructor create;
      destructor destroy; override;
end;
TTemplateItem=class(TCollectionItem)
   private
     FVariable:string;
     FLines:Tstrings;
   protected
      procedure SetLines(Value: TStrings);
      function GetDisplayName: string; override;
   published
      property Variable:string read Fvariable write FVariable;
      property Lines:Tstrings read Flines write SetLines;
   public
      constructor Create(Collection:TCollection);override;
      destructor Destroy;override;
end;
TTemplateReplace=Class(TCollection)
   private
      FOwner:TPersistent;
      FFilename:TFilename;
      FClearBefore:boolean;
      FFileContent:Tstrings;
      function GetItem(Index:Integer):TTemplateItem;
      Procedure SetItem(Index:Integer;Value:TTemplateItem);
      procedure SetFilename(value:tfilename);
   Protected
      function GetOwner:TPersistent;override;
   Public
      Constructor Create(Owner:TPersistent);
      Destructor Destroy;override;
      Function Add:TTemplateItem;
      procedure SaveToFile(filename:TFilename);
      property Items[Index:Integer]:TTemplateItem read Getitem write SetItem; default;
   published
      Property FileName:TFilename read FFilename write SetFilename;
      property ClearBefore:Boolean read FClearBefore write FClearBefore default true;
end;
// Guardara la lnea de comienzo y fin de la pgina
TPagesItem=class(TCollectionItem)
   private
      FFirst:Integer;
      FLast:Integer;
   published
      property First:integer read FFirst write FFirst;
      property Last:integer read FLast write FLast;
   public
      Constructor Create(Collection: TCollection); override;
end;
// Manejo de las pginas
TPages=Class(TCollection)
   private
//      FHTMLExport:THTMLExport;
      Fowner:TPersistent;
      function GetItem(Index:Integer):TPagesItem;
      Procedure SetItem(Index:Integer;Value:TPagesItem);
   Protected
      function GetOwner:TPersistent;override;
   Public
      Constructor Create(owner:Tpersistent);
      Function Add:TPagesItem;
      property Page[Index:Integer]:TPagesItem read Getitem write SetItem; default;
end;
// Tipos de tamao de ttulos
THTMLSizeText=(H1,H2,H3,H4,H5,H6);
// Caracteristicas del texto
THTMLText=Class(TPersistent)
   private
      FColor:Tcolor;
      FText:string;
      FSize:THTMLSizeText;
   published
      property Color:Tcolor read Fcolor write FColor;
      property Text:String read FText write FText;
      property Size:THTMLSizeText read FSize write FSize;
   public
      constructor Create;
      function SizeName:string;
end;
// Tipo de color del texto
// Objeto de exportacin hacia HTML
THTMLExport=Class(TFieldsType)
   private
      FTitle:THTMLText;
      FSubTitle:THTMLText;
      FBarTitleColor:TColorText;
      FTextColor:TColorText;
      FHTMLResult :TstringList;
      FLinesPerTable:Integer;
      FPages:TPages;
      FPage:TStringList;
      FHTMLTable:THTMLTable;
      FCss:string;
      FTemplate:TFileName;
      FTemplateReplace:TTemplateReplace;
      FOnNewRecordBeforeExport : TOnNewRecordBeforeExport;
      FOnExportDataField : TOnExportFieldFormatEvent;
      procedure PrintDataField(Field:TField;L:integer);
      Procedure CabeceraTabla(Stringl:TStringList);
      Procedure CabeceraPagina(Stringl:TStringList);
      Procedure PiePagina(Stringl:TStringList);
      Procedure PieTabla(Stringl:TStringList);
//      function  bgColor(color:TCOLOR):string;
      function FontColor(Color:TCOLOR;dato:string):string;
   published
      property Title:THTMLText Read FTitle write FTitle;
      property SubTitle:THTMLText Read FSubTitle write FSubTitle;
      property BarTitleColor:TColorText read FBarTitleColor write FBarTitleColor;
      property TextColor:TColorText read FTextColor write FTextColor;
      property LinesPerTable:Integer read fLinesPerTable write fLinesPerTable;
      property HTMLTable:THTMLTable read FHTMLTable write FHTMLTable;
      property CSS:string read FCss write FCss;
      property Template:TFilename read FTemplate write FTemplate;
      property TemplateReplace:TTemplateReplace read FTemplateReplace write fTemplateReplace;
      property OnNewRecordBeforeExport : TOnNewRecordBeforeExport read FOnNewRecordBeforeExport write FOnNewRecordBeforeExport;
      property OnExportDataField : TOnExportFieldFormatEvent read FOnExportDataField write FOnExportDataField;
   public
      property HTMLResult:TstringList read FHTMLResult write FHTMLResult;
      Constructor create(AOwner: TComponent);override;
      Destructor destroy;override;
      Procedure SaveAllToFile(FileName: string;Template:boolean=false);
      procedure SavePageToFile(pPage:integer;FileName: string;Template:boolean=false);
      Procedure Generate;
      Function GetPage(Index:Integer):TStringList;
      Function GetTemplatePage(Index:integer):TStringList;
      Function GetTemplateAll:TStringList;
      Function CountPages:Integer;
      Function Params:Integer;
end;

implementation
constructor THTMLTable.create;
begin
   inherited;
   FName:='';
   FBorder:=1;
   FCellspacing:=0;
   FCellpadding:=-1;
   FbgColor:=clwindow;
   FBordercolor:=clWindowText;
   FDifferent:=false;
   FDColor1:=tcolortext.Create;
   FDColor2:=tcolortext.Create;
//   FDColor1:=clwindow;
//   FDColor2:=clwindow;
end;
destructor THTMLTable.destroy;
begin
   FDColor1.Free;
   FDColor2.Free;
   inherited;
end;
constructor TTemplateReplace.Create(Owner:TPersistent);
begin
   inherited Create(TTemplateItem);
   Fowner:=owner;
   FFileContent:=tstringlist.Create;
   FFilename:='';
   FClearBefore:=True;
end;
Destructor TTemplateReplace.Destroy;
begin
   ffilecontent.Free;
   inherited destroy;
end;
Procedure TTemplateReplace.SetFilename(value:TFilename);
   procedure LoadVars;
   var i,index:integer;
       v:boolean;
   begin
      v:=false;
      index:=self.Count-1;
      if clearbefore then
      begin
         self.Clear;
         index:=-1;
      end;
      for i:=0 to ffilecontent.Count-1 do
      begin
         if pos('#VAR:',uppercase(ffilecontent.Strings[i]))<>0 then
         begin
             inc(index);
             v:=true;
             self.Add;
             self.Items[index].Variable:=copy(ffilecontent.Strings[i],pos('#VAR:',uppercase(ffilecontent.Strings[i]))+5,length(ffilecontent.Strings[i]));
         end
         else
            if v then
               self.Items[index].Lines.Add(ffilecontent.Strings[i]);
      end;
   end;
begin
   if value<>'' then
   begin
      if (value<>ffilename) and FileExists(value) then
      begin
         ffilename:=value;
         ffilecontent.LoadFromFile(value);
         loadvars;
      end
   end
   else
      ffilename:='';
end;
Procedure TTemplateReplace.SaveToFile(filename:TFilename);
var
   temp:tstringlist;
   i:integer;
begin
   try
      temp:=tstringlist.create;
      for i:=0 to self.count-1 do
      begin
         temp.add('#var:'+self.items[i].variable);
         temp.text:=temp.text+self.items[i].lines.text;
      end;
      try
         temp.SaveToFile(filename);
      except
         showmessage('Error. No se puede grabar');
      end;
      temp.free;
   except
      showmessage('Error. No se puede grabar');
   end;
end;
function TTemplateReplace.GetItem(Index:Integer):TTemplateItem;
begin
   result:=TTemplateItem(inherited GetItem(Index));
end;
Procedure TTemplateReplace.SetItem(Index:Integer;Value:TTemplateItem);
begin
   inherited SetItem(Index,Value);
end;
Function TTemplateReplace.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TTemplateReplace.Add:TTemplateItem;
begin
   result:=TTemplateItem(Inherited Add);
end;
Constructor TTemplateItem.Create;
begin
   inherited;
   FVariable:='';
   FLines:=Tstringlist.create;
end;
destructor TTemplateItem.Destroy;
begin
   flines.Free;
   inherited;
end;
procedure TTemplateItem.SetLines(Value: TStrings);
begin
  FLines.Assign(Value);
end;
function TTemplateitem.GetDisplayName: string;
begin
  Result := FVariable;
  if Result = '' then Result := inherited GetDisplayName;
end;
constructor TPages.Create(owner:Tpersistent);
begin
   inherited Create(TPagesItem);
   Fowner:=owner;
end;
function TPages.GetItem(Index:Integer):TPagesItem;
begin
   result:=TPagesItem(inherited GetItem(Index));
end;
Procedure TPages.SetItem(Index:Integer;Value:TPagesItem);
begin
   inherited SetItem(Index,Value);
end;
Function TPages.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TPages.Add:TPagesItem;
begin
   result:=TPagesItem(Inherited Add);
end;
Constructor TPagesItem.Create;
begin
   inherited;
   FFirst:=0;
   FLast:=0;
end;
constructor TColorText.Create;
begin
   inherited;
   FColor:=clWindowText;
   FBgColor:=clWindow;
end;
constructor  THTMLText.Create;
begin
   inherited;
   Ftext:='';
   FColor:=clWindowText;
   FSize:=H1;
end;
function THTMLText.SizeName:string;
begin
   result:=copy('H1H2H3H4H5H6',((ord(FSize)-1)*2)+1,2);
end;
constructor THTMLExport.create(AOWner:Tcomponent);
begin
   inherited;
   FBarTitleColor:= TColorText.Create;
   FTextColor:=TColorText.Create;
   FTitle:=THTMLText.Create;
   FSubTitle:=THTMLText.Create;
   FHTMLResult:=TstringList.create;
   FLinesPerTable:=50;
   FPages:=tpages.Create(self);
   FTemplateReplace:=TTemplateReplace.Create(self);
   fpage:=tstringlist.create;
   FHTMLTable:=THTMLTable.create;
   FCss:='';
end;
Destructor THTMLExport.destroy;
begin
   FTitle.free;
   FSubTitle.free;
   FHTMLResult.free;
   FBarTitleColor.free;
   FTextColor.free;
   FPages.Free;
   FTemplateReplace.Free;
   fpage.Free;
   FHTMLTable.Free;
   inherited;
end;
Function THTMLExport.Params:integer;
var
   frmParam:THTMLParam;
begin
   frmParam:=THTMLParam.Create(self);
   frmparam.pBarTitle.font.Color:=BarTitleColor.Color;
   frmparam.pBarTitle.color:=BarTitleColor.bgcolor;
   frmparam.PText.Color:=TextColor.bgColor;
   frmparam.PText.font.Color:=TextColor.Color;
   frmparam.txttitle.Font.Color:=title.Color;
   frmparam.txtsubtitle.Font.Color:=subtitle.Color;
   frmparam.txtNombreTabla.text:=HTMLTable.name;
   frmparam.PbgTable.Color:=HTMLTable.bgcolor;
   frmparam.ChkDifferent.Checked:=HTMLTable.Different;
   frmparam.PD1.Color:=HTMLTable.DColor1.bgColor;
   frmparam.PD2.Color:=HTMLTable.DColor2.bgColor;
   frmparam.PD1.Font.Color:=HTMLTable.DColor1.Color;
   frmparam.PD2.Font.Color:=HTMLTable.DColor2.Color;
   frmparam.txtBorder.Text:=inttostr(HTMLTable.border);
   frmparam.pBorder.color:=HTMLTable.bordercolor;
   frmparam.txtpadding.Text:=inttostr(HTMLTable.cellpadding);
   frmparam.txtspacing.Text:=inttostr(HTMLTable.cellspacing);
   frmparam.chk_css.Checked:=not (css='');
   frmparam.txt_css.Text:=css;
   if frmparam.ShowModal=mrok then
   begin
      BarTitleColor.Color:=frmparam.pBarTitle.font.Color;
      BarTitleColor.bgcolor:=frmparam.pBarTitle.color;
      TextColor.bgColor:=frmparam.PText.Color;
      TextColor.Color:=frmparam.PText.font.Color;
      subtitle.Color:=frmparam.txtsubtitle.Font.Color;
      css:=frmparam.txt_css.Text;
      HTMLTable.name:=frmparam.txtNombreTabla.text;
      HTMLTable.bordercolor:=frmparam.pBorder.color;
      HTMLTable.bgcolor:=frmparam.PbgTable.Color;
      HTMLTable.Different:=frmparam.ChkDifferent.Checked;
      HTMLTable.DColor1.bgColor:=frmparam.PD1.Color;
      HTMLTable.DColor2.bgColor:=frmparam.PD2.Color;
      HTMLTable.DColor1.Color:=frmparam.PD1.font.Color;
      HTMLTable.DColor2.Color:=frmparam.PD2.font.Color;
      HTMLTable.border:=strtoint(frmparam.txtBorder.Text);
      HTMLTable.cellpadding:=strtoint(frmparam.txtpadding.Text);
      HTMLTable.cellspacing:=strtoint(frmparam.txtspacing.Text);
      result:=mrok;
   end
   else
      result:=mrcancel;
   frmparam.Free;
end;
procedure THTMLExport.CabeceraTabla(Stringl:TStringList);
var i,index:integer;
    cad:string;
begin
   cad:='';
   if css='' then
   begin
      cad:='<TABLE '+iif(FHTMLTable.name<>'','name="'+FHTMLTable.name+'" ','');
      cad:=cad+iif(FHTMLTable.cellspacing>=0,'cellspacing="'+inttostr(FHTMLTable.cellspacing)+'" ','');
      cad:=cad+iif(FHTMLTable.cellpadding>=0,'cellpadding="'+inttostr(FHTMLTable.cellpadding)+'" ','');
      cad:=cad+iif(FHTMLTable.Border>=0,'border="'+inttostr(FHTMLTable.border)+'" ','');
      cad:=cad+iif(FHTMLTable.bgcolor<>clwindow,'bgcolor="'+colortohtml(FHTMLTable.bgcolor)+'" ','');
      cad:=cad+iif(FHTMLTable.bordercolor<>clwindowtext,'bordercolor="'+colortohtml(FHTMLTable.bordercolor)+'">','>');
      Stringl.Add(cad);
   end
   else
      Stringl.Add('<TABLE class=Table>');
   if css='' then
   begin
      if FBarTitleColor.bgColor<>clWindow then
         Stringl.Add('<TR bgcolor="'+ColorToHtml(FBarTitleColor.bgColor)+'">')
      else
         Stringl.Add('<TR>');
      for i:=0 to table.FieldDefs.Count-1 do
      begin
         IF fields.Locate(table.Fields[i].fieldname,index) then
            Stringl.Add('<TD><B>'+table.FieldDefs[i].DisplayName+'</B></TD>');
      end;
      Stringl.Add('</TR>');
   end
   else
   begin
      stringl.Add('<TR class=HeadTable>');
      for i:=0 to table.FieldDefs.Count-1 do
      begin
         IF fields.Locate(table.Fields[i].fieldname,index) then
            Stringl.Add('<TD>'+table.FieldDefs[i].DisplayName+'</TD>');
      end;
      Stringl.Add('</TR>');
   end;
end;
procedure THTMLExport.CabeceraPagina(Stringl:TStringList);
begin
   Stringl.Add('<!doctype html public "-//w3c//dtd html 4.0 transitional//en">');
   Stringl.Add('<html>');
   Stringl.Add('<head>');
   Stringl.Add('   <meta name="Author" content="">');
   Stringl.Add('   <meta name="GENERATOR" content="Mozilla/4.51 [es]">');
   if CSS<>'' then
      Stringl.add('   <LINK REL="stylesheet" TYPE="text/css" HREF="'+CSS+'">');
   Stringl.Add('</head>');
   Stringl.Add('<CENTER>')
end;
procedure THTMLExport.PiePagina(Stringl:TStringList);
begin
   Stringl.Add('</CENTER>');
   Stringl.Add('</BODY>');
   Stringl.Add('</HTML>');
end;
procedure THTMLExport.PieTabla(Stringl:TStringList);
begin
    Stringl.Add('</TABLE>');
    Stringl.Add('<BR>');
end;

{function THTMLExport.bgColor(color:Tcolor):string;
begin
   if color<>clWindow then
      result:='bgcolor="'+ColorToHtml(color)+'"'
   else
      result:='';
end;
}
function THTMLExport.FontColor(Color:TCOLOR;Dato:string):string;
begin
   if color<>clWindowText then
      result:='<FONT color="'+ColorToHtml(color)+'">'+dato+'</FONT>'
   else
      result:=Dato;
end;
Function THTMLExport.CountPages:Integer;
begin
   result:=Fpages.Count;
end;
Function THTMLExport.GetPage(Index:Integer):TStringList;
var
  i:integer;
begin
   fpage.Clear;
   CabeceraPagina(FPage);
   if (FPages[index].First>0) and  (FPages[index].Last>0) then
      for I:=FPages[index].First to FPages[index].Last do
         Fpage.Add(FHTMLResult.Strings[i])
   else
      Fpage.clear;
   Piepagina(fpage);
   result:=fpage;
end;
//------------------------
Function THTMLExport.GetTemplateAll:TStringList;
var
  i,index:integer;
  tmp:tstringlist;
begin
   tmp:=tstringlist.Create;
   try
      tmp.LoadFromFile(ftemplate);
      fpage.Clear;
      if pos('<!--htmltable-->',tmp.DelimitedText)=0 then
      begin
         showmessage('Plantilla con formato incorrecto');
         fpage.Clear;
      end
      else
      begin
         for index:=0 to fpages.Count-1 do
         if (FPages[index].First>0) and  (FPages[index].Last>0) then
            for I:=FPages[index].First to FPages[index].Last do
               Fpage.Add(FHTMLResult.Strings[i]);
         fpage.Text:=StringReplace(tmp.Text,'<!--htmltable-->',fpage.Text,[]);
         if FTitle.Text<>'' then
         begin
            if css='' then
               fpage.Text:=StringReplace(fpage.Text,'<!--htmltitle-->','<'+Ftitle.SizeName+'>'+Fontcolor(FTitle.Color,Ftitle.Text),[])
            else
               fpage.Text:=StringReplace(fpage.Text,'<!--htmltitle-->','<'+Ftitle.SizeName+' class=Title>'+Ftitle.Text+'</'+Ftitle.SizeName+'>',[]);
         end;
         if FSubTitle.Text<>'' then
         begin
            if css='' then
               fpage.Text:=StringReplace(fpage.Text,'<!--htmlsubtitle-->','<'+FSubtitle.SizeName+'>'+Fontcolor(FSubTitle.Color,FSubtitle.Text),[])
            else
               fpage.Text:=StringReplace(fpage.Text,'<!--htmlsubtitle-->','<'+FSubtitle.SizeName+' class=SubTitle>'+FSubtitle.Text+'</'+FSubtitle.SizeName+'>',[]);
         end;
         if css<>'' then
            fpage.Text:=StringReplace(fpage.Text,'<!--htmlcss-->','"'+css+'"',[])
         else
            fpage.Text:=StringReplace(fpage.Text,'<!--htmlcss-->','""',[]);
         for i:=0 to templatereplace.Count-1 do
            fpage.Text:=StringReplace(fpage.Text,templatereplace.items[i].Variable,templatereplace.items[i].Lines.Text,[]);
     end;
   except
      showmessage('Plantilla :'+ftemplate+' no encontrada');
   end;
   result:=fpage;
   tmp.Free;
end;

//---------------------------
Function THTMLExport.GetTemplatePage(Index:Integer):TStringList;
var
  i:integer;
  tmp:tstringlist;
begin
   tmp:=tstringlist.Create;
   try
      tmp.LoadFromFile(ftemplate);
      fpage.Clear;
      if pos('<!--htmltable-->',tmp.DelimitedText)=0 then
      begin
         showmessage('Plantilla con formato incorrecto');
         fpage.Clear;
      end
      else
      begin
         if (FPages[index].First>0) and  (FPages[index].Last>0) then
            for I:=FPages[index].First to FPages[index].Last do
               Fpage.Add(FHTMLResult.Strings[i]);
         fpage.Text:=StringReplace(tmp.Text,'<!--htmltable-->',fpage.Text,[]);
         if FTitle.Text<>'' then
         begin
            if css='' then
               fpage.Text:=StringReplace(fpage.Text,'<!--htmltitle-->','<'+Ftitle.SizeName+'>'+Fontcolor(FTitle.Color,Ftitle.Text),[])
            else
               fpage.Text:=StringReplace(fpage.Text,'<!--htmltitle-->','<'+Ftitle.SizeName+' class=Title>'+Ftitle.Text+'</'+Ftitle.SizeName+'>',[]);
         end;
         if FSubTitle.Text<>'' then
         begin
            if css='' then
               fpage.Text:=StringReplace(fpage.Text,'<!--htmlsubtitle-->','<'+FSubtitle.SizeName+'>'+Fontcolor(FSubTitle.Color,FSubtitle.Text),[])
            else
               fpage.Text:=StringReplace(fpage.Text,'<!--htmlsubtitle-->','<'+FSubtitle.SizeName+' class=SubTitle>'+FSubtitle.Text+'</'+FSubtitle.SizeName+'>',[]);
         end;
         if css<>'' then
            fpage.Text:=StringReplace(fpage.Text,'<!--htmlcss-->','"'+css+'"',[])
         else
            fpage.Text:=StringReplace(fpage.Text,'<!--htmlcss-->','""',[]);         
     end;
   except
      showmessage('Plantilla :'+ftemplate+' no encontrada');
   end;
   result:=fpage;
   tmp.Free;
end;
procedure THTMLExport.SaveAllToFile(FileName: string;Template:boolean=false);
var
  k:tstringlist;
begin
   if not template then
      FHTMLResult.SaveToFile(filename)
   else
   begin
      k:=tstringlist.Create;
      k.Assign(GetTemplateAll);
      k.SaveToFile(filename);
      k.Free;
   end;
end;
procedure THTMLExport.SavePageToFile(pPage:integer;FileName: string;Template:boolean=false);
var
  k:tstringlist;
begin
   k:=tstringlist.Create;
   if not template then
      k.assign(GetPage(ppage))
   else
      k.Assign(GetTemplatePage(ppage));
   k.SaveToFile(filename);
   k.Free;
end;
procedure THTMLExport.PrintDataField(Field:TField;L:integer);
var cancel:boolean;
    valor:variant;
    formats:string;
    C:tcolor;
begin
   if HTMLTable.Different then
      if (l mod 2)=0 then
        c:=HTMLTable.FDColor1.Color
      else
        c:=HTMLTable.FDColor2.Color
   else
      c:=self.FTextColor.Color;
   valor:=field.value;
   formats:='';
   if Assigned(FOnExportDataField) then
   begin
      if Field.DataType in [ftFloat,ftInteger,ftcurrency,ftSmallint] then
         formats:= TNumericField(field).displayformat;
      FOnExportDataField(Self,field.FieldName,valor,formats, Cancel);
   end;
   if not cancel then
   begin
     case Field.DataType of
          ftstring: if css='' then
                       FHTMLResult.Add('<TD>'+FontColor(c,vartostr(valor))+'</TD>')
                    else
                       FHTMLResult.Add('<TD>'+vartostr(valor)+'</TD>');
          ftfloat: if formats<>'' then
                      if css<>'' then
                          FHTMLResult.Add('<TD align="right">'+formatfloat(formats,varastype(valor,varDouble))+'</TD>')
                      else
                          FHTMLResult.Add('<TD align="right">'+fontcolor(c,formatfloat(formats,varastype(valor,varDouble)))+'</TD>')
                   else
                      if css='' then
                          FHTMLResult.Add('<TD align="right">'+fontcolor(c,vartostr(valor))+'</TD>')
                      else
                          FHTMLResult.Add('<TD align="right">'+vartostr(valor)+'</TD>');
          ftcurrency: if formats<>'' then
                         if css='' then
                             FHTMLResult.Add('<TD align="right">'+fontcolor(c,formatcurr(formats,varastype(valor,varDouble)))+'</TD>')
                         else
                             FHTMLResult.Add('<TD align="right">'+formatcurr(formats,varastype(valor,varDouble))+'</TD>')
                      else
                         if css='' then
                             FHTMLResult.Add('<TD align="right">'+fontcolor(c,vartostr(valor))+'</TD>')
                         else
                             FHTMLResult.Add('<TD align="right">'+vartostr(valor)+'</TD>');
          ftInteger,
          ftSmallint: if formats<>'' then
                         if css='' then
                            FHTMLResult.Add('<TD align="right" >'+fontcolor(c,format(formats,[varastype(valor,varDouble)]))+'</TD>')
                         else
                            FHTMLResult.Add('<TD align="right">'+format(formats,[varastype(valor,varDouble)])+'</TD>')
                      else
                         if css='' then
                            FHTMLResult.Add('<TD align="right" >'+fontcolor(c,vartostr(valor))+'</TD>')
                         else
                            FHTMLResult.Add('<TD align="right">'+vartostr(valor)+'</TD>')
     else
        if css='' then
           FHTMLResult.Add('<TD align="right" >'+fontcolor(c,Field.AsString)+'</TD>')
        else
           FHTMLResult.Add('<TD align="right">'+fontcolor(c,Field.AsString)+'</TD>');
     end;
   end;
end;
procedure THTMLExport.Generate;
var i,j,l,index : integer;
    cancel:boolean;
begin
   if not table.active then exit;
   table.FieldDefs.Update;
   FHTMLResult.Clear;
   FPages.Clear;
   CabeceraPagina(FHTMLResult);
   If FTitle.Text<>'' then
   begin
      if css='' then
         FHTMLResult.Add('<'+Ftitle.SizeName+'>'+Fontcolor(FTitle.Color,Ftitle.Text))
      else
         FHTMLResult.Add('<'+Ftitle.SizeName+' class=Title>'+Ftitle.Text);
      FHTMLResult.Add('</'+Ftitle.SizeName+'>');
   end;
   If FSubTitle.Text<>'' then
   begin
      if css='' then
         FHTMLResult.Add('<'+FSubtitle.SizeName+'>'+FontColor(FSubTitle.Color,FSubtitle.Text))
      else
         FHTMLResult.Add('<'+FSubtitle.SizeName+' class=SubTitle>'+FSubtitle.Text);
      FHTMLResult.Add('</'+FSubtitle.SizeName+'>');
   end;
   l:=0;
   if table.RecordCount>0 then
   begin
      fPages.Add;
      fPages.page[fPages.count-1].first:=FHTMLResult.Count;
      cabeceraTabla(FHTMLResult);
      table.First;
      for i:=0 to table.RecordCount-1 do
      begin
         cancel:=false;
         if assigned(FOnNewRecordBeforeExport) then
            FOnNewRecordBeforeExport(self,table,cancel);
         if not cancel then
         begin
           if Fhtmltable.different then
              if css='' then
                 FHTMLResult.Add('<TR'+iif((l mod 2)=0,' bgcolor="'+colortohtml(fhtmltable.dcolor1.bgColor)+'"',' bgcolor="'+colortohtml(fhtmltable.dcolor2.bgColor)+'"')+'>')
              else
                 FHTMLResult.Add('<TR'+iif((l mod 2)=0,' class=L1',' class=L2')+'>')
           else
              if css='' then
                 FHTMLResult.Add('<TR>')
              else
                 FHTMLResult.Add('<TR'+iif((l mod 2)=0,' class=L1>',' class=L2')+'>');
           for j:=0 to table.FieldDefs.Count-1 do
           begin
              IF fields.Locate(table.Fields[j].fieldname,index) then
                 PrintDataField(table.Fields[j],l);
           end;
        end;
        FHTMLResult.Add('</TR>');
        l:=l+1;
        if (l>linespertable) and (linespertable>0) then
        begin
           PieTabla(FHTMLResult);
           fPages.page[fPages.count-1].last:=FHTMLResult.Count-1;
           fPages.Add;
           fPages.page[fPages.count-1].First:=FHTMLResult.Count;
           cabeceraTabla(FHTMLResult);
           l:=0;
        end;
        table.Next;
      end;
      FHTMLResult.Add('</TABLE>');
   end;
   fPages.page[fPages.count-1].last:=FHTMLResult.Count-1;
   PiePagina(FHTMLResult);
end;
end.
