unit HintStatusBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ComCtrls,dialogs,forms,graphics,igriegaconsts;

type
  THintStatusBar = class(TCustomStatusBar)
  private
     FOrigWindowProc : TWndMethod;
     FForm:TScrollingWinControl;
     FPanel:Integer;
     FTagNumber:Integer;
     FOnHintStatusBar:TNotifyevent;
     Procedure ControlSubClass(var Message:TMessage);
     Procedure SetPanel(Value:Integer);
    { Private declarations }
  protected
    procedure createwnd;override;
    procedure Init(AOwner:TComponent);
    procedure SetCaption(value:String);
    function GetCaption:String;
    { Protected declarations }
  public
    constructor Create(AOwner:TComponent);override;
    Destructor Destroy;override;
    { Public declarations }
  published
    property Panel:Integer read FPanel write SetPanel default -1;
    property Action;
    property AutoHint default False;
    property Align default alBottom;
    property Anchors;
    property BiDiMode;
    property BorderWidth;
    property Color default clBtnFace;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font stored IsFontStored;
    property Constraints;
    property Panels;
    property ParentBiDiMode;
    property ParentColor default False;
    property ParentFont default False;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property SizeGrip default True;
    property UseSystemFont default True;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnHint;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property TagNumber:integer read FTagNumber Write FTagNumber default 900;
    property OnHintStatusBar:TNotifyevent read FOnHintStatusBar write FOnHintStatusBar;
    property Caption:string read GetCaption Write SetCaption;
    { Published declarations }
  end;

implementation

Constructor THintStatusBar.Create(AOwner:TComponent);
begin
   inherited;
   self.SimplePanel:=true;
   FOrigWindowProc:=nil;
   FTagNumber:=HINTTAGNUMBER;
   FPanel:=-1;
   init(AOwner);
end;
procedure THintStatusBar.Init(Aowner:TComponent);
begin
   if not (csDesigning in aowner.ComponentState) then
   begin
      FForm := AOwner as TScrollingWinControl;
      FOrigWindowProc:= fform.WindowProc;
      fform.WindowProc:=ControlSubClass;
   end;
end;
destructor THintStatusBar.Destroy;
begin
   if assigned(FOrigWindowProc) then
   begin
      fForm.WindowProc:=FOrigWindowProc;
      FOrigWindowProc:=nil;
   end;
   inherited;
end;
Procedure THintStatusBar.SetPanel(Value:Integer);
begin
   if value<>FPanel then
   begin
      if (value>=-1) and(((csDesigning in ComponentState) and (value<self.Panels.Count)) or true)then
         begin
            FPanel:=value;
            if Fpanel=-1 then
               self.SimplePanel:=true
            else
               self.SimplePanel:=false;
         end;
   end;
end;
Procedure THintStatusBar.ControlSubClass(var Message:TMessage);
begin
   FOrigWindowProc(message);
   if message.Msg=CM_FOCUSCHANGED then
      if tcmfocuschanged(message).Sender.Tag=TagNumber then
      begin
         if assigned(FOnHintStatusBar) then FOnHintStatusBar(tcmfocuschanged(message).Sender);
         if Panel<0 then
            self.SimpleText:=tcmfocuschanged(message).Sender.Hint
         else
            self.Panels[Panel].Text:=tcmfocuschanged(message).Sender.Hint;
      end
      else
         if Panel<0 then
            self.SimpleText:=''
         else
            self.Panels[Panel].Text:='';
end;
procedure THintStatusBar.createwnd;
begin
   inherited Createwnd;
   self.SimpleText:=self.Name;
end;
procedure THintStatusBar.SetCaption(value:String);
begin
   if self.SimpleText<>value then
   begin
      self.SimpleText:=value;
   end;
end;
function THintStatusBar.getcaption:string;
begin
   result:=self.SimpleText;
end;
end.
