unit HintWindowNew;

interface

uses
  Messages, Windows, Classes, Graphics,
  forms,controls;
type
  THintWindowNew = class(THintWindow)
  private
//procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    function CalcHintRect(MaxWidth: Integer; const AHint: string;
      AData: Pointer): TRect; override;
    property BiDiMode;
    property Caption;
    property Color;
    property Font;
  end;

implementation

{ THintWindowNew }

constructor THintWindowNew.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Color := $80FFFF;
//  Canvas.Font := Screen.HintFont;
  Canvas.Brush.Style := bsClear;
end;

procedure THintWindowNew.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do
  begin
    Style :=WS_POPUP or WS_BORDER;
    WindowClass.Style := WindowClass.Style or CS_SAVEBITS;
    if NewStyleControls then ExStyle := WS_EX_TOOLWINDOW;
    AddBiDiModeExStyle(ExStyle);
  end;
end;

procedure THintWindowNew.Paint;
var
  R: TRect;

begin
  R := ClientRect;
  Inc(R.Left, 50);
  Inc(R.Top, 2);
  Canvas.Font.Color := Screen.HintFont.Color;
  DrawText(Canvas.Handle, PChar(Caption), -1, R, DT_LEFT or DT_NOPREFIX or
    DT_WORDBREAK or DrawTextBiDiModeFlagsReadingOnly);
end;
function THintWindowNew.CalcHintRect(MaxWidth: Integer; const AHint: string; AData: Pointer): TRect;
begin
  Result := Rect(0, 0, MaxWidth, 0);
  DrawText(Canvas.Handle, PChar(AHint), -1, Result, DT_CALCRECT or DT_LEFT or
    DT_WORDBREAK or DT_NOPREFIX or DrawTextBiDiModeFlagsReadingOnly);
  Inc(Result.Right, 50+6);
  Inc(Result.Bottom, 2);
end;


{procedure THintWindowNew.CMTextChanged(var Message: TMessage);
var
   r:trect;
begin
  inherited;
  r:=CalcHintRect(400,Caption,nil);
  width:=r.Right-r.Left+6+50;
  height:=r.Bottom-r.Top+4;
end;}

end.
