unit HotSpotMap;

interface

uses
  Windows, Messages, SysUtils, Classes,Graphics,ExtCtrls,controls,dialogs,
  menus,igriegaStrs,igriegaclasses,Shellapi,ClipBrd;
const
  InkGlassModevalues:array[0..11] of longint=(cmBlackness,cmDstInvert,cmMergeCopy,cmMergePaint,cmNotSrcCopy,
                 cmNotSrcErase,cmSrcAnd,cmSrcCopy,cmSrcErase,cmSrcInvert,cmSrcPaint,cmWhiteness);
  MaxNumberPoints=100;
  MinNumberPoints=0;
type
  TInkGlassMode=(imBlackness,imDstInvert,imMergeCopy,imMergePaint,imNotSrcCopy,
                 imNotSrcErase,imSrcAnd,imSrcCopy,imSrcErase,imSrcInvert,imSrcPaint,imWhiteness);
  TPPoint=class of TPointType; // definido en funciones
  TPPointItem=class(TCustomPointColItem) // definido en funciones;
     published
        property Point;
  end;
  TClickType=(ctEvent,ctLink,ctLinkEvent,ctEventLink);

  TPoly=Class(TCollection)
     private
        FOwner:TPersistent;
        FHint:String;
        FHintColor:TColor;
        FPopupMenu:TPopupMenu;
        FActive:Boolean;
        FCursor:TCursor;
        FLink:TLinkClass;
        function GetItem(Index:Integer):TPPointItem;
        Procedure SetItem(Index:Integer;Value:TPPointItem);
     protected
        function GetOwner:TPersistent;override;
     public
        Constructor Create(Owner:TPersistent);
        Function Add:TPPointItem;
        property Items[Index:Integer]:TPPointItem read Getitem write SetItem; default;
        destructor destroy;override;
     published
        property Hint:String read FHint write FHint;
        property HintColor:TColor read FHintColor write FHintColor default clInfoBk;
        property PopupMenu:TPopupMenu read FPopupMenu write FPopupMenu;
        Property Active:Boolean read FActive write FActive default true;
        property Cursor:TCursor read FCursor Write FCursor default crHandPoint;
        property Link:TLinkClass read FLink write FLink;
  end;

  TPolyItem=class(TCollectionItem)
     private
        FPoly:TPoly;
        FName:String;
        procedure SetName(Value:String);
     protected
        function GetDisplayName: string; override;
     public
        constructor Create(Collection:TCollection);override;
     published
        property Poly:TPoly read FPoly Write FPoly;
        Property Name:String read FName write SetName;
  end;

  TPolys=Class(TCollection)
     private
        FOwner:TPersistent;
        FLoadFrom:TFilename;
        function GetItem(Index:Integer):TPolyItem;
        Procedure SetItem(Index:Integer;Value:TPolyItem);
     protected
        function GetOwner:TPersistent;override;
     public
         Constructor Create(Owner:TPersistent);
         Function Add:TPolyItem;
         property Items[Index:Integer]:TPolyItem read Getitem write SetItem; default;
     published
  end;

  TOnHotClick=procedure(Sender : TObject;Polygon:integer) of object;
  TOnPolygonActive=TOnHotClick;
  THotSpotMap = class(TGraphicControl)
  private
    FPolygons:TPolys;
    FOnHotClick:TOnHotClick;
    FOnPolygonActive:TOnPolygonActive;
    FHintW:THintWindow;
    FPolygon:integer;
    FPicture:TPicture;
    FStretch:Boolean;
    FProportional:Boolean;
    FCenter: Boolean;
    FTransparent:Boolean;
    FFramed:Boolean;
    FFrameSize:Integer;
    FInkColor:TColor;
    FInkGlass:Boolean;
    FInkGlassMode:TInkGlassMode;
    FActive:Boolean;
    FEventOutPolygon:Boolean;
    FClickType:TClickType;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure SetPicture(Value:TPicture);
    function GetPicture:TPicture;
    procedure SetPolygon(Value:Integer);
    procedure SetStretch(Value:Boolean);
    procedure SetProportional(Value:Boolean);
    procedure SetCenter(Value: Boolean);
    procedure SetTransparent(Value:Boolean);
    procedure SetFrameSize(Value:Integer);
    function DestRect: TRect;
    { Private declarations }
  protected
     procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);override;
     procedure MouseMove(Shift: TShiftState; X, Y: Integer);override;
     procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
     procedure Paint; override;
     function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;override;
     procedure InvalidateComp;
     procedure HTMLMap(var L:TStringlist);
    { Protected declarations }
  public
    constructor Create(AOwner:TComponent);override;
    Destructor Destroy;override;
    Function GetNumber(HotSpotName:String):Integer;
    Function GetName(HotSpotNumber:Integer):String;
    Function ByName(HotSpotName:String):TPoly;
    property Polygon:Integer read FPolygon write SetPolygon default -1;
    Property Canvas;
    procedure Draw(N:integer);overload;
    procedure Draw(N:String);overload;
    procedure ExportHTMLMap(Filename:TFilename);
    procedure CopyHTMLMaptoClipboard;
    { Public declarations }
  published
    Property Polygons:TPolys read FPolygons write FPolygons;
    Property OnHotClick:TOnHotClick read FOnHotClick write FOnHotClick;
    Property Picture:TPicture read GetPicture write setpicture;
    property OnPolygonActive:TOnPolygonActive read FOnPolygonActive write FOnPolygonActive;
    property EventOutPolygon:Boolean read FEventOutPolygon write FEventOutPolygon default false;
    property ShowHint;
    property Stretch:Boolean read FStretch write SetStretch;
    property Proportional:Boolean read FProportional write SetProportional;
    property Center: Boolean read FCenter write SetCenter default False;
    property Transparent:Boolean read FTransparent write SetTransparent;
    property Framed:Boolean read FFramed write FFramed default false;
    property FrameSize:Integer read FFrameSize write SetFrameSize default 1;
    property InkColor:TColor read FInkColor write FInkColor default clRed;
    property InkGlass:Boolean read FInkGlass write FInkGlass default false;
    property InkGlassMode:TInkGlassMode read FInkGlassMode write FInkGlassMode default imSrcAnd;
    property Active:Boolean read FActive Write FActive default False;
    property ClickType:TClickType read FClickType write FClickType default ctEvent;
    property Align;
    property Anchors;
    property AutoSize;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property PopupMenu;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;

    { Published declarations }
  end;

implementation
constructor THotSpotMap.Create(AOwner:TComponent);
begin
   inherited;
   ControlStyle := ControlStyle + [csReplicatable]+[csOpaque];
   FPicture:=tpicture.Create;
   FPolygons:=TPolys.Create(self);
   FHintW:=THintWindow.Create(self);
   FPolygon:=-1;
   FEventOutPolygon:=false;
   FFramed:=false;
   FFrameSize:=1;
   FInkColor:=clRed;
   FInkGlass:=False;
   FInkGlassMode:=imSrcAnd;
   FActive:=false;
   FClickType:=ctEvent;   
end;
Destructor THotSpotMap.Destroy;
begin
   Fpicture.Free;
   FPolygons.Free;
   FHintW.Free;
   inherited;
end;
Function THotSpotMap.GetNumber(HotSpotName:String):Integer;
var
   i:integer;
   found:Boolean;
begin
   found:=false;
   for i:=0 to Polygons.Count-1 do
      if uppercase(Polygons.Items[i].Name)=Uppercase(HotSpotName) then
      begin
         found:=true;
         break;
      end;
   if not found then
      i:=-1;
   result:=i
end;
Function THotSpotMap.GetName(HotSpotNumber:Integer):String;
begin
   if (HotSpotNumber>=0) and (HotSpotNumber<=Polygons.Count-1) then
      result:=Polygons.Items[HotSpotNumber].Name
   else
      result:='';
end;
Function THotSpotMap.ByName(HotSpotName:String):TPoly;
var n:integer;
begin
   n:=GetNumber(HotSpotName);
   if n<>-1 then
      result:=Polygons.Items[n].Poly
   else
      result:=nil;
end;
procedure THotSpotMap.InvalidateComp;
begin
   controlstyle:=controlstyle-[csopaque];
   Invalidate;
   controlstyle:=controlstyle+[csopaque];
end;
procedure THotSpotMap.SetFrameSize(Value:Integer);
begin
   if (FFrameSize<>Value) and (Value>0) then
      FFrameSize:=Value;
end;
function THotSpotMap.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := True;
  if not (csDesigning in ComponentState) or (Picture.Width > 0) and
    (Picture.Height > 0) then
  begin
    if Align in [alNone, alLeft, alRight] then
      NewWidth := Picture.Width;
    if Align in [alNone, alTop, alBottom] then
      NewHeight := Picture.Height;
  end;
end;
Procedure THotSpotMap.SetProportional(Value:Boolean);
begin
   if FProportional<>Value then
   begin
      FProportional:=Value;
      InvalidateComp;
   end;
end;
procedure THotSpotMap.SetTransparent(Value:Boolean);
begin
   if FTransparent<>Value then
   begin
      FTransparent:=Value;
      Picture.Graphic.Transparent:=Value;
      InvalidateComp;
   end;
end;
procedure THotSpotMap.SetCenter(Value: Boolean);
begin
  if FCenter <> Value then
  begin
	FCenter := Value;
	InvalidateComp;
  end;
end;
procedure THotSpotMap.SetStretch(Value:Boolean);
begin
   if FStretch<>value then
   begin
       FStretch:=Value;
       InvalidateComp;
   end;
end;
procedure THotSpotMap.Paint;
var
   PolyPoints,PolyPointstmp:array[MinNumberPoints..MaxNumberPoints] of TPoint;
   j:integer;
   nPoints:Integer;
   btmp:TBitmap;
   r:TRect;
   rgn:HRGN;
   B:TBrush;
   P:TPen;
begin
   if csDesigning in ComponentState then
      with Canvas do
      begin
         Pen.Style := psDash;
         Brush.Style := bsClear;
         Rectangle(0, 0, Width, Height);
      end;
   if not Stretch then
      Canvas.Draw(0,0,Picture.Graphic)
   else
      canvas.StretchDraw(DestRect,Picture.Graphic);
   if not(csDesigning in ComponentState) and active then
   begin
      B:=TBrush.Create;
      P:=TPen.Create;
      B.Assign(canvas.Brush);
      P.Assign(canvas.Pen);
      if (FPolyGon<>-1) and (framed or inkglass) then
      begin
         npoints:=Polygons.Items[FPolygon].Poly.Count;
         if npoints>MaxNumberPoints then npoints:=MaxNumberPoints;
         for j:=0 to npoints-1 do
         begin
            PolyPoints[j].X:=Polygons.Items[FPolygon].Poly.Items[j].Point.X;
            PolyPoints[j].Y:=Polygons.Items[FPolygon].Poly.Items[j].Point.Y;
            PolyPointstmp[j].X:=PolyPoints[j].X+Left;
            PolyPointstmp[j].y:=PolyPoints[j].Y+Top;
         end;
         if InkGlass then
         begin
            btmp:=tbitmap.Create;
            rgn:=createpolygonrgn(polypointstmp,npoints,WINDING);
            getrgnbox(rgn,r);
            btmp.Width:=r.Right-r.Left;
            btmp.Height:=r.Bottom-r.Top;
            btmp.Canvas.Brush.Style:=bsSolid;
            btmp.Canvas.Brush.Color:=inkcolor;
            btmp.Canvas.FillRect(rect(0,0,btmp.Width,btmp.Height));
            selectcliprgn(Canvas.Handle,rgn);
            canvas.CopyMode:=InkGlassModevalues[ord(InkGlassMode)];
            Canvas.CopyRect(clientrect,btmp.Canvas,rect(0,0,btmp.Width,btmp.Height));
            canvas.CopyMode:=cmSrcCopy;
            selectcliprgn(Canvas.Handle,0);
            deleteobject(rgn);
            btmp.Free;
         end;
         canvas.Brush.Style:=bsclear;
         if framed then
         begin
            canvas.Pen.Width:=FrameSize;
            canvas.Pen.Mode:=pmNot;
            canvas.Polygon(slice(polypoints,npoints));
         end;
      end;
      canvas.Brush.Assign(B);
      canvas.Pen.Assign(P);
      B.Free;
      P.Free;
   end;
end;
function THotSpotMap.DestRect: TRect;
var
  w, h, cw, ch: Integer;
  xyaspect: Double;
begin
  w := Picture.Width;
  h := Picture.Height;
  cw := ClientWidth;
  ch := ClientHeight;
  if Stretch or (Proportional and ((w > cw) or (h > ch))) then
  begin
	if Proportional and (w > 0) and (h > 0) then
	begin
      xyaspect := w / h;
      if w > h then
      begin
        w := cw;
        h := Trunc(cw / xyaspect);
        if h > ch then  // woops, too big
        begin
          h := ch;
          w := Trunc(ch * xyaspect);
        end;
      end
      else
      begin
        h := ch;
        w := Trunc(ch * xyaspect);
        if w > cw then  // woops, too big
        begin
          w := cw;
          h := Trunc(cw / xyaspect);
        end;
      end;
    end
    else
    begin
      w := cw;
      h := ch;
    end;
  end;

  with Result do
  begin
    Left := 0;
    Top := 0;
    Right := w;
    Bottom := h;
  end;

  if Center then
	OffsetRect(Result, (cw - w) div 2, (ch - h) div 2);
end;
procedure THotSpotMap.Notification(AComponent: TComponent;
      Operation: TOperation);
var
   i:integer;
begin
   inherited;
   if (AComponent.classtype=TPopupMenu) and (Operation=opRemove) then
   begin
      for i:=0 to polygons.count-1 do
         if Polygons[i].Poly.PopupMenu=AComponent then
            Polygons[i].Poly.PopupMenu:=nil;
   end;
end;

procedure THotSpotMap.SetPolygon(Value:Integer);
begin
   if FPolygon<>value then
   begin
      FPolygon:=Value;
      repaint;
      if assigned(FOnPolygonActive) and (((value=-1) and EventOutPolygon) or (value<>-1)) then
         FOnPolygonActive(self,Value)
   end;
end;
procedure THotSpotMap.SetPicture(Value:TPicture);
var
   tmp:TBitmap;
begin
   if value.Graphic<>nil then
   begin
      tmp:=tbitmap.Create;
      Tmp.Width:=value.Width;
      Tmp.Height:=value.Height;
      FPicture.Bitmap.Width:=value.Width;
      FPicture.Bitmap.Height:=value.Height;
      Tmp.Canvas.Draw(0,0,value.Graphic);
      FPicture.Assign(Tmp);
      tmp.Free;
   end
   else
   begin
      Fpicture.Assign(Value);
      Fpicture.Graphic:=nil;
   end;
   InvalidateComp;
end;
function THotSpotMap.getpicture:TPicture;
begin
   result:=FPicture;
end;
procedure THotSpotMap.CMMouseLeave(var Message: TMessage);
begin
  if fhintw.HandleAllocated then
     FHintw.ReleaseHandle;
  if Parent <> nil then
    Parent.Perform(CM_MOUSELEAVE, 0, Longint(Self));
  Polygon:=-1;
end;
procedure THotSpotMap.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var
   HotSpotRgn: HRGN;
   PolyPoints: array[MinNumberPoints..MaxNumberPoints] of TPoint;
   i,j:integer;
   polyfound:boolean;
   npoints:integer;
   punto:tpoint;
//---------------------------------
procedure Click(C:TLinkClass);
var
  oper :string;
  vshow:integer;
  verror:integer;
  mens:string;
begin
  inherited;
  case c.Operation of
     loOpen:Oper:='open';
     loPrint:Oper:='print';
     loExplore:oper:='explore';
  end;
  vshow:=ShowNumber(c.ShowCmd); // ShowNumber definido en igriegaClass.pas
  verror:=shellexecute(Parent.Handle,pchar(oper),pchar(C.filename),pchar(C.parameters),pchar(C.DefaultDir),vshow);
  if verror<=32 then
  begin
     case verror of
        0:mens:='The operating system is out of memory or resources.';
        ERROR_PATH_NOT_FOUND:mens:='The specified path was not found.';
        ERROR_BAD_FORMAT:mens:='The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).';
        SE_ERR_ACCESSDENIED:mens:='The operating system denied access to the specified file.';
        SE_ERR_ASSOCINCOMPLETE:mens:='The filename association is incomplete or invalid.';
        SE_ERR_DDEBUSY:mens:='The DDE transaction could not be completed because other DDE transactions were being processed.';
        SE_ERR_DDEFAIL:mens:='The DDE transaction failed.';
        SE_ERR_DDETIMEOUT:mens:='The DDE transaction could not be completed because the request timed out.';
        SE_ERR_DLLNOTFOUND:mens:='The specified dynamic-link library was not found.';
        SE_ERR_FNF:mens:='The specified file was not found.';
        SE_ERR_NOASSOC:mens:='There is no application associated with the given filename extension.';
        SE_ERR_OOM:mens:='There was not enough memory to complete the operation.';
        SE_ERR_SHARE:mens:='A sharing violation occurred.';
     else
        mens:='Error Unknow';
     end;
     raise Exception.Create(mens);
  end;
end;
//----------------------------------
begin
 if fhintw.HandleAllocated then
    FHintW.ReleaseHandle;
 polyfound:=false;
 if Active then
 begin
 if (assigned(FOnHotClick) and (ssLeft in Shift)) or ((ssRight in Shift)) or (Clicktype=ctLink) then
 begin
   for i:=0 to Polygons.Count-1 do
   begin
      npoints:=Polygons.Items[i].Poly.Count;
      if npoints>MaxNumberPoints then npoints:=MaxNumberPoints;
      for j:=0 to npoints-1 do
      begin
         PolyPoints[j].X:=Polygons.Items[i].Poly.Items[j].Point.X;
         PolyPoints[j].Y:=Polygons.Items[i].Poly.Items[j].Point.Y;
      end;
      HotSpotRgn := CreatePolygonRgn(PolyPoints,npoints, WINDING);
      if PtInRegion(HotSpotRgn, X,Y) then
      begin
         if polygons[i].Poly.Active then
         begin
            if (ssLeft in Shift) then
            begin
               if (Clicktype in [ctLink,ctLinkEvent]) { and (polygons[i].Poly.Link.Filename<>'')} then
                  Click(polygons[i].Poly.Link);
               if (Clicktype in [ctEvent,ctEventLink]) then
                  if assigned(FOnHotClick) then
                     FOnHotClick(self,I);
               if (Clicktype =ctLinkEvent) and assigned(FOnHotClick) then
                  FOnHotClick(self,I);
            end;
            polyfound:=true;
            DeleteObject(HotSpotRgn);
            Polygon:=-1;
            break;
         end
         else
            break;
      end;
      DeleteObject(HotSpotRgn);
   end;
   if not polyfound then
      inherited
   else if (ssRight in Shift) and (Polygons[I].Poly.PopupMenu<>nil) then
        begin
            Repaint;
            punto:=clienttoscreen(point(x,y));
            Polygons[I].Poly.PopupMenu.Popup(punto.X,punto.y);
        end
        else
            inherited;
 end
 else
 inherited;
 end
 else
    inherited;
end;

procedure THotSpotMap.MouseMove(Shift: TShiftState; X, Y: Integer);
var
   HotSpotRgn: HRGN;
   PolyPoints: array[MinNumberPoints..MaxNumberPoints] of TPoint;
   i,j:integer;
   nPoints:Integer;
   R:TRect;
   polyfound:boolean;
   P:TPoint;
begin
 if active then
 begin
 p.X:=X;
 p.Y:=Y;
 polyfound:=false;
 Cursor:=crDefault;
 for i:=0 to Polygons.Count-1 do
 begin
    npoints:=Polygons.Items[i].Poly.Count;
    if npoints>MaxNumberPoints then npoints:=MaxNumberPoints;
      for j:=0 to npoints-1 do
      begin
         PolyPoints[j].X:=Polygons.Items[i].Poly.Items[j].Point.X;
         PolyPoints[j].Y:=Polygons.Items[i].Poly.Items[j].Point.Y;
      end;
    HotSpotRgn := CreatePolygonRgn(PolyPoints,npoints, WINDING);
    if PtInRegion(HotSpotRgn, X, Y) then
    begin
       if Polygons[i].Poly.Active then
       begin
          Cursor:=Polygons[i].Poly.Cursor;
          DeleteObject(HotSpotRgn);
          if ShowHint and (Polygons[i].Poly.Hint<>'') then
          begin
             p:=clienttoscreen(p);
             r:=FHintw.CalcHintRect(200,Polygons[i].Poly.Hint,nil);
             offsetRect(R,p.X,p.y+32);
             FHintW.Color:=Polygons[i].Poly.HintColor;
             FHintW.ActivateHint(R ,Polygons[i].Poly.Hint);
          end;
          polyfound:=true;
          Polygon:=i;
          break;
       end
       else
          break;
    end;
    DeleteObject(HotSpotRgn);
 end;
 if not polyfound then
 begin
     if fhintw.HandleAllocated then
        FHintW.ReleaseHandle;
     Polygon:=-1;
     Cursor:=crDefault;
 end;
 end;
 inherited;
end;

(*constructor TPPoint.Create;
begin
   FX:=0;
   FY:=0;
end;
 *)
(*constructor TPPointitem.Create(Collection:TCollection);
begin
   inherited;
   Fpoint:=TPPoint.Create;
end;
function TPPointItem.GetDisplayName: string;
begin
   result:='Point_'+inttostr(index);
end;
*)

constructor TPoly.Create(Owner:TPersistent);
begin
   inherited Create(TPPointItem);
   Fowner:=owner;
   FHintColor:=clInfoBk;
   FActive:=true;
   FCursor:=crHandPoint;
   Flink:=tlinkclass.Create;
end;
Destructor TPoly.destroy;
begin
   FLink.Free;
   inherited;
end;
procedure THotSpotMap.Draw(N:String);
begin
   Draw(GetNumber(N));
end;
procedure THotSpotMap.Draw(N:integer);
var
   p:array[MinNumberPoints..MaxNumberPoints] of TPoint;
   i:integer;
begin
 if (Polygons.Count>=n) AND (n>=0) then
   if Polygons[n].Poly.Count>0 then
   begin
      for i:=0 to Polygons[n].Poly.Count-1 do
      begin
         p[i].X:=Polygons[n].Poly.Items[i].Point.X;
         p[i].Y:=Polygons[n].Poly.Items[i].Point.Y;
      end;
      canvas.Polygon(slice(p,Polygons[n].Poly.Count));;
   end;
end;
procedure THotSpotMap.HTMLMap(var L:TStringlist);
var
   i,j:integer;
   lin:string;
begin
   if Polygons.Count>0 then
   begin
      try
         L.Add('<IMG src="------image file -------" width="'+inttostr(self.Picture.Width)+'" '+
                'height="'+inttostr(self.Picture.Height)+'" border="0" alt="---- image comment ----" usemap="#'+Name+'">');
         L.Add('<MAP name="'+Name+'">');
         for i:=0 to Polygons.Count-1 do
         begin
            lin:='   <AREA href="---href---" shape="poly" coords="';
            for j:=0 to self.Polygons[i].Poly.Count-1 do
            begin
               lin:=lin+inttostr(self.Polygons[i].Poly[j].Point.X)+','+inttostr(self.Polygons[i].Poly[j].Point.y)+',';
            end;
            L.Add(copy(lin,1,length(lin)-1)+'" alt="'+self.Polygons[i].Poly.Hint+'">');
         end;
         L.Add('</MAP>');
      finally
      end;
   end;
end;
procedure THotSpotMap.CopyHTMLMaptoClipboard;
var
   clip:TClipboard;
   L:TStringList;
begin
   if Polygons.Count>0 then
   begin
      L:=TStringList.Create;
      clip:=tclipboard.Create;
      try
         HTMLMap(L);
         clip.SetTextBuf(l.GetText);
      finally
         L.Free;
         clip.Free;
      end;
   end;
end;
procedure THotSpotMap.ExportHTMLMap(Filename:TFilename);
var
   L:TStringList;
begin
   if Polygons.Count>0 then
   begin
      L:=TStringList.Create;
      try
         HTMLMap(L);
         L.SaveToFile(filename);
      finally
         L.Free;
      end;
   end;
end;
function TPoly.GetItem(Index:Integer):TPPointItem;
begin
   result:=TPPointItem(inherited GetItem(Index));
end;
Procedure TPoly.SetItem(Index:Integer;Value:TPPointItem);
begin
   inherited SetItem(Index,Value);
end;
Function TPoly.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TPoly.Add:TPPointItem;
begin
   result:=TPPointItem(Inherited Add);
end;

constructor TPolyitem.Create(Collection:TCollection);
begin
   inherited;
   Fpoly:=TPoly.Create(self);
   FName:=GetDisplayName;
end;
Procedure TPolyitem.SetName(Value:String);
var
   i:integer;
   found:Boolean;
begin
   found:=false;
   if (FName<>Value) and (Value<>'') then
   begin
      for i:=0 to Collection.Count-1 do
         if uppercase(TPolyItem(Collection.Items[i]).Name)=uppercase(Value) then
         begin
            found:=true;
            break;
         end;
      if not found then
         FName:=Value
      else
         raise exception.Create(sNameUniqueErrMsg);
//         ShowMessage('Name must be unique');
   end;
end;
function TPolyItem.GetDisplayName: string;
begin
   result:='Poly_'+inttostr(index);
end;
constructor TPolys.Create(Owner:TPersistent);
begin
   inherited Create(TPolyItem);
   Fowner:=owner;
   FLoadFrom:='(File)';
end;
function TPolys.GetItem(Index:Integer):TPolyItem;
begin
   result:=TPolyItem(inherited GetItem(Index));
end;
Procedure TPolys.SetItem(Index:Integer;Value:TPolyItem);
begin
   inherited SetItem(Index,Value);
end;
Function TPolys.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TPolys.Add:TPolyItem;
begin
   result:=TPolyItem(Inherited Add);
end;
end.

