unit ImageClick;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  ExtCtrls,imglist,DB,DBTables,DBCtrls,LinkDoc;

type
  TImageClick = class(TImage)
  private
//    FLinkDocC:TLinkDoc;
    FSelected:integer;
    FImageList:TImageList;
    FImageChangeLink: TChangeLink;
    FRotator:boolean;
    procedure SetImageList(value:TImageList);
    procedure ImageListChanged(Sender:TObject);
    { Private declarations }
  protected
    procedure SetSelected(Value:integer); virtual;
    procedure Notification (AComponent: TComponent; Operation: TOperation); override;
    Procedure Click; override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
    function Count:integer;
    { Public declarations }
  published
    property Selected:integer read FSelected write SetSelected;
    Property ImageList:TImageList read FImageList write SetImageList;
    property Rotator:Boolean read FRotator write FRotator;
    property Action;
    { Published declarations }
  end;

Implementation

constructor TImageClick.Create(AOwner: TComponent);
begin
   inherited;
   FRotator:=true;
//   FLinkDocC:=TLinkDoc.create(self);
end;
destructor TImageClick.destroy;
begin
   if assigned(FImageChangeLink) then
      FImageChangeLink.free;
   inherited;
end;
procedure TImageClick.Click;
begin
   if rotator then
      selected:=selected+1;
   inherited;
end;
procedure TImageClick.SetSelected(Value:integer);
var
  t:tbitmap;
begin
   t:=tbitmap.Create;
   if assigned(FImageList) then
   begin
      if (value<0) or (value >= fimagelist.Count) then
         value:=0;
      if value < fimagelist.Count then
      begin
         fimagelist.GetBitmap(value,t);
         picture.Bitmap.Assign(t);
         FSelected:=value;
      end;
   end;
   t.free;
end;
function TImageClick.Count:integer;
begin
   if assigned(FImageList) then
      result:=fimagelist.Count
   else
      result:=-1;
end;
procedure TImageClick.SetImageList(Value:TImageList);
begin
    if FImageList <> Value then
    begin
      if FImageList <> nil then
        FImageList.UnRegisterChanges (FImageChangeLink);
      FImageList := Value;
      if FImageList <> nil then
      begin
        if FImageChangeLink = nil then
        begin
          FImageChangeLink := TChangeLink.Create;
          FImageChangeLink.OnChange := ImageListChanged;
        end;
        FImageList.RegisterChanges (FImageChangeLink);
        FImageList.FreeNotification (Self);
        setselected(fselected);
      end
      else
      begin
        FImageChangeLink.Free;
        FImageChangeLink := nil;
        picture.Bitmap:=nil;
        fimagelist:=nil;
      end
    end
    else
       setselected(fselected);
end;
procedure TImageClick.Notification (AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if Operation = opRemove then
  begin
    if Assigned(FImagelist) and (AComponent = ImageList) then
       ImageList := nil;
  end;
end;
procedure TImageClick.ImageListChanged(Sender:TObject);
begin
   setimagelist(timagelist(sender));
end;

end.
