unit Label3D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Math,funciones;

type
  TShadow = class(TPersistent)
     private
        FColor:Tcolor;
        FVShadow:integer;
        FHShadow:Integer;
        FOnChange:TNotifyEvent;
        FCanWrite:boolean;
        procedure SetColor(value:Tcolor);
        procedure SetVShadow(Value:Integer);
        procedure SetHShadow(Value:Integer);
     protected
        property CanWrite:boolean read fcanwrite write fcanwrite;
     published
        property Color:TColor read FColor write SetColor;
        property VShadow:Integer read FVShadow write SetVShadow;
        property HShadow:Integer read FHShadow write SetHShadow;
     public
        constructor Create;
        property Onchange:TNotifyEvent read FOnChange write FOnchange;
  end;
  TLabel3D = class(TLabel)
  private
     FShadow:TShadow;
     FBevel:TBevelCut;
     procedure SetBevel(Value:TBevelcut);
     procedure SetShadow(value:tshadow);
     procedure RepaintRequest(sender:TObject);
  protected
//     procedure paint; override;
     procedure DoDrawText(var Rect: TRect; Flags: longint); override;
    { Protected declarations }
  public
     constructor Create(AOwner:TComponent);override;
     destructor Destroy;override;
        { Public declarations }
  published
     property Shadow:TShadow read FShadow write SetShadow;
     property Bevel:TBevelCut read FBevel write SetBevel;
    { Published declarations }
  end;

implementation
constructor TShadow.Create;
begin
   inherited;
   FColor:=clwhite;
   FVShadow:=1;
   FHShadow:=1;
   FCanWrite:=true;
end;
procedure TShadow.SetVShadow(Value:Integer);
begin
   if fcanwrite then
   begin
      fvshadow:=value;
      if assigned(fonchange) then fonchange(Self);
   end
   else
      MessageDlg('Los Valores de ''Shadow'' solo se pueden cambiar para ''Bevel''=bvNone', mtError,[mbOk], 0);
end;
procedure TShadow.SetHShadow(Value:Integer);
begin
   if fcanwrite then
   begin
      fHshadow:=value;
      if assigned(fonchange) then fonchange(Self);
   end
   else
      MessageDlg('Los Valores de ''Shadow'' solo se pueden cambiar para ''Bevel''=bvNone', mtError,[mbOk], 0);

end;
procedure TShadow.SetColor(Value:Tcolor);
begin
   if fcanwrite then
   begin
      fcolor:=value;
      if assigned(fonchange) then fonchange(Self);
   end
   else
      MessageDlg('Los Valores de ''Shadow'' solo se pueden cambiar para ''Bevel''=bvNone', mtError,[mbOk], 0);
end;
procedure tlabel3d.DoDrawText(var Rect: TRect; Flags: Longint);
var
   TmpRect1,TmpRect2: TRect;
begin
  canvas.font:=font;
  TmpRect1 := Rect;
  OffsetRect( TmpRect1, Iif(Shadow.HShadow<0,0,Shadow.HShadow),iif(shadow.VShadow<0,0,shadow.VShadow));
  Canvas.Font.color := shadow.Color;
  DrawText(Canvas.Handle, pchar(caption), Length(caption), TmpRect1,Flags);
  TmpRect2 := Rect;
  OffsetRect( TmpRect2, Iif(Shadow.HShadow<0,abs(Shadow.HShadow),0),iif(shadow.VShadow<0,abs(shadow.VShadow),0));
  Canvas.Font.Color := self.font.Color;
  DrawText(Canvas.Handle, pchar(caption), Length(caption), TmpRect2,Flags);
  if autosize then
  begin
     if rect.Right<max(tmprect1.Right,tmprect2.Right) then
        rect.Right:=max(tmprect1.Right,tmprect2.Right);
     if rect.Bottom<max(tmprect1.Bottom,tmprect2.Bottom) then
        rect.Bottom:=max(tmprect1.Bottom,tmprect2.Bottom);
  end;
end;
procedure tlabel3d.SetBevel(Value:TBevelcut);
begin
   fbevel:=value;
   case value of
      bvLowered:
      begin
         shadow.canwrite:=true;
//         font.Color:=clgray;
         shadow.setColor(clWhite);
         shadow.setvshadow(1);
         shadow.sethshadow(1);
         shadow.canwrite:=False;
      end;
      bvRaised, bvSpace:
      begin
         shadow.canwrite:=true;
//         font.Color:=clgray;
         shadow.setColor(clWhite);
         shadow.setvshadow(-1);
         shadow.sethshadow(-1);
         shadow.canwrite:=False;
      end;
      bvNone : shadow.canwrite:=true;
   end;
//   if assigned(fonchange) then fonchange(Self);
end;
Constructor tlabel3d.create(AOwner:TComponent);
begin
   inherited;
   fshadow:=tshadow.Create;
   FBevel:=bvNone;
   fshadow.Onchange:=RepaintRequest;
end;
procedure tlabel3d.RepaintRequest(sender:tobject);
begin
   self.AdjustBounds;
   invalidate;
end;
Destructor tlabel3d.destroy;
begin
   fshadow.free;
   inherited;
end;
{Procedure tlabel3d.paint;
var Rect: TRect;
begin
   rect:=clientrect;
   width:=canvas.TextWidth(self.caption)+abs(shadow.HShadow);
   height:=canvas.TextHeight(self.caption)+abs(shadow.VShadow);
   canvas.font:=self.font;
   canvas.brush.style:= bsClear;
   canvas.FillRect(Rect);
   canvas.Font.Color:=Shadow.Color;
   canvas.textout(Iif(Shadow.HShadow<0,0,Shadow.HShadow),iif(shadow.VShadow<0,0,shadow.VShadow),self.caption);
   canvas.Font:=self.font;
   canvas.textout(Iif(Shadow.HShadow<0,abs(Shadow.HShadow),0),iif(shadow.VShadow<0,abs(shadow.VShadow),0),self.caption);
   Canvas.FrameRect(Rect);
end;}
Procedure tlabel3d.SetShadow(value:tshadow);
begin
   FShadow.assign(value);
end;

end.
