unit LinkDoc;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,Shellapi,Graphics,Dialogs,igriegaClasses;

type

  TLinkDoc = class(TCustomLabel)
  private
    { Private declarations }
    FFileName:TFilename;
    FOperation:TLinkOperation;
    FParameters:String;
    FDefaultDir:String;
    FshowCmd :TShowCmd; // TShowCmd definido en Funciones.pas
  protected
    { Protected declarations }
    procedure Click; override;
  public
    { Public declarations }
    constructor Create(Aowner:TComponent); override;
  published
    property Filename:TFilename read FFilename write FFilename;
    property Operation:TLinkOperation read FOperation write FOperation;
    property Parameters:String read FParameters write FParameters;
    property DefaultDir:String read FDefaultDir write FDefaultDir;
    property ShowCmd:TShowCmd read FShowCmd write FShowCmd;
    property Caption;
    property Font;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnStartDock;
    property OnStartDrag;

    { Published declarations }
  end;

implementation
Constructor TLinkDoc.Create(Aowner:TComponent);
begin
   inherited;
   Cursor:=crHandPoint;
   font.Color:=clHotLight;
   font.Style:=[fsUnderline];
   ShowCmd:=scSHOWNORMAL;
end;
procedure TLinkDoc.Click;
var
  oper :string;
  vshow:integer;
  verror:integer;
  mens:string;
begin
  inherited;
  case operation of
     loOpen:Oper:='open';
     loPrint:Oper:='print';
     loExplore:oper:='explore';
  end;
  vshow:=ShowNumber(ShowCmd); // ShowNumber definido en igriegaClass.pas
  verror:=shellexecute(Parent.Handle,pchar(oper),pchar(filename),pchar(parameters),pchar(DefaultDir),vshow);
  if verror<=32 then
  begin
     case verror of
        0:mens:='The operating system is out of memory or resources.';
        ERROR_PATH_NOT_FOUND:mens:='The specified path was not found.';
        ERROR_BAD_FORMAT:mens:='The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).';
        SE_ERR_ACCESSDENIED:mens:='The operating system denied access to the specified file.';
        SE_ERR_ASSOCINCOMPLETE:mens:='The filename association is incomplete or invalid.';
        SE_ERR_DDEBUSY:mens:='The DDE transaction could not be completed because other DDE transactions were being processed.';
        SE_ERR_DDEFAIL:mens:='The DDE transaction failed.';
        SE_ERR_DDETIMEOUT:mens:='The DDE transaction could not be completed because the request timed out.';
        SE_ERR_DLLNOTFOUND:mens:='The specified dynamic-link library was not found.';
        SE_ERR_FNF:mens:='The specified file was not found.';
        SE_ERR_NOASSOC:mens:='There is no application associated with the given filename extension.';
        SE_ERR_OOM:mens:='There was not enough memory to complete the operation.';
        SE_ERR_SHARE:mens:='A sharing violation occurred.';
     else
        mens:='Error Unknow';
     end;
     raise Exception.Create(mens);
  end;
end;
end.
