unit LockKeys;

interface

uses
  Windows, Messages, SysUtils, Classes,ExtCtrls,ComCtrls,dialogs,funciones;
type
  TLockKeyChange=procedure(Sender:TObject;Key:byte) of object;
  TLockKeys = class;
  TKeyPanel=Class(TPersistent)
     private
        FNumKey:Integer;
        FCapkey:Integer;
        FScrollKey:integer;
        FInsertKey:integer;
        FParent:TLockKeys;
        procedure SetPanel(Index: Integer; Value: integer);
     public
        constructor Create(Aowner:TLockKeys);
     published
        property NumKey:Integer index 0 read FNumKey Write SetPanel default -1;
        property Capkey:Integer index 1 read FCapkey Write SetPanel default -1;
        property ScrollKey:Integer index 2 read FScrollKey Write SetPanel default -1;
        property InsertKey:Integer index 3 read FInsertKey Write SetPanel default -1;
  end;
  TKeyText=Class(TPersistent)
     private
        FNumKey:String;
        FCapkey:String;
        FScrollKey:String;
        FInsertKey:String;
     public
        constructor Create;overload;
        Constructor Create(Num,Cap,Scr,ins:String);overload;
     published
         property NumKey:String read FNumKey write FNumKey;
         property CapKey:String read FCapKey write FCapKey;
         property ScrollKey:String read FScrollKey write FScrollKey;
         property InsertKey:String read FInsertKey write FInsertKey;
  end;
  TLockKeys = class(tcomponent)
  private
    FTimer:TTimer;
    FPanels:TKeyPanel;
    FStatusBar:TCustomStatusBar;
    FTextOn:TKeyText;
    FTextOff:TKeyText;
    FInterval:Integer;
    FActive:Boolean;
    FNumKey:Boolean;
    FCapkey:Boolean;
    FScrKey:Boolean;
    FInsKey:Boolean;
    FOnChange:TLockKeyChange;
    FFirst:Boolean;
    procedure SetNumLock(Value:Boolean);
    procedure SetCapLock(Value:Boolean);
    procedure SetScrLock(Value:Boolean);
    procedure SetInsLock(Value:Boolean);
    Function GetNumLock:Boolean;
    Function GetCapLock:Boolean;
    Function GetScrLock:Boolean;
    Function GetInsLock:Boolean;
    Procedure SetInterval(Value:Integer);
    procedure OnTimer(Sender:TObject);
    Procedure SetActive(Value:Boolean);
    { Private declarations }
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    { Protected declarations }
  public
     Constructor Create(AOwner:TComponent);override;
     Destructor Destroy;override;
     Property NumLock:Boolean read GetNumLock write SetNumLock;
     Property CapLock:Boolean read GetCapLock write SetCapLock;
     Property ScrLock:Boolean read GetScrLock write SetScrLock;
     Property InsLock:Boolean read GetInsLock write SetInsLock;
     Property Active:Boolean read FActive write SetActive default false;
    { Public declarations }
  published
     property TextOn:TKeyText read FTextOn write FTextOn;
     property TextOff:TKeyText read FTextOff write FTextOff;
     property Panels:TKeyPanel read FPanels write FPanels;
     property StatusBar:TCustomStatusBar read FStatusBar write FStatusBar;
     property Interval:Integer read FInterval Write SetInterval default 250;
     property OnChange:TLockKeyChange read FOnChange write FOnChange;
    { Published declarations }
  end;

procedure Register;

implementation
constructor TKeyPanel.Create(AOwner:TLockKeys);
begin
   FParent:=AOwner;
   FNumKey:=-1;
   FCapKey:=-1;
   FScrollKey:=-1;
   FInsertKey:=-1;

end;
procedure TKeyPanel.SetPanel(Index: Integer; Value: integer);
begin
   if (value>=-1) then
      case index of
         0:FNumKey:=Value;
         1:FCapKey:=Value;
         2:FScrollKey:=Value;
         3:FInsertKey:=Value;
      end;
end;
constructor TKeyText.Create;
Begin
end;
Constructor TKeyText.Create(Num,Cap,Scr,ins:String);
begin
   FNumKey:=Num;
   FCapkey:=Cap;
   FScrollKey:=Scr;
   FInsertKey:=Ins;
end;
Constructor TLockKeys.Create(Aowner:TComponent);
var
   KeyBoard: TKeyboardState;
begin
   inherited;
   FTimer:=TTimer.Create(self);
   FTimer.Name:='Timer';
   FTimer.Enabled:=false;
   FInterval:=250;
   FTimer.Interval:=FInterval;
   FTimer.OnTimer:=OnTimer;
   FActive:=false;
   FTextOn:=TKeyText.Create('Num','Cap','Scr on','Ins');
   FTextOff:=TKeyText.Create('','','Scr off','Ovr');
   FPanels:=TKeyPanel.Create(Self);
   GetKeyboardState(KeyBoard);
   FInsKey:=not(KeyBoard[VK_INSERT]=1);
   FNumKey:=not(KeyBoard[VK_NUMLOCK]=1);
   FScrKey:=not(KeyBoard[VK_SCROLL]=1);
   FCapKey:=not(KeyBoard[VK_CAPITAL]=1);
   FFirst:=true;
end;
Destructor TLockKeys.Destroy;
begin
   FTimer.Free;
   inherited;
end;
Procedure TLockKeys.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FStatusBar <> nil) and (acomponent=FStatusBar) then
     FStatusBar := nil;
end;
Procedure TLockKeys.SetNumLock(Value:Boolean);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   KeyBoard[VK_NUMLOCK]:=iif(Value,1,0);
   SetKeyboardState(KeyBoard);
end;
Function TLockKeys.GetNumLock:Boolean;
begin
   result:=GetKeyState(VK_NUMLOCK)=1;
end;
Procedure TLockKeys.SetCapLock(Value:Boolean);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   KeyBoard[VK_CAPITAL]:=iif(Value,1,0);
   SetKeyboardState(KeyBoard);
end;
Function TLockKeys.GetCapLock:Boolean;
begin
   result:=GetKeyState(VK_CAPITAL)=1;
end;
Procedure TLockKeys.SetScrLock(Value:Boolean);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   KeyBoard[VK_SCROLL]:=iif(Value,1,0);
   SetKeyboardState(KeyBoard);
end;
Function TLockKeys.GetScrLock:Boolean;
begin
   result:=GetKeyState(VK_SCROLL)=1;
end;
Procedure TLockKeys.SetInsLock(Value:Boolean);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   KeyBoard[VK_INSERT]:=iif(Value,1,0);
   SetKeyboardState(KeyBoard);
end;
Function TLockKeys.GetInsLock:Boolean;
begin
   result:=GetKeyState(VK_INSERT)=1;
end;
Procedure TLockKeys.SetInterval(Value:Integer);
begin
   if FInterval<>Value then
   begin
      FInterval:=Value;
      ftimer.Interval:=FInterval;
   end;
end;
procedure TLockKeys.OnTimer(Sender:TObject);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   if FNumkey<>(KeyBoard[VK_NUMLOCK]=1) then
   begin
      FNumKey:=KeyBoard[VK_NUMLOCK]=1;
      if (panels.NumKey>-1) and assigned(FStatusBar) then
         if panels.NumKey<=(FStatusBar.Panels.Count-1) then
               StatusBar.Panels[panels.NumKey].Text:=iif(FNumKey,TextOn.NumKey,TextOff.NumKey);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_NUMLOCK);
   end;
   if FCapKey<>(KeyBoard[VK_CAPITAL]=1) then
   begin
      FCapKey:=KeyBoard[VK_CAPITAL]=1;
      if (panels.CapKey>-1) and assigned(FStatusBar) then
         if panels.CapKey<=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[panels.CapKey].Text:=iif(FCapKey,TextOn.CapKey,TextOff.CapKey);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_CAPITAL);
   end;
   if FInsKey<>(KeyBoard[VK_INSERT]=1) then
   begin
      FInsKey:=KeyBoard[VK_INSERT]=1;
      if (panels.InsertKey>-1) and assigned(FStatusBar) then
         if panels.InsertKey<=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[panels.InsertKey].Text:=iif(FInsKey,TextOn.InsertKey,TextOff.InsertKey);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_INSERT);
   end;
   if FScrKey<>(KeyBoard[VK_SCROLL]=1) then
   begin
      FScrKey:=KeyBoard[VK_SCROLL]=1;
      if (panels.ScrollKey>-1) and assigned(FStatusBar) then
         if panels.ScrollKey<=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[panels.ScrollKey].Text:=iif(FScrKey,TextOn.ScrollKey,TextOff.ScrollKey);
      if assigned(FOnchange) and not FFirst  then
         FOnChange(Self,VK_SCROLL);
   end;
   FFirst:=False;
end;
Procedure TLockKeys.SetActive(Value:Boolean);
begin
   if FActive<>Value then
   begin
      Factive:=Value;
      Ftimer.Enabled:=Value;
   end;
end;
procedure Register;
begin
  RegisterComponents('i-vcl Non-Visual', [tLockKeys]);
end;

end.
