unit Log;

interface

uses
  Windows, Messages, SysUtils, Classes,dialogs,forms,logviewer,funciones,typinfo,controls,graphics;
{const
   cError=clRed;
   cInfo=clBlue;
   cSingle=clBlack;
   cValue=clGreen;}
type
  TOpenFile=(foAppend,foCreate,foNone);
  TMessageColors=class(TPersistent)
     private
       FError,
       FInfo,
       FSingle,
       FValue:TColor;
     public
     constructor Create;
     published
        property Error:TColor Read FError write FError;
        property Info:TColor Read FInfo write FInfo;
        property Single:TColor Read FSingle write FSingle;
        property Value:TColor Read FValue write FValue;
  end;
  TLog = class(TComponent)
  private
    FContent:TstringList;
    FFileName:TLogFileName;
    FFile:Text;
    FOpen:TOpenFile;
    FMemory:Boolean;
    FViewer:Boolean;
    FActive:Boolean;
    FMessageColors:TMessageColors;
    FDateTimeMask:TFormatMask;
    FForm:Tfrmviewer;
    FOnActivate:TNotifyEvent;
    FOnDeActivate:TNotifyEvent;
    procedure SetActive(Value:Boolean);
    procedure SetViewer(Value:Boolean);
    procedure SetOpen(Value:TOpenFile);
    procedure SetMemory(Value:Boolean);
    { Private declarations }
  protected
    { Protected declarations }
  public
     Constructor Create(Aowner:TComponent);override;
     destructor Destroy;override;
     procedure Error(msg:string);
     procedure Info(msg:string);
     procedure Single(msg:String);overload;
     procedure Single(msg:String;Color:TColor);overload;     
     procedure PropValue(Obj:TObject;prop:String); overload;
     procedure PropValue(prop:String);overload;
     Function View:TStringlist;
     procedure ClearView;
     Property Active:Boolean read FActive write SetActive default False;
    { Public declarations }
  published
     property MessageColors:TMessageColors read FMessageColors write FMessageColors;
     property FileName:TLogFileName read FFileName write FFileName;
     Property Open:TOpenFile read FOpen write SetOpen default foNone;
     property Memory:Boolean read FMemory write SetMemory default True;
     property Viewer:Boolean read FViewer write SetViewer default False;
     property DateTimeMask:TFormatMask read FDateTimeMask write FDateTimeMask;
     property OnActive:TNotifyEvent read FOnActivate write FOnActivate;
     property OnDeActive:TNotifyEvent read FOnDeactivate write FOnDeactivate;
    { Published declarations }
  end;
procedure Register;

implementation
constructor TMessageColors.Create;
begin
   FError:=clRed;
   FInfo:=clBlue;
   FSingle:=clBlack;
   FValue:=clGreen;
end;
Constructor TLog.Create(Aowner:TComponent);
begin
   inherited;
   FActive:=false;
   FMemory:=True;
   FOpen:=foNone;
   FDateTimeMask:='dd/mm/yyyy hh:nn:ss:zzz';
   FContent:=TStringList.Create;
   FMessageColors:=TMessageColors.Create;
end;
Destructor TLog.Destroy;
begin
   if FActive then
      Active:=false;
   FContent.Free;
   inherited;
end;
procedure TLog.SetMemory(Value:Boolean);
begin
   if FMemory<>Value then
   begin
      if value then
         Open:=foNone;
      if Active then Active:=false;
      FMemory:=Value;
   end;
end;
procedure TLog.SetOpen(Value:TOpenFile);
begin
   if FOpen<>Value then
   begin
      if FMemory then FMemory:=False;
      if Active then Active:=false;
      FOpen:=Value;
   end;
end;
procedure TLog.Error(msg:string);
begin
   if viewer then
      FForm.Memo.SelAttributes.Color:=FMessageColors.Error;
   if FActive then
   if FMemory then
   begin
      FContent.Add(format('ERROR %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      if viewer then
         FForm.Memo.Lines.Add(format('ERROR %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
   end
   else
   begin
      try
         writeln(FFile,format('ERROR %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
         if viewer then
            FForm.Memo.Lines.Add(format('ERROR %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      except
      end;
   end;
end;
procedure TLog.Single(msg:String;Color:TColor);
begin
   if Factive then
   begin
      if FMemory then
         FContent.Add(msg)
      else
      begin
         try
            writeln(FFile,msg);
         except
         end;
      end;
      if viewer then
      begin
         FForm.Memo.SelAttributes.Color:=Color;
         FForm.Memo.Lines.Add(msg);
      end;
   end;
end;
procedure TLog.Single(msg:string);
begin
{   if viewer then
      FForm.Memo.SelAttributes.Color:=csingle;}
   if Factive then
   begin
      if FMemory then
         FContent.Add(msg)
      else
         try
            writeln(FFile,msg);
         except
         end;
      if viewer then
      begin
         FForm.Memo.SelAttributes.Color:=FMessageColors.Single;
         FForm.Memo.Lines.Add(msg);
      end;
   end;
end;
procedure TLog.Info(msg:string);
begin
   if viewer then
      FForm.Memo.SelAttributes.Color:=FMessageColors.Info;
   if Factive then
   if FMemory then
   begin
      FContent.Add(format('%s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      if viewer then
         FForm.Memo.Lines.Add(format('%s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
   end
   else
   begin
      try
         writeln(FFile,format('%s ---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
         if viewer then
            FForm.Memo.Lines.Add(format('%s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      except
      end;
   end;
end;
procedure TLog.PropValue(Obj:TObject;prop:String);
var
   msg:String;
begin
   if viewer then
      FForm.Memo.SelAttributes.Color:=FMessageColors.Value;
   msg:=prop+'='+getpropvalue(obj,prop,true);
   if Factive then
   if FMemory then
   begin
      FContent.Add(format('VALUE '+tcontrol(obj).Name+' %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      if viewer then
         FForm.Memo.Lines.Add(format('VALUE '+tcontrol(obj).Name+' %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
   end
   else
   begin
      try
         writeln(FFile,format('VALUE '+tcontrol(obj).Name+' %s ---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
         if viewer then
            FForm.Memo.Lines.Add(format('VALUE '+tcontrol(obj).Name+' %s :---[%s]---',[formatdatetime(Fdatetimemask,Now),msg]));
      except
      end;
   end;
end;
procedure TLog.PropValue(prop:String);
var
   msg:String;
   i:integer;
begin
   single('VALUES '+prop+' ['+formatdatetime(Fdatetimemask,Now)+']',fmessagecolors.Value);
   for i:=0 to TwinControl(self.Owner).ComponentCount-1 do
   begin
      if typinfo.GetPropInfo(TwinControl(self.Owner).Components[i],prop)<>nil then
         msg:='   '+TwinControl(self.Owner).Components[i].Name+'='+getpropvalue(TwinControl(self.Owner).Components[i],prop,true)
      else
         msg:='';
      if msg<>'' then
         single(msg,FMessageColors.Value);
   end;
end;

Function TLog.View:TStringList;
begin
   if FMemory then
      result:=FContent
   else
   begin
      FContent.LoadFromFile(FFilename);
      result:=FContent;
   end;
end;
procedure TLog.ClearView;
begin
   FContent.Clear;
   If Viewer then
      FForm.Memo.Clear;
end;
procedure TLog.SetActive(Value:Boolean);
begin
   if Value<>FActive then
      if Value then
      begin
         if assigned(FOnactivate) then
            FOnActivate(self);
         if FOpen<>foNone then
         begin
            if FFileName='' then
               FFilename:=FileTempCurrent('LOG_');
            assignfile(FFile,FFilename);
            try
            case FOpen of
               foAppend: append(FFile);
               foCreate: rewrite(FFile);
            end;
            FActive:=true;
            Single('Begin LOG '+application.ExeName+'['+formatdatetime(Fdatetimemask,Now)+']');
            except
               showmessage('No se puede Abrir/Crear el fichero');
               FActive:=False;
            end;
         end
         else
         begin
            FActive:=value;
            Single('Begin LOG '+application.ExeName+'['+formatdatetime(Fdatetimemask,Now)+']');
         end;
      end
      else
      begin
         if not fmemory then
            try
               Single('End LOG '+application.ExeName+'['+formatdatetime(Fdatetimemask,Now)+']');
               FActive:=False;
               close(FFile);
            except
               Showmessage('No se puede cerrar el fichero');
               FActive:=true;
            end
         else
         begin
            Single('End LOG'+application.ExeName+'['+formatdatetime(Fdatetimemask,Now)+']');
            FActive:=Value;
         end;
         if not FActive and assigned(FOnDeActivate) then
            FOnDeActivate(self);
      end;
end;
procedure TLog.SetViewer(Value:Boolean);
begin
   if (Value<>FViewer) then
      if Value then
      begin
         FForm:=TfrmViewer.Create(self);
         FForm.Caption:='LOG :'+application.ExeName;
         FForm.Show;
         FViewer:=true;
      end
      else
      begin
         FViewer:=false;
         FForm.FCerrar:=true;
         FForm.Destroy;
      end;
end;

procedure Register;
begin
  RegisterComponents('i-vcl Non-Visual', [TLog]);
end;

end.
