unit NLockKeys;

interface

uses
  Windows, Messages, SysUtils, Classes,ExtCtrls,ComCtrls,dialogs,funciones;
type
  TNLockKeyChange=procedure(Sender:TObject;Key:byte) of object;
  TNLockKeys = class;
  TNLockKey=Class(TPersistent)
  private
     FTextOn:String;
     FTextOff:String;
     FPanel:Integer;
     FKey:Byte;
     FName:String;
     procedure SetLocked(Value:Boolean);
     function GetLocked:Boolean;
     procedure SetPanel(Value: integer);
  public
     Constructor Create(vKey:Byte;vName:String;VOn:String='';VOff:String='');
     Property Locked:Boolean read GetLocked Write SetLocked;
     property Key:Byte read FKey;
     Property Name:String Read FName;     
  published
     Property TextOn:String read FTextOn write FTextOn;
     Property TextOff:String read FTextOff write FTextOff;
     Property Panel:Integer read FPanel write SetPanel;
  end;
  TNLockKeys = class(tcomponent)
  private
    FTimer:TTimer;
    FStatusBar:TCustomStatusBar;
    FInterval:Integer;
    FActive:Boolean;
    FNumKey:Boolean;
    FCapkey:Boolean;
    FScrKey:Boolean;
    FInsKey:Boolean;
    FOnChange:TNLockKeyChange;
    FFirst:Boolean;
    FNum:TNLockKey;
    FIns:TNLockKey;
    FCaps:TNLockKey;
    FScr:TNLockKey;
    Procedure SetInterval(Value:Integer);
    procedure OnTimer(Sender:TObject);
    Procedure SetActive(Value:Boolean);
    { Private declarations }
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    { Protected declarations }
  public
     Constructor Create(AOwner:TComponent);override;
     Destructor Destroy;override;
     Property Active:Boolean read FActive write SetActive default false;
    { Public declarations }
  published
     property StatusBar:TCustomStatusBar read FStatusBar write FStatusBar;
     property Interval:Integer read FInterval Write SetInterval default 250;
     property NumLock:TNLockKey read FNum Write FNum;
     property InsLock:TNLockKey read FIns Write FIns;
     property CapsLock:TNLockKey read FCaps Write FCaps;
     property ScrLock:TNLockKey read FScr Write FScr;
     property OnChange:TNLockKeyChange read FOnChange write FOnChange;
    { Published declarations }
  end;

procedure Register;

implementation

Constructor TNLockKey.Create(vKey:Byte;vName:String;VOn:String='';VOff:String='');
begin
   FKey:=vKey;
   FTextOn:=vOn;
   FTextOff:=vOff;
   FName:=vName;
   FPanel:=-1;
end;
procedure TNLockKey.SetPanel( Value: integer);
begin
   if (value>=-1) and (Value<>FPanel) then
      FPanel:=Value;
end;
Function TNLockKey.GetLocked:Boolean;
begin
   result:=(odd(GetKeyState(FKey)));
end;
Procedure TNLockKey.SetLocked(Value:Boolean);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   KeyBoard[self.FKey]:=iif(Value,1,0);
   SetKeyboardState(KeyBoard);
end;
Constructor TNLockKeys.Create(Aowner:TComponent);
var
   KeyBoard: TKeyboardState;
begin
   inherited;
   FTimer:=TTimer.Create(self);
   FTimer.Name:='Timer';
   FTimer.Enabled:=false;
   FInterval:=250;
   FTimer.Interval:=FInterval;
   FTimer.OnTimer:=OnTimer;
   FActive:=false;
   GetKeyboardState(KeyBoard);
   FInsKey:=not(KeyBoard[VK_INSERT]=1);
   FNumKey:=not(KeyBoard[VK_NUMLOCK]=1);
   FScrKey:=not(KeyBoard[VK_SCROLL]=1);
   FCapKey:=not(KeyBoard[VK_CAPITAL]=1);
   FFirst:=true;
   FCaps:=tNLockKey.Create(vk_capital,'Capitals','Cap');
   FNum:=tNLockKey.Create(VK_NUMLOCK,'NumLock','Num');
   FScr:=tNLockKey.Create(VK_SCROLL,'Scroll','SCR ON','SCR OFF');
   FIns:=tNLockKey.Create(VK_INSERT,'Insert','Ins','Ovr');
end;
Destructor TNLockKeys.Destroy;
begin
   FTimer.Free;
   inherited;
end;
Procedure TNLockKeys.Notification(AComponent: TComponent;Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FStatusBar <> nil) and (acomponent=FStatusBar) then
     FStatusBar := nil;
end;

Procedure TNLockKeys.SetInterval(Value:Integer);
begin
   if FInterval<>Value then
   begin
      FInterval:=Value;
      ftimer.Interval:=FInterval;
   end;
end;
procedure TNLockKeys.OnTimer(Sender:TObject);
var
   KeyBoard: TKeyboardState;
begin
   GetKeyboardState(KeyBoard);
   if FNumkey<>(KeyBoard[VK_NUMLOCK]=1) then
   begin
      FNumKey:=KeyBoard[VK_NUMLOCK]=1;
      if (numlock.Panel>-1) and assigned(FStatusBar) then
         if numlock.Panel<=(FStatusBar.Panels.Count-1) then
               StatusBar.Panels[numlock.Panel].Text:=iif(FNumKey,numlock.TextOn,numlock.TextOff);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_NUMLOCK);
   end;
   if FCapKey<>(KeyBoard[VK_CAPITAL]=1) then
   begin
      FCapKey:=KeyBoard[VK_CAPITAL]=1;
      if (CapsLock.Panel>-1) and assigned(FStatusBar) then
         if CapsLock.Panel <=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[CapsLock.Panel].Text:=iif(FCapKey,CapsLock.TextOn,CapsLock.TextOff);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_CAPITAL);
   end;
   if FInsKey<>(KeyBoard[VK_INSERT]=1) then
   begin
      FInsKey:=KeyBoard[VK_INSERT]=1;
      if (InsLock.Panel>-1) and assigned(FStatusBar) then
         if InsLock.Panel<=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[InsLock.Panel].Text:=iif(FInsKey,InsLock.TextOn,InsLock.TextOff);
      if assigned(FOnchange) and not FFirst then
         FOnChange(Self,VK_INSERT);
   end;
   if FScrKey<>(KeyBoard[VK_SCROLL]=1) then
   begin
      FScrKey:=KeyBoard[VK_SCROLL]=1;
      if (ScrLock.Panel>-1) and assigned(FStatusBar) then
         if ScrLock.Panel<=(FStatusBar.Panels.Count-1) then
            StatusBar.Panels[ScrLock.Panel].Text:=iif(FScrKey,ScrLock.TextOn,ScrLock.TextOff);
      if assigned(FOnchange) and not FFirst  then
         FOnChange(Self,VK_SCROLL);
   end;
   FFirst:=False;
end;
Procedure TNLockKeys.SetActive(Value:Boolean);
begin
   if FActive<>Value then
   begin
      Factive:=Value;
      Ftimer.Enabled:=Value;
   end;
end;
procedure Register;
begin
  RegisterComponents('i-vcl Non-Visual', [tNLockKeys]);
end;

end.
