unit Newpanel;

interface
uses
  Windows, Messages, SysUtils,stdCtrls, Classes, Graphics, Controls, Forms, Dialogs,ExtCtrls,MMSystem,math;
type
  TBevelNew = (bnNone, bnLowered, bnRaised,bnLoweredline,bnRaisedLine);
  TTitleTextAlign = (ttLeft,ttCenter,ttRight);
  TTitleAlign = (taTop,taBottom);
  TShapeNew = (tsRect,tsRectRound);
  TPanelN = class(TCustomPanel)
  public
    property DockManager;
  published
    property Align;
    property Alignment;
    property Anchors;
    property AutoSize;
    property BevelOuter;
    property BiDiMode;
    property BorderWidth;
    property Constraints;
    property UseDockManager default True;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FullRepaint;
    property Font;
    property Locked;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

   tNewPanel=class(TPanelN)
      private
         procedure DrawParentImage (Control: TControl; Dest: TCanvas);
         procedure WMSize(var Message: TWMSize); message WM_SIZE;
         procedure WMMove(var Message: TWMMove); message WM_MOVE;
      public
         constructor Create(AOwner:TComponent);override;
      protected
         procedure Paint; override;
   end;
  TTitle=class(TPersistent)
     private
         FBkColor:TColor;
         FHeight:integer;
         FTextAlign:TTitleTextAlign;
         FAlign:TTitleAlign;
         FBorder:Boolean;
         FBevel:TBevelNew;
         FSeparation:integer;
         FShape:TShapeNew;
         FArc:Integer;
         FWidth:Integer;
         FHighLightColor:TColor;
         FShadowColor:Tcolor;
         FOffSet:Integer;
         fOnChange:TNotifyEvent;
         procedure SetBkColor(value:tcolor);
         Procedure SetHeight(value:integer);
         procedure SetTextAlign(value:TTitleTextAlign);
         procedure SetAlign(value:TTitleAlign);
         Procedure SetBorder(Value:boolean);
         Procedure SetBevel(Value:TBevelNew);
         Procedure SetSeparation(Value:Integer);
         Procedure SetShape(Value:TShapeNew);
         Procedure SetArc(Value:Integer);
         Procedure SetShadowColor(Value:TColor);
         Procedure SetHighLightColor(Value:TColor);
         Procedure SetWidth(Value:integer);
         Procedure SetOffSet(Value:integer);
     public
         Constructor Create;
         property Onchange:TNotifyEvent read fOnChange write fOnChange;
     published
         Property Offset:Integer read FOffSet write SetOffSet;
         property Width:integer read FWidth write SetWidth;
         Property HighLightColor:TColor read FHighLightColor write SetHighLightColor;
         Property ShadowColor:Tcolor read FShadowColor write setShadowColor;
         Property Arc:Integer read FArc write SetArc;
         Property Shape:TShapeNew read FShape write SetShape;
         Property Separation:Integer read FSeparation Write SetSeparation;
         Property Bevel:TBevelNew read FBevel write SetBevel;
         Property Border:boolean read FBorder Write SetBorder;
         property TextAlign:TTitleTextAlign read FTextAlign write SetTextAlign;
         property Align:TTitleAlign read FAlign write SetAlign;
         Property Height:integer read FHeight write SetHeight;
         property BkColor:Tcolor read FBkColor write SetBkColor;
  end;

   tNewGroupBox=class(TGroupBox)
      private
         FTransparentMode:Boolean;
         FBorder:Boolean;
         FTitle:TTitle;
         FBevel:TBevelNew;
         FShape:TShapeNew;
         FArc:Integer;
         FHighLightColor:TColor;
         FShadowColor:Tcolor;
         procedure DrawParentImage (Control: TControl; Dest: TCanvas);
         procedure WMSize(var Message: TWMSize); message WM_SIZE;
         procedure WMMove(var Message: TWMMove); message WM_MOVE;
         procedure SetTransparentMode(Value:Boolean);
         procedure SetBorder(Value:Boolean);
         procedure RepaintRequest(sender:TObject);
         Procedure SetBevel(Value:TBevelNew);
         Procedure WriteBox(cad:string);
         Procedure SetShape(Value:TShapeNew);
         Procedure SetArc(Value:Integer);
         Procedure SetShadowColor(Value:TColor);
         Procedure SetHighLightColor(Value:TColor);
      public
         constructor Create(AOwner:TComponent);override;
         destructor destroy; override;
      protected
{         procedure AdjustClientRect(var Rect: TRect); override;}
         procedure Paint; override;
      published
         Property HighLightColor:TColor read FHighLightColor write SetHighLightColor;
         Property ShadowColor:Tcolor read FShadowColor write setShadowColor;
         Property Arc:Integer read FArc write SetArc;
         Property Bevel:TBevelNew read FBevel write SetBevel;
         property Title:TTitle read FTitle write FTitle;
         Property TransparentMode:Boolean read FTransparentMode write SetTransparentMode;
         Property Border:Boolean read FBorder write SetBorder;
         Property Shape:TShapeNew read FShape write SetShape;
   end;

implementation
constructor tnewpanel.Create(AOwner:TComponent);
begin
   inherited;
   self.BorderWidth:=1;
end;
procedure tnewpanel.DrawParentImage (Control: TControl; Dest: TCanvas);
var
  SaveIndex: Integer;
  DC: HDC;
  Position: TPoint;
begin
  with Control do
  begin
    if Parent = nil then
      Exit;
    DC := Dest.Handle;
    SaveIndex := SaveDC(DC);
    GetViewportOrgEx(DC, Position);
    SetViewportOrgEx(DC, Position.X - Left, Position.Y - Top, nil);
    IntersectClipRect(DC, 0, 0, Parent.ClientWidth, Parent.ClientHeight);
    ///Fixed Thorsten Claus {25.01.2002}
    Parent.Perform(WM_ERASEBKGND, Integer(DC), Integer(0));
    Parent.Perform(WM_PAINT, Integer(DC), Integer(0));
    RestoreDC(DC, SaveIndex);
  end;
end;
procedure TNewpanel.WMSize(var Message: TWMSize);
begin
   inherited;
   invalidate;
   message.Result:=0;
end;
procedure TNewpanel.WMMove(var Message: TWMMove);
begin
   inherited;
   invalidate;
   message.Result:=0;
end;
procedure TNewpanel.paint;
var
   R:Trect;
begin
   DrawParentImage(Self, Self.Canvas);
   R:=clientRect;
   if self.BevelOuter=bvLowered then
      Frame3d(canvas, R,clBtnShadow,clBtnHighlight,borderwidth)
   else if self.BevelOuter=bvRaised then
      Frame3d(canvas, R,clBtnHighlight,clBtnShadow,borderwidth);
end;
constructor TNewGroupBox.Create(AOwner:TComponent);
begin
   inherited;
   ftitle:=ttitle.Create;
   ftitle.Onchange:=RepaintRequest;
   Ftitle.Width:=width;
   FTransparentMode:=false;
   FBorder:=False;
   FArc:=15;
   FHighLightColor:=clbtnhighlight;
   FShadowColor:=clbtnshadow;
end;
procedure tnewgroupbox.DrawParentImage (Control: TControl; Dest: TCanvas);
var
  SaveIndex: Integer;
  DC: HDC;
  Position: TPoint;
begin
  with Control do
  begin
    if Parent = nil then
      Exit;
    DC := Dest.Handle;
    SaveIndex := SaveDC(DC);
    {$IFDEF PDJ_2}
    GetViewportOrgEx(DC, @Position);
    {$ELSE}
    GetViewportOrgEx(DC, Position);
    {$ENDIF}
    SetViewportOrgEx(DC, Position.X - Left, Position.Y - Top, nil);
    IntersectClipRect(DC, 0, 0, Parent.ClientWidth, Parent.ClientHeight);
    {Parent.Perform(WM_ERASEBKGND, DC, 0);
    Parent.Perform(WM_PAINT, DC, 0); }
    ///Fixed Thorsten Claus {25.01.2002}
    Parent.Perform(WM_ERASEBKGND, Integer(DC), Integer(0));
    Parent.Perform(WM_PAINT, Integer(DC), Integer(0));
    RestoreDC(DC, SaveIndex);
  end;
end;
procedure TNewGroupBox.WMSize(var Message: TWMSize);
begin
   inherited;
   invalidate;
   message.Result:=0;
end;
procedure TNewGroupBox.WMMove(var Message: TWMMove);
begin
   inherited;
   invalidate;
   message.Result:=0;
end;
procedure TNewGroupBox.paint;
begin
  with Canvas do
  begin
    DrawParentImage(Self, Self.Canvas);
    WriteBox('TITLE');
    writebox('');
  end;
end;

procedure TNewGroupBox.RepaintRequest(sender:tobject);
begin
   invalidate;
end;
procedure TNewGroupBox.SetBevel(value:TBevelNew);
begin
   if value<>FBevel then
   begin
      FBevel:=value;
      invalidate;
   end;
end;

destructor TNewGroupBox.destroy;
begin
   ftitle.free;
   inherited;
end;
procedure TNewGroupBox.SetTransparentMode(Value:Boolean);
begin
   FTransparentMode:=Value;
   invalidate;
end;
procedure TNewGroupBox.SetBorder(Value:Boolean);
begin
   FBorder:=Value;
   invalidate;
end;
Constructor ttitle.Create;
begin
   inherited;
   FBkColor:=clnone;
   FHeight:=13;
   FTextAlign:=ttLeft;
   FAlign:=taTop;
   FBorder:=true;
   FSeparation:=0;
   FArc:=15;
   FOffSet:=0;
   FHighLightColor:=clbtnhighlight;
   FShadowColor:=clbtnshadow;
end;
Procedure TNewGroupBox.SetShape(Value:TShapeNew);
begin
   if (value<>FShape) then
   begin
      FShape:=value;
      invalidate;
   end;
end;
procedure TTitle.SetBkColor(Value:tcolor);
begin
   FBkcolor:=value;
   if assigned(fOnChange) then fOnChange(Self);
end;
procedure TTitle.setborder(value:boolean);
begin
   fborder:=value;
   if assigned(fOnChange) then fOnChange(Self);
end;

Procedure TTitle.SetHeight(value:integer);
begin
    if value>=0 then
    begin
       FHeight:=value;
       if assigned(fOnChange) then fOnChange(Self);
    end;
end;
procedure TTitle.SetTextAlign(value:TTitleTextAlign);
begin
   if value<>FTextAlign then
   begin
      FTextAlign:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
procedure TTitle.SetAlign(value:TTitleAlign);
begin
   if value<>FAlign then
   begin
      FAlign:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
procedure TTitle.SetBevel(value:TBevelNew);
begin
   if value<>FBevel then
   begin
      FBevel:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
procedure TTitle.SetSeparation(value:integer);
begin
   if (value<>FSeparation) and (value>=0) then
   begin
      FSeparation:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TTitle.SetShape(Value:TShapeNew);
begin
   if (value<>FShape) then
   begin
      FShape:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TTitle.SetArc(Value:Integer);
begin
   if (value<>FArc) then
   begin
      FArc:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TNewGroupBox.SetArc(Value:Integer);
begin
   if (value<>FArc) then
   begin
      FArc:=value;
      invalidate;
   end;
end;
Procedure TTitle.SetOffset(Value:Integer);
begin
   if (value<>FOffSet) then
   begin
      FOffset:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TTitle.SetHighLightColor(Value:TColor);
begin
   if (value<>FHighLightColor) then
   begin
      FHighLightColor:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TTitle.SetShadowColor(Value:TColor);
begin
   if (value<>FShadowColor) then
   begin
      FShadowColor:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TTitle.SetWidth(Value:integer);
begin
   if (value<>FWidth) then
   begin
      FWidth:=value;
      if assigned(fOnChange) then fOnChange(Self);
   end;
end;
Procedure TNewGroupBox.SetHighLightColor(Value:TColor);
begin
   if (value<>FHighLightColor) then
   begin
      FHighLightColor:=value;
      invalidate;
   end;
end;
Procedure TNewGroupBox.SetShadowColor(Value:TColor);
begin
   if (value<>FShadowColor) then
   begin
      FShadowColor:=value;
      invalidate;
   end;
end;

Procedure TNewGroupBox.WriteBox(cad:string);
var
  H: Integer;
  r1: TRect;
  ShapeTmp:TShapeNew;
  Beveltmp:TBevelNew;
  Bordertmp:boolean;
  ColorTmp:Tcolor;
  ArcTmp:integer;
  HighColortmp,ShadowColortmp:tcolor;
  Flags: Longint;
  bkmodeant:integer;
begin
  with Canvas do
  begin
    R1:=ClientRect;
    ShapeTMP:=Shape;
    Beveltmp:=Bevel;
    Bordertmp:=border;
    ArcTmp:=farc;
    HighColortmp:=self.HighLightColor;
    ShadowColortmp:=ShadowColor;
    H:=title.height;
    PEN.Width:=1;
    if transparentmode then
       colortmp:=clNone
    else
       colortmp:=Color;
    if cad='TITLE' then
    begin
       r1.right:=r1.left+title.width+title.foffset;
       r1.Left:=r1.Left+title.foffset;
       if title.align=taTop then
          R1.Bottom:=H
       else
          R1.Top:=R1.Bottom-H;
       ShapeTMP:=Title.Shape;
       Beveltmp:=title.Bevel;
       Bordertmp:=title.border;
       colortmp:=title.bkcolor;
       ArcTmp:=title.arc;
       HighColortmp:=title.HighLightColor;
       ShadowColortmp:=title.ShadowColor;
    end
    else
    begin
       if title.align=taTop then
          R1.Top:=r1.Top+H+title.Separation
       else
          r1.bottom:=r1.Bottom-h-title.Separation;
    end;
    brush.Color:=colortmp;
    if colortmp<>clNone then
       brush.Style:=bsSolid
    ELSE
       brush.Style:=bsClear ;
    if Bordertmp then
    begin
      case Beveltmp of
         bnLowered :
            begin
               if colortmp<>clNone then fillrect(r1);
               Frame3d(canvas, R1,ShadowColortmp,HighColortmp,pen.Width);
            end;
         bnRaised  :
            begin
               if colortmp<>clNone then fillrect(r1);
               Frame3d(canvas, R1,HighColortmp,ShadowColortmp,pen.Width);
            end;
         bnLoweredLine:
            begin
               inc(R1.left,pen.width);
               inc(R1.top,pen.width);
               pen.Color:=HighColortmp;
               pen.Mode:=pmCopy;
               IF shapetmp=tsRect then
                  Rectangle(r1)
               else
                  RoundRect(R1.Left, r1.top, r1.Right ,r1.Bottom,arctmp, arctmp);
               offsetRect(r1,-pen.width,-pen.Width);
               pen.Color:=ShadowColortmp;
               Brush.Color:=clWhite;
               Brush.Style:=bsClear;
               IF shapetmp=tsRect then
                  Rectangle(r1)
               else
                  RoundRect(R1.Left, r1.top, r1.Right ,r1.Bottom,arctmp, arctmp);
            end;
         bnRaisedLine:
            begin
               inc(R1.left,pen.Width);
               inc(R1.top,pen.Width);
               pen.Color:=ShadowColortmp;
               pen.Mode:=pmCopy;
               IF shapetmp=tsRect then
                  Rectangle(r1)
               else
                   RoundRect(R1.Left, r1.top, r1.Right ,r1.Bottom,arctmp, arctmp);
               offsetRect(r1,-pen.width,-pen.Width);
               pen.Color:=HighColortmp;
               Brush.Style:=bsClear;
               IF shapetmp=tsRect then
                  Rectangle(r1)
               else
                  RoundRect(R1.Left, r1.top, r1.Right ,r1.Bottom,arctmp, arctmp);
            end;
      end;
    end
    else if colortmp<>clnone then
       fillrect(r1);
    if cad='TITLE' then
    begin
    textflags:=textflags-ETO_OPAQUE;
    if Text <> '' then
    begin
      H:=title.Height;
      case title.Textalign of
         ttLeft:
            if not UseRightToLeftAlignment then
              R1 := Rect(r1.left+1, R1.top+((H-textheight('0')) div 2), r1.Right, r1.bottom+1)
            else
              R1 := Rect(R1.Right - Canvas.TextWidth(Text)-1, R1.top+((H-textheight('0')) div 2), r1.Right, r1.bottom+1);
         ttRight:
            if not UseRightToLeftAlignment then
               R1 := Rect(R1.Right - Canvas.TextWidth(Text)-1, r1.top+((h-textheight('0')) div 2), r1.Right, r1.bottom+1)
            else
               R1 := Rect(r1.left+1, r1.top+((H-textheight('0')) div 2), 0, r1.bottom+1);
         ttCenter:
               R1 := Rect(r1.left+((r1.right-r1.left) - min(Canvas.TextWidth(Text),r1.right-r1.left)-1) div 2, r1.top+((H-textheight('0')) div 2), r1.Right , r1.bottom+1)
      end;
      Flags := DrawTextBiDiModeFlags(textflags and DT_SINGLELINE);
//      DrawText(Handle, PChar(Text), Length(Text), R1, flags or DT_CALCRECT);
      canvas.Font:=self.Font;
      bkmodeant:=setbkmode(handle,transparent);
      DrawText(Handle, PChar(Text), Length(Text), R1, flags);
      setbkmode(handle,bkmodeant);
    end;
    end;
  end;
end;
end.
