unit polprop;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, Menus;

type
  TfrmPolProp = class(TForm)
    BitBtn1: TBitBtn;
    txtHint: TMemo;
    Label1: TLabel;
    cbHintColor: TColorBox;
    Label2: TLabel;
    sbPoints: TStatusBar;
    chkActive: TCheckBox;
    tvPoints: TTreeView;
    Label3: TLabel;
    mnuPoints: TPopupMenu;
    Delete1: TMenuItem;
    ilPoints: TImageList;
    Insert1: TMenuItem;
    AddAfter1: TMenuItem;
    N1: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    txtName: TEdit;
    Label4: TLabel;
    procedure tvPointsEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure tvPointsEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure Delete1Click(Sender: TObject);
    procedure mnuPointsPopup(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure AddAfter1Click(Sender: TObject);
    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPolProp: TfrmPolProp;
  np:integer;
implementation

{$R *.dfm}

procedure TfrmPolProp.tvPointsEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
   if copy(node.Text,1,5)='Point' then AllowEdit:=false;
end;

procedure TfrmPolProp.tvPointsEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
   n:Integer;
begin
   try
      N:=strtoint(S);
      s:=inttostr(N);
   except
      S:='0';
   end;
end;

procedure TfrmPolProp.Delete1Click(Sender: TObject);
begin
   tvpoints.Selected.Free;
   np:=np-1;
   self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
end;

procedure TfrmPolProp.mnuPointsPopup(Sender: TObject);
var
   t:ttreenode;
begin
   t:=tvpoints.Selected;
   if copy(t.Text,1,5)='Point' then
   begin
      mnuPoints.Items[0].Visible:=true;
      mnuPoints.Items[1].Visible:=true
   end
   else
   begin
      mnuPoints.Items[0].Visible:=false;
      mnuPoints.Items[1].Visible:=false;
   end;
end;

procedure TfrmPolProp.Insert1Click(Sender: TObject);
var
 t,tt:TTreenode;
begin
  t:=tvpoints.Items.insert(tvpoints.Selected,'Point Added');
  t.ImageIndex:=3;
  t.SelectedIndex:=3;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=1;
  tt.SelectedIndex:=1;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=2;
  tt.SelectedIndex:=2;
  np:=np+1;
  self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
end;

procedure TfrmPolProp.AddAfter1Click(Sender: TObject);
var
 t,tt:TTreenode;
begin
  t:=tvpoints.Items.Add(nil,'Point Added');
  t.ImageIndex:=3;
  t.SelectedIndex:=3;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=1;
  tt.SelectedIndex:=1;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=2;
  tt.SelectedIndex:=2;
  np:=np+1;
  self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
end;

procedure TfrmPolProp.ExpandAll1Click(Sender: TObject);
begin
   tvpoints.FullExpand;
end;

procedure TfrmPolProp.CollapseAll1Click(Sender: TObject);
begin
   tvPoints.FullCollapse;
end;

end.
