unit PanelDown;

interface

uses
  Windows, Messages, SysUtils,Classes,ExtCtrls,graphics, Controls,buttons,
  dialogs,funciones,forms,igriegaconsts,igriegaclasses;

type

  TStatusPanel=(spUp,spDown);
  TOnStatusChange=procedure(Sender:TObject;var NewStatus:TStatusPanel) of object;
  TPanelDown = class(TCustomcontrol)
  private
     Fbutton:TSpeedButton;
     FStatus:TStatusPanel;
     FBackground:TBitmap;
     FHeightDown:Integer;
     FControlWhenClose:TWincontrol;
     FOnstatusChange:TOnStatusChange;
     FBevelDown:TBoxBevel;
     FBevelCaption:TBoxBevel;
     FChange:Boolean;
     FShadow:Boolean;
     FShadowDepth:Integer;
     FBrightness:Integer;
     FRect:TRect;
     procedure clickButton(Sender:TObject);
     procedure SetStatus(Value:TStatusPanel);
     procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
     procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
     procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
     procedure CMParentCtl3DChanged(var Message: TMessage); message CM_PARENTCTL3DCHANGED;
     procedure WMSize(var Message: TWMSize); message WM_SIZE;
     procedure CMStatusChanged(var Message: TMessage); message CM_STATUSCHANGED;
     procedure WMWindowPosChanged(var Message: TWMWindowPosChanged); message WM_WINDOWPOSCHANGED;
     Procedure SetBackground(Value:TBitmap);
     Procedure SetHeightDown(value:Integer);
     procedure SetControlWhenClose(Value:TWinControl);
     procedure SetBevelDown(Value:TBoxBevel);
     procedure SetBevelCaption(Value:TBoxBevel);
     procedure SetShadow(Value:Boolean);
     procedure SetShadowDepth(Value:Integer);
     procedure SetBrightness(Value:Integer);
    { Private declarations }
  protected
     procedure Paint;override;
     procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
     function GetClientRect: TRect; override;
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property ClientRect:TRect read GetClientRect;
    { Public declarations }
  published
     Property Color;
     Property Background:TBitmap read FBackground Write SetBackground;
     Property HeightDown:Integer read FHeightDown write SetHeightDown;
     property ControlWhenClose:TWincontrol read FControlWhenClose write SetControlWhenClose;
     Property Status:TStatusPanel read FStatus Write SetStatus;
     Property BevelDown:TBoxBevel read FBevelDown write SetBevelDown default bbRaised;
     Property BevelCaption:TBoxBevel read FBevelCaption write SetBevelCaption default bbNone;
     property Shadow:Boolean read FShadow Write SetShadow;
     property ShadowDepth:Integer read FShadowDepth Write SetShadowDepth;
     property Brightness:Integer read FBrightness Write SetBrightness default -30;
     Property Caption;
     Property Font;
     property PopupMenu;
     Property Hint;
     property Enabled;
     property Ctl3D;
     property ParentColor;
     property ParentCtl3D;
     property ParentFont;
     property ParentShowHint;
     property ShowHint;
     property TabOrder;
     property Visible;
     Property Align;
     property OnStatusChange:TOnStatusChange read FOnstatusChange Write FOnStatusChange;
     property OnClick;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnResize;

    { Published declarations }
  end;
procedure Register;

implementation
constructor TPanelDown.Create(Aowner:TComponent);
var
   tmpimage:TBitmap;
begin
   inherited;
   FChange:=true;
   FBackground:=TBitmap.Create;
   Color:=clBtnFace;
   ControlStyle:=controlstyle+[csSetCaption,csReflector,csOpaque];
   FStatus:=spDown;
   controlstyle:=ControlStyle+[csAcceptsControls];
   Width:=185;
   FHeightDown:=100;
   Height:=100;
   FBrightness:=-30;
   FShadow:=False;
   FShadowDepth:=10;
   FButton:=TSpeedButton.Create(nil);
   FButton.Name:='UpDown';
   FButton.Parent:=self;
   FButton.Left:=(width-fbutton.Width);
   FButton.Height:=17;
   FButton.OnClick:=clickButton;
   FButton.Flat:=true;
   if (csDesigning in ComponentState) then
      FButton.OnClick:=nil;
   FBevelCaption:=bbNone;
   FBevelDown:=bbRaised;
   tmpimage:=TBitmap.Create;
    try
      tmpimage.Handle:=LoadBitmap( 0,makeintresource(OBM_COMBO) );
      Fbutton.Glyph.Assign(tmpimage);
      DeleteObject(tmpimage.Handle);
    finally
      tmpimage.Free;
    end;
    FRect:=rect(left,top,left+width+FShadowDepth,top+height+FShadowDepth);
end;
destructor TPanelDown.Destroy;
begin
   FButton.Free;
   FBackground.Free;
   if assigned(FControlWhenClose) then
      FControlWhenClose:=nil;
   inherited;
end;
function TPanelDown.GetClientRect: TRect;
begin
  if FBevelDown<>bbNone then
  begin
     Result.Left := 2;
     Result.Top := Self.Canvas.TextHeight('O')+6;
     Result.Right := Width-2;
     Result.Bottom := Height-2;
  end
  else
  begin
     Result.Left := 0;
     Result.Top := Self.Canvas.TextHeight('O')+4;
     Result.Right := Width;
     Result.Bottom := Height;
  end

end;
procedure TPanelDown.SetShadow(Value:Boolean);
begin
   if FShadow<>Value then
   begin
      FShadow:=value;
      FChange:=true;
      if not FShadow then
         invalidaterect(parent.Handle,@FRect,true);
      invalidate;
   end;
end;
procedure TPanelDown.SetShadowDepth(Value:Integer);
begin
   if FShadowDepth<>Value then
   begin
      FShadowDepth:=Value;
      FChange:=true;
      invalidate;
   end;
end;
procedure TPanelDown.SetBrightness(Value:Integer);
begin
   if FBrightness<>Value then
   begin
      FBrightness:=Value;
      FChange:=true;
      invalidate;
   end;
end;
procedure TPanelDown.SetBevelDown(Value:TBoxBevel);
begin
   if FBevelDown<>Value then
   begin
      FBevelDown:=Value;
      invalidate;
   end;
end;
procedure TPanelDown.SetBevelCaption(Value:TBoxBevel);
begin
   if FBevelCaption<>Value then
   begin
      FBevelCaption:=Value;
      invalidate;
   end;
end;
procedure TPanelDown.Notification(AComponent: TComponent;
      Operation: TOperation);
begin
   if (AComponent=FControlWhenClose) and (Operation=opRemove) then
      FControlWhenClose:=nil;
end;
procedure TPanelDown.SetControlWhenClose(Value:TWinControl);
var i:integer;
    enc:Boolean;
begin
   enc:=false;
   if FControlWhenClose<>Value then
   begin
      if Value<>nil then
        if Value.Name<>self.Name then
        begin
           for i:=0 to self.ControlCount-1 do
              if self.Controls[i].Name=value.Name then
              begin
                 enc:=true;
                 break;
              end
        end
        else
           enc:=true;
      if not enc then
         FControlWhenClose:=Value
      else
         showmessage('El control no debe estar dentro del panel');
   end;
end;
procedure TPanelDown.WMWindowPosChanged(var Message: TWMWindowPosChanged);
begin
   inherited;
   fChange:=true;
   invalidate;
end;
procedure TPanelDown.CMStatusChanged(var Message: TMessage);
var i:integer;
begin
   fchange:=true;
      if assigned(FOnStatusChange) then
         FOnStatusChange(self,FStatus);
      if FStatus=spdown then
      begin
         BringToFront;
         Height:=FHeightDown;
         for i:=0 to self.ControlCount-1 do
            self.Controls[i].Enabled:=true;
      end
      else
      begin
         self.SendToBack;
         Height:=canvas.TextHeight('O')+4;
         for i:=0 to self.ControlCount-1 do
            if self.Controls[i].Name<>'UpDown' then
            self.Controls[i].Enabled:=false;
         if (not (csDesigning in ComponentState))and assigned(FControlWhenClose) then
            try
               FControlWhenClose.SetFocus;
            Except
               doexit;
            end;
      end;
end;
procedure TPanelDown.CMCtl3DChanged(var Message: TMessage);
begin
   inherited;
   repaint;
end;
procedure TPanelDown.CMParentCtl3DChanged(var Message: TMessage);
begin
   inherited;
   repaint;
end;
procedure TPanelDown.WMSize(var Message: TWMSize);
begin
   fchange:=true;
   if fstatus=spDown then
      setHeightDown(Message.Height)
   else
      Height:=canvas.TextHeight('O')+4;
   FButton.Left:=(width-fbutton.Width);
end;
Procedure TPanelDown.SetHeightDown(value:Integer);
begin
   FChange:=true;
   if FHeightDown<>Value then
   begin
      FHeightDown:=Value;
      If FStatus=spDown then
      begin
         Height:=FHeightDown;
         invalidate;
      end;
   end;
end;
Procedure TPanelDown.SetBackground(Value:TBitmap);
begin
   FBackground.assign(Value);
   invalidate;
end;
procedure TPanelDown.CMTextChanged(var Message: TMessage);
begin
   inherited;
   invalidate;
end;
procedure TPanelDown.CMFontChanged(var Message: TMessage);
begin
   inherited;
   FChange:=true;
   canvas.Font:=font;
   FButton.Height:=canvas.TextHeight('O')+4;
   if FStatus=spUp then
      Height:=canvas.TextHeight('O')+4
   else
      invalidate;
end;
procedure TPanelDown.SetStatus(Value:TStatusPanel);
begin
   if Fstatus<>Value then
   begin
      FStatus:=Value;
      Perform(CM_STATUSCHANGED, Ord(Value), 0);
   end;
end;
procedure TPanelDown.ClickButton(Sender:Tobject);
begin
   FChange:=true;
   if FStatus=spUp then Status:=spDown else Status:=spUp;
end;
procedure TPanelDown.Paint;
   procedure Bevel(R:TRect;Bev:TBoxBevel);
   begin
      with canvas do
      if Ctl3D then
      case Bev of
         bbRaised: drawedge(Handle,R,BDR_RAISEDOUTER,BF_SOFT or BF_RECT);
         bbLowered:drawedge(Handle,R,BDR_SUNKENOUTER,BF_SOFT or BF_RECT);
         bbRaisedLine:
            begin
               Inc(R.Left);
               Inc(R.Top);
               Brush.Color := clBtnShadow;
               FrameRect(R);
               OffsetRect(R, -1, -1);
               Brush.Color := clBtnHighlight;
               FrameRect(R);
            end;
         bbLoweredLine:
            begin
               Inc(R.Left);
               Inc(R.Top);
               Brush.Color := clBtnHighlight;
               FrameRect(R);
               OffsetRect(R, -1, -1);
               Brush.Color := clBtnShadow;
               FrameRect(R);
            end;
         bbEdgeBump:drawedge(Handle,R,EDGE_BUMP,BF_SOFT or BF_RECT);
         bbEdgeEtChed:drawedge(Handle,R,EDGE_ETCHED,BF_SOFT or BF_RECT);
      end
      else
         if Bev<>bbNone then
         begin
            Brush.Color := clwindowframe;
            FrameRect(R);
         end;
   end;
var r:trect;
    b:TBItmap;
    DC:HDC;
begin
   if fchange and FShadow then
   begin
      FChange:=false;
      invalidaterect(parent.Handle,@FRect,true);
      updatewindow(parent.Handle);
      FRect:=rect(left,top,left+width+FShadowDepth,top+height+FShadowDepth);
      r.Left:=0;
      r.Top:=0;
      r.Right:=Self.Width;
      r.Bottom:=Self.Height;
      incpoint(r.TopLeft,FShadowDepth);
      incpoint(r.BottomRight,FShadowDepth);
      b:=tbitmap.Create;
      b.Width:=width;
      b.Height:=height;
      DC:=GetDC(twincontrol(parent).Handle);
      bitblt(b.Canvas.Handle,0,0,Width,Height,DC,left+FShadowDepth,Top+FShadowDepth,srccopy);
      b.PixelFormat:=pf24bit;
      funciones.brightness(b,FBrightness);
   //   r:=clientrect;
      r.Left:=0;
      r.Top:=0;
      r.Right:=Self.Width;
      r.Bottom:=Self.Height;
      incpoint(r.TopLeft,FShadowDepth);
      incpoint(r.BottomRight,FShadowDepth);
      bitblt(DC,left+FShadowDepth,Top+FShadowDepth,Width,Height,b.Canvas.Handle,0,0,srccopy);
      releasedc(twincontrol(parent).Handle,dc);
      b.Free;
   end;
   with Canvas do
   begin
      r.Left:=0;
      r.Top:=0;
      r.Right:=Self.Width;
      r.Bottom:=Self.Height;
      Brush.Style:=bsSolid;
      Brush.Color:=Color;
      FillRect(R);
      r.Top:=r.Top+TextHeight('O')+5;
      try
         if not Fbackground.Empty then
            Brush.Bitmap:=FBackground;
      finally
         FillRect(R);
         Brush.Bitmap:=nil;
      end;
      Pen.Style:=psSolid;
      if Fstatus=spDown then
         Bevel(r,FBevelDown);
      r.Left:=0;
      r.Top:=0;
      r.Right:=Self.Width;
      r.Bottom:=Self.Height;
      R.Bottom:=r.Top+TextHeight('O')+4;
      Bevel(R,FBevelCaption);
      R.Left:=R.Left+2;
      Inc(R.Top);
      Font:=self.Font;
      setbkmode(Handle,TRANSPARENT);
      drawtext(Handle,pchar(caption),length(caption),r,DT_Left+DT_SINGLELINE);
   end;
end;
procedure Register;
begin
  RegisterComponents('i-vcl Panels', [TPanelDown]);
end;

end.
