unit prinunit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, HotSpotMap, jpeg, ComCtrls, Menus, StdCtrls, Buttons,
  Spin,polprop,aboutunit,igriegastrs;

type
  TFrmEditComp = class(TForm)
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    HotSpotMap1: THotSpotMap;
    btnaddpol: TSpeedButton;
    btndelpol: TSpeedButton;
    poln1: TSpinEdit;
    Label3: TLabel;
    btnpolprop: TSpeedButton;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    cbInkColor: TColorBox;
    chkFramed: TCheckBox;
    chkShowHint: TCheckBox;
    chkInkGlass: TCheckBox;
    tbFrameSize: TTrackBar;
    SBar: TStatusBar;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    btnAbout: TSpeedButton;
    cbInkMode: TComboBox;
    Label4: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    chkShowPol: TCheckBox;
    chkActive: TCheckBox;
    Procedure OnChangeHotspot(Sender:TObject;Polygon:integer);
    procedure cbInkColorChange(Sender: TObject);
    procedure chkFramedClick(Sender: TObject);
    procedure chkShowHintClick(Sender: TObject);
    procedure chkInkGlassClick(Sender: TObject);
    procedure tbFrameSizeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkActiveClick(Sender: TObject);
    procedure ShowPol;
    procedure HotSpotMap1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure chkShowPolClick(Sender: TObject);
    procedure poln1Change(Sender: TObject);
    procedure btnpolpropClick(Sender: TObject);
    procedure btndelpolClick(Sender: TObject);
    procedure btnaddpolClick(Sender: TObject);
    procedure HotSpotMap1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HotSpotMap1DblClick(Sender: TObject);
    procedure HotSpotMap1HotClick(Sender: TObject; Polygon: Integer);
    procedure btnAboutClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbInkModeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmEditComp: TFrmEditComp;
  frmpolprop:Tfrmpolprop;
  frmabout:Tfrmabout;
  Intro:Boolean;
  n:integer;
  p:tpoint;
implementation

{$R *.dfm}

Procedure TFrmEditComp.OnChangeHotspot(Sender:TObject;Polygon:integer);
begin
   if polygon>=0 then
      SBar.Panels[2].Text:='Current : '+HotSpotMap1.GetName(Polygon)+' ['+inttostr(Polygon)+']'
   else
      SBar.Panels[2].Text:='';
end;
procedure TFrmEditComp.ShowPol;
var
   P:array[0..100]of tpoint;
   i:integer;
begin
  hotspotmap1.repaint;
  if chkShowPol.Checked and (poln1.Value>=0)then
  begin
   with hotspotmap1.Polygons do
      if Count>0 then
      begin
         if items[poln1.Value].Poly.Count>0 then
         begin
            for i:=0 to items[poln1.Value].Poly.Count-1 do
            begin
               p[i].X:=items[poln1.Value].Poly[i].Point.X;
               p[i].Y:=items[poln1.Value].Poly[i].Point.Y;
            end;
            hotspotmap1.Canvas.Brush.Style:=bsClear;
            hotspotmap1.Canvas.Pen.Color:=clBlack;
            hotspotmap1.Canvas.Pen.Mode:=pmNot;
            hotspotmap1.Canvas.Pen.Width:=tbFrameSize.Position;
            hotspotmap1.Canvas.Polygon(slice(p,i));
         end;
      end;
   end;
{   else
      hotspotmap1.Invalidate;}
end;

procedure TFrmEditComp.cbInkColorChange(Sender: TObject);
begin
   hotspotmap1.InkColor:=cbinkcolor.Selected;
end;

procedure TFrmEditComp.chkFramedClick(Sender: TObject);
begin
   hotspotmap1.Framed:=chkFramed.Checked;
end;

procedure TFrmEditComp.chkShowHintClick(Sender: TObject);
begin
   hotspotmap1.ShowHint:=chkShowHint.Checked;
end;

procedure TFrmEditComp.chkInkGlassClick(Sender: TObject);
begin
   hotspotmap1.InkGlass:=chkInkGlass.Checked;
end;

procedure TFrmEditComp.tbFrameSizeChange(Sender: TObject);
begin
   hotspotmap1.FrameSize:=tbFrameSize.Position;
   tbFrameSize.Hint:='Size : '+inttostr(tbFrameSize.Position);
end;

procedure TFrmEditComp.FormCreate(Sender: TObject);
begin
   frmpolprop:=Tfrmpolprop.Create(Application);
   frmabout:=Tfrmabout.Create(Application);
   frmabout.Label1.Caption:=sMsgAboutHotSpotMap;
   self.HotSpotMap1.OnPolygonActive:=OnChangeHotspot;
   tbFrameSize.Position:=2;
   tbFrameSize.Hint:='Size : '+inttostr(tbFrameSize.Position);
   Sbar.Panels[0].text:='HotSpots : '+inttostr(hotspotmap1.Polygons.Count);
   Intro:=false;
end;

procedure TFrmEditComp.chkActiveClick(Sender: TObject);
begin
   HotSpotMap1.Active:=chkActive.Checked;
   chkShowPol.Checked:=not chkActive.Checked;
   hotspotmap1.ShowHint:=chkShowHint.Checked;
   hotspotmap1.InkGlass:=chkInkGlass.Checked;
   hotspotmap1.Framed:=chkFramed.Checked;
   hotspotmap1.FrameSize:=tbFrameSize.Position;
   hotspotmap1.InkGlassMode:= TInkGlassMode(cbInkMode.ItemIndex);
   hotspotmap1.InkColor:=cbinkcolor.Selected;
end;

procedure TFrmEditComp.HotSpotMap1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
   Sbar.Panels[1].Text:='Position : ('+inttostr(X)+','+inttostr(Y)+')';
   inherited;
end;

procedure TFrmEditComp.chkShowPolClick(Sender: TObject);
begin
   chkActive.Checked:=not chkShowPol.Checked;
   showpol;
end;

procedure TFrmEditComp.poln1Change(Sender: TObject);
begin
   if poln1.Value>hotspotmap1.Polygons.Count-1 then
      poln1.value:=pred(poln1.value);
   Sbar.Panels[0].text:='HotSpots : '+inttostr(hotspotmap1.Polygons.Count);
   showpol;
end;

procedure TFrmEditComp.btnpolpropClick(Sender: TObject);
var
   i,j:Integer;
   t,tt:TTreenode;
begin
   if (hotspotmap1.Polygons.Count>0) and (poln1.Value>=0) then
   begin
      frmpolprop.Caption:='[Properties] HotSpot n : '+ inttostr(poln1.Value);
      frmpolprop.txtHint.Lines.Clear;
      frmpolprop.txtHint.Lines.Add(hotspotmap1.Polygons[poln1.value].Poly.Hint);
      frmpolprop.cbHintColor.Selected:=hotspotmap1.Polygons[poln1.value].Poly.HintColor;
      frmpolprop.sbPoints.SimpleText:='Number of points : '+inttostr(hotspotmap1.Polygons[poln1.value].Poly.count);
      polprop.np:=hotspotmap1.Polygons[poln1.value].Poly.count;
      frmpolprop.chkActive.Checked:=hotspotmap1.Polygons[poln1.value].Poly.Active;
      frmpolprop.tvPoints.Items.Clear;
      frmpolprop.txtName.Text:=Hotspotmap1.Polygons[poln1.value].Name;
      if hotspotmap1.Polygons[poln1.value].Poly.Count>0 then
      begin
         for i:=0 to hotspotmap1.Polygons[poln1.value].Poly.Count-1 do
         begin
            t:=frmpolprop.tvPoints.Items.Add(nil,'Point '+inttostr(i));
            t.ImageIndex:=0;
            tt:=frmpolprop.tvPoints.Items.AddChild(t,inttostr(hotspotmap1.Polygons[poln1.value].Poly[i].Point.X));
            tt.ImageIndex:=1;
            tt.SelectedIndex:=1;
            tt:=frmpolprop.tvPoints.Items.AddChild(t,inttostr(hotspotmap1.Polygons[poln1.value].Poly[i].Point.Y));
            tt.ImageIndex:=2;
            tt.SelectedIndex:=2;
         end;
      end;
      frmpolprop.ShowModal;
      hotspotmap1.Polygons[poln1.value].Poly.Active:=frmpolprop.chkActive.Checked;
      hotspotmap1.Polygons[poln1.value].Poly.Hint:='';
      for i:=0 to frmpolprop.txtHint.Lines.Count-1 do
      begin
         hotspotmap1.Polygons[poln1.value].Poly.Hint:= hotspotmap1.Polygons[poln1.value].Poly.Hint+frmpolprop.txtHint.Lines[i];
         if i<(frmpolprop.txtHint.Lines.Count-1) then
            hotspotmap1.Polygons[poln1.value].Poly.Hint:=hotspotmap1.Polygons[poln1.value].Poly.Hint+#13#10;
      end;
      Hotspotmap1.Polygons[poln1.value].Name:=frmpolprop.txtName.Text;
      hotspotmap1.Polygons[poln1.value].Poly.Clear;
      j:=-1;
      for i:=0 to (frmpolprop.tvPoints.Items.Count div 3)-1 do
      begin
         hotspotmap1.Polygons[poln1.value].Poly.Add;
         j:=j+1;
         hotspotmap1.Polygons[poln1.value].Poly[j].Point.X:=strtoint(frmpolprop.tvpoints.Items[(i*3)+1].Text);
         hotspotmap1.Polygons[poln1.value].Poly[j].Point.Y:=strtoint(frmpolprop.tvpoints.Items[(i*3)+2].Text);
      end;
      hotspotmap1.Polygons[poln1.value].Poly.HintColor:=frmpolprop.cbHintColor.Selected;
      if chkshowpol.Checked then
         showpol;
   end;
end;

procedure TFrmEditComp.btndelpolClick(Sender: TObject);
begin
   if (hotspotmap1.Polygons.Count>0) and (poln1.Value>=0) then
      if MessageDlg('Delete HotSpot N :'+inttostr(poln1.value)+'?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
         hotspotmap1.Polygons[poln1.Value].Free;
         if poln1.Value>0 then
            poln1.Value:=poln1.Value-1;
         poln1.MaxValue:=hotspotmap1.Polygons.Count-1;
         sbar.Panels[0].Text:='HotSpots : '+inttostr(hotspotmap1.Polygons.Count);
         if chkshowpol.Checked then
            showpol;
      end;
end;

procedure TFrmEditComp.btnaddpolClick(Sender: TObject);
begin
   if not intro then
   begin
      intro:=true;
      n:=0;
      hotspotmap1.Polygons.Add;
      poln1.MaxValue:=hotspotmap1.Polygons.Count-1;
      poln1.Value:=hotspotmap1.Polygons.Count-1;
      sbar.Panels[0].Text:='HotSpots : '+inttostr(hotspotmap1.Polygons.Count);
      poln1.enabled:=false;
      chkActive.Checked:=false;
      btndelpol.Enabled:=false;
      btnpolprop.Enabled:=false;
      chkShowPol.Checked:=true;
      chkShowPol.Enabled:=false;
      chkActive.Enabled:=false;
   end
   else
      HotSpotMap1DblClick(nil);
end;

procedure TFrmEditComp.HotSpotMap1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   R:TRect;
begin
   if Intro then
   begin
      hotspotmap1.Polygons[poln1.Value].Poly.Add;
      hotspotmap1.Polygons[poln1.Value].Poly[hotspotmap1.Polygons[poln1.Value].Poly.Count-1].Point.X:=X;
      hotspotmap1.Polygons[poln1.Value].Poly[hotspotmap1.Polygons[poln1.Value].Poly.Count-1].Point.Y:=Y;
      R.Top:=y-2;
      r.Bottom:=y+2;
      r.Left:=x-2;
      r.Right:=x+2;
      hotspotmap1.canvas.Brush.Color:=clred;
      hotspotmap1.canvas.Brush.Style:=bsSolid;
      hotspotmap1.canvas.FillRect(R);
      hotspotmap1.Canvas.Pen.Mode:=pmNot;
      hotspotmap1.Canvas.Pen.Width:=tbframesize.Position;
      if n>0 then
         hotspotmap1.canvas.LineTo(x,y)
      else
         hotspotmap1.canvas.MoveTo(x,y);
      n:=n+1;
   end;
end;

procedure TFrmEditComp.HotSpotMap1DblClick(Sender: TObject);
begin
   if Intro then
   begin
      intro:=false;
      poln1.enabled:=true;
      chkActive.Enabled:=true;
      btndelpol.Enabled:=true;
      btnpolprop.Enabled:=true;
      chkShowPol.Enabled:=true;
      showpol;
      btnpolpropClick(nil);
   end;
end;

procedure TFrmEditComp.HotSpotMap1HotClick(Sender: TObject;
  Polygon: Integer);
begin
   poln1.Value:=polygon;
   btnpolpropClick(nil);
end;

procedure TFrmEditComp.btnAboutClick(Sender: TObject);
begin
   frmabout.ShowModal;
end;

procedure TFrmEditComp.FormDestroy(Sender: TObject);
begin
   frmpolprop.Free;
   frmabout.Free;
end;

procedure TFrmEditComp.cbInkModeChange(Sender: TObject);
begin
   hotspotmap1.InkGlassMode:= TInkGlassMode(cbInkMode.ItemIndex);
end;

end.
