{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit RegEditorhotspotmap;
interface
uses
   classes,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF},sysutils,Controls,igriegaStrs;
type
  THotSpotEditor=Class(TComponentEditor)
     public
        procedure ExecuteVerb(Index:Integer);override;
        Function GetVerb(Index:Integer):string;override;
        function GetVerbCount:Integer;override;
        procedure Edit;override;
  end;
procedure Register;
implementation
uses
   hotspotmap,Dialogs,prinunit,Forms,math;
procedure THotSpotEditor.Edit;
var
   F:TFrmEditComp;
   i,j:integer;
begin
   if not THotSpotMap(Component).Picture.Bitmap.Empty then
   begin
      F:=TFrmEditComp.create(Application);
      try
         f.HotSpotMap1.Picture.Assign(THotSpotMap(Component).Picture);
         f.HotSpotMap1.AutoSize:=false;
         f.HotSpotMap1.AutoSize:=true;
         f.chkFramed.Checked:=THotSpotMap(Component).Framed;
         f.chkShowHint.Checked:=THotSpotMap(Component).ShowHint;
         f.chkInkGlass.Checked:=THotSpotMap(Component).InkGlass;
         f.cbInkColor.Selected:=THotSpotMap(Component).InkColor;
         f.tbFrameSize.Position:=THotSpotMap(Component).FrameSize;
         f.cbInkMode.ItemIndex:=ord(THotSpotMap(Component).InkGlassMode);
         for i:=0 to THotSpotMap(Component).Polygons.Count-1 do
         begin
            f.HotSpotMap1.Polygons.Add;
            f.HotSpotMap1.Polygons[i].Name:=THotSpotMap(Component).Polygons[i].Name;            
            for j:=0 to THotSpotMap(Component).Polygons[i].Poly.Count-1 do
            begin
               f.HotSpotMap1.Polygons[i].Poly.Add;
               f.HotSpotMap1.Polygons[i].Poly[j].Point.X:=THotSpotMap(Component).Polygons[i].Poly[j].Point.X;
               f.HotSpotMap1.Polygons[i].Poly[j].Point.Y:=THotSpotMap(Component).Polygons[i].Poly[j].Point.Y;
               f.HotSpotMap1.Polygons[i].Poly.Hint:=THotSpotMap(Component).Polygons[i].Poly.hint;
               f.HotSpotMap1.Polygons[i].Poly.HintColor:=THotSpotMap(Component).Polygons[i].Poly.HintColor;
               f.HotSpotMap1.Polygons[i].Poly.Active:=THotSpotMap(Component).Polygons[i].Poly.Active;
               f.HotSpotMap1.Polygons[i].Poly.PopupMenu:=THotSpotMap(Component).Polygons[i].Poly.PopupMenu;
            end;
         end;
         f.poln1.MaxValue:=Max(f.HotSpotMap1.Polygons.Count-1,0);
         f.SBar.Panels[0].Text:='HotSpots : '+inttostr(f.HotSpotMap1.Polygons.Count);
         if f.ShowModal=mrOk then
         begin
//------------------------
            THotSpotMap(Component).Framed:=f.chkFramed.Checked;
            THotSpotMap(Component).ShowHint:=f.chkShowHint.Checked;
            THotSpotMap(Component).InkGlass:=f.chkInkGlass.Checked;
            THotSpotMap(Component).InkColor:=f.cbInkColor.Selected;
            THotSpotMap(Component).FrameSize:=f.tbFrameSize.Position;
            THotSpotMap(Component).InkGlassMode:=TInkGlassMode(f.cbInkMode.ItemIndex);
            THotSpotMap(Component).Polygons.Clear;
            for i:=0 to f.HotSpotMap1.Polygons.Count-1 do
            begin
               THotSpotMap(Component).Polygons.Add;
               THotSpotMap(Component).Polygons[i].Name:=f.HotSpotMap1.Polygons[i].Name;
               for j:=0 to f.HotSpotMap1.Polygons[i].Poly.Count-1 do
               begin
                  THotSpotMap(Component).Polygons[i].Poly.Add;
                  THotSpotMap(Component).Polygons[i].Poly[j].Point.X:=f.HotSpotMap1.Polygons[i].Poly[j].Point.X;
                  THotSpotMap(Component).Polygons[i].Poly[j].Point.Y:=f.HotSpotMap1.Polygons[i].Poly[j].Point.Y;
                  THotSpotMap(Component).Polygons[i].Poly.Hint:=f.HotSpotMap1.Polygons[i].Poly.hint;
                  THotSpotMap(Component).Polygons[i].Poly.HintColor:=f.HotSpotMap1.Polygons[i].Poly.HintColor;
                  THotSpotMap(Component).Polygons[i].Poly.Active:=f.HotSpotMap1.Polygons[i].Poly.Active;
                  THotSpotMap(Component).Polygons[i].Poly.PopupMenu:=f.HotSpotMap1.Polygons[i].Poly.PopupMenu;
               end;
            end;
            designer.Modified;
//-------------------------
         end;
      finally
         f.free;
      end;
   end
   else
      raise exception.Create(sSelectPictureErrMsg);
//      showmessage('Select a Picture before edit component');
end;
procedure THotSpotEditor.ExecuteVerb(Index:Integer);
   procedure SetLoadFrom;
   var
      PolList:TStringList;
      i:integer;
      b:boolean;
      OFD:TOpenDialog;
      counter:Integer;
   begin
      counter:=0;
      OFD:=TOpenDialog.Create(nil);
      OFD.Filter:='HotSpots (*.plg)|*.plg|All (*.*)|*.*';
      OFD.DefaultExt:='plg';
      OFD.Title:='Load HotSpots from file';
      if OFD.execute then
      begin
      b:=false;
      if THotSpotMap(Component).Polygons.Count>0 then
      begin
        if  messagedlg('HotSpots exists. Continue?',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
           b:=true;
      end
      else
         b:=true;
      if b then
      with THotSpotMap(Component).Polygons do
      begin
         Clear;
         pollist:=tstringList.Create;
         pollist.LoadFromFile(OFD.FileName);
         for i:=0 to pollist.Count-1 do
           begin
              pollist.Strings[i]:=uppercase(trim(Stringreplace(pollist.Strings[i],chr(9),' ',[rfReplaceAll])));
              if system.copy(pollist.Strings[i],1,8)='POLYGON ' then
              begin
                 Add;
                 counter:=counter+1;
              end;
              if (system.copy(pollist.Strings[i],1,6)='POINT ') and (Count>0) then
                 Items[Count-1].Poly.add;
              if (system.copy(pollist.Strings[i],1,2)='X=') and (Count>0) then
                 if Items[Count-1].Poly.count>0 then
                    Items[Count-1].Poly[Items[Count-1].Poly.count-1].Point.X:=strtoint(system.copy(pollist.Strings[i],3,10));
              if (system.copy(pollist.Strings[i],1,2)='Y=') and (Count>0) then
                 if Items[Count-1].Poly.count>0 then
                    Items[Count-1].Poly[Items[Count-1].Poly.count-1].Point.Y:=strtoint(system.copy(pollist.Strings[i],3,10));
           end;
           pollist.Free;
           showmessage(inttostr(Counter)+' HotSpots added');
         end;
         end;
         OFD.Free;
   end;
begin
   case Index of
      0:Edit;
      1:SetLoadFrom;
   end;
end;
function THotSpotEditor.GetVerb(Index:Integer):string;
begin
   case Index of
      0:Result:='Edit';
      1:Result:='Load From ...';
   end;
end;
function THotSpotEditor.GetVerbCount:integer;
begin
   result:=2;
end;
procedure Register;
begin
  RegisterComponents('i-griegavcl', [THotSpotMap]);
  RegisterComponentEditor(THotSpotMap,THotSpotEditor);
end;
end.
