{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

unit RegPropertieseditors;

interface
uses
   classes,funciones,dialogs,
{$IFDEF D6_OR_HIGHER}
   DesignIntf, DesignEditors   //2.4
{$ELSE}
   DsgnIntf
{$ENDIF};
type
  TFormatMaskProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TNavBarMaskProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TLogFileNameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

procedure Register;
implementation
uses
   datemask,navbarmask,forms,controls;
procedure TLogFileNameProperty.Edit;
var
   cd:TOpenDialog;
begin
   cd:=TOpenDialog.Create(nil);
   cd.DefaultExt:='.log';
   cd.Filter:='Log files (*.log)|*.log|All (*.*)|*.*';
   cd.FilterIndex:=1;
   cd.FileName:=self.GetValue;
   if cd.Execute then
   begin
      self.SetValue(cd.FileName);
      designer.Modified;
   end;
   cd.Free;
end;
function TLogFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TFormatMaskProperty.Edit;
var
  DatemaskEditor: TfrmDateMask;
begin
  DatemaskEditor := TfrmDatemask.Create(Application);
  try
     DatemaskEditor.txtTest.text:=getvalue;
     if DatemaskEditor.ShowModal=mrok then
     begin
        setvalue(DatemaskEditor.txtTest.text);
        designer.Modified;
     end;
  finally
    DatemaskEditor.Free;
  end;
end;
function TFormatMaskProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

procedure TNavBarMaskProperty.Edit;
var
  NavBarMaskEditor: TfrmNavBarMask;
begin
  NavBarMaskEditor := TfrmNavBarMask.Create(Application);
  try
     NavBarMaskEditor.txtMask.text:=getvalue;
     if NavBarMaskEditor.ShowModal=mrok then
     begin
        setvalue(NavBarMaskEditor.txtMask.text);
        designer.Modified;
     end;
  finally
    NavBarMaskEditor.Free;
  end;
end;
function TNavBarMaskProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;
procedure Register;
begin
   RegisterPropertyEditor(TypeInfo(TFormatMask), nil, '',TFormatMaskProperty);
   RegisterPropertyEditor(TypeInfo(TNavBarMask), nil, 'TNavBarMask',TNavBarMaskProperty);
   RegisterPropertyEditor(TypeInfo(TLogFileName), nil, '',TLogFileNameProperty);
end;

end.
