unit SelPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,graphics,
  igriegastrs,igriegaclasses,funciones;

type
  TSelPanel = class(tcustomcontrol)
  private
     FColors:array[0..8] of TColor;
     FOver:Boolean;
     FOnMouseEnter,
     FOnMouseLeave:TNotifyEvent;
     FBorder:Boolean;
     FBorderWidth:integer;
     FPicture:TPicture;
     FPosXPicture:Word;
     FPosXText:Word;
     FText:TCaption;
     FTextFont:TFont;
     FScrew:TBitmap;
     FShowScrew:Boolean;
     FAlignment,
     FTextAlign: TAlignment;
     FBevel:Array[0..2] of TBoxBevel;
     FFocusRect:Integer;
     FGrad:Boolean;
     FGradDir:TDirection;
     procedure SetBevel(Index:Integer;Value:TBoxBevel);
     function GetBevel(Index:Integer):TBoxBevel;
     procedure SetColors(Index:Integer;Value:TColor);
     function GetColors(Index:integer):TColor;
     procedure SetBorder(Value:Boolean);
     procedure SetPicture(Value:TPicture);
     procedure SetBorderWidth(Value:integer);
     procedure SetPosXPicture(Value:Word);
     procedure SetPosXText(Value:Word);
     procedure SetText(Value:TCaption);
     procedure SetTextFont(Value:TFont);
     procedure FontChanged(Sender: TObject);
     procedure SetScrew(Value:TBitmap);
     procedure SetAlignment(Value: TAlignment);
     procedure SetTextAlign(Value: TAlignment);
     procedure SetDrawFocus(Value:Boolean);
     function GetDrawFocus:Boolean;
     procedure SetGrad(Value:Boolean);
     procedure SetGradDir(Value:TDirection);
    { Private declarations }
  protected
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMSetFocus); message WM_KILLFOCUS;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMBiDiModeChanged(var Message: TMessage); message CM_BIDIMODECHANGED;
    procedure KeyPress(var Key: Char);override;
    procedure Paint; override;
    procedure Click;override;
    { Protected declarations }
  public
     constructor Create(AOwner:TComponent);override;
     destructor Destroy;override;
     property Colors[Index:Integer]:TColor read GetColors Write SetColors;
     property Bevels[Index:Integer]:TBoxBevel read GetBevel write SetBevel;
    { Public declarations }
  published
     property Alignment: TAlignment read FAlignment write SetAlignment default taLeftJustify;
     property TextAlign: TAlignment read FTextAlign write SetTextAlign default taLeftJustify;
     property Color:TColor Index 0 read GetColors Write SetColors default clBtnFace;
     property BorderColor:TColor Index 1 read GetColors Write SetColors default clBlack;
     property GradColor:TColor Index 2 read GetColors Write SetColors default clBlack;
     property Bevel:TBoxBevel index 0 read GetBevel write SetBevel default bbNone;
     property FocusedColor:TColor Index 3 read GetColors Write SetColors default clBtnHighlight;
     property FocusedBorderColor:TColor Index 4 read GetColors Write SetColors default clBlack;
     property FocusedGradColor:TColor Index 5 read GetColors Write SetColors default clBlack;
     property FocusedBevel:TBoxBevel index 1 read GetBevel write SetBevel default bbNone;
     property OverColor:TColor Index 6 read GetColors Write SetColors default clBtnShadow;
     property OverBorderColor:TColor Index 7 read GetColors Write SetColors default clBlack;
     property OverGradColor:TColor Index 8 read GetColors Write SetColors default clBlack;
     property OverBevel:TBoxBevel index 2 read GetBevel write SetBevel default bbNone;
     property Border:Boolean read FBorder Write SetBorder default True;
     property BorderWidth:integer read FBorderWidth Write SetBorderWidth default 1;
     property Picture:TPicture read FPicture Write SetPicture;
     property PosXPicture:Word read FPosXPicture Write SetPosXPicture default 10;
     property PosXText:Word read FPosXText Write SetPosXText default 50;
     property Screw:TBitmap read FScrew Write SetScrew;
     property ShowScrew:Boolean read FShowScrew Write FShowScrew default false;
     property DrawFocusRect:Boolean read GetDrawFocus Write SetDrawFocus;
     property Gradient:Boolean read FGrad write SetGrad default false;
     Property GradDirection:TDirection read FGradDir write SetGradDir default dHorizontal;
     property Caption;
     property Text:TCaption read FText Write SetText;
     property TextFont:TFont read FTextFont Write SetTextFont;
     property OnMouseEnter:TNotifyEvent read FOnMouseEnter Write FOnMouseEnter;
     property OnMouseLeave:TNotifyEvent read FOnMouseLeave Write FOnMouseLeave;
     property BiDiMode;
     property TabStop;
     property TabOrder;
     property Action;
     property Align;
     property Anchors;
     property Visible;
     property Enabled;
     property Constraints;
     property DragCursor;
     property DragKind;
     property DragMode;
     property Font;
     property ParentBiDiMode;
     property ParentFont;
     property ParentShowHint;
     property PopupMenu;
     property ShowHint;
     property OnClick;
     property OnContextPopup;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEndDock;
     property OnEndDrag;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnStartDock;
     property OnStartDrag;
     property OnEnter;
     property OnExit;

    { Published declarations }
  end;
Function _BiDiMode(Alignment: TAlignment;BiDi:TBiDiMode):TAlignment;
procedure Register;

implementation
{$R selpanre}
Function _BiDiMode(Alignment: TAlignment;BiDi:TBiDiMode):TAlignment;
begin
  Result :=Alignment;
  if (SysLocale.MiddleEast) and (BiDi= bdRightToLeft) then
  case Alignment of
    taLeftJustify:  Result := taRightJustify;
    taRightJustify: result := taLeftJustify;
  end;
end;
constructor TSelPanel.Create(AOwner:TComponent);
begin
   inherited;
   FScrew:=TBitmap.Create;
   FScrew.LoadFromResourceName(Hinstance,'SCREW');
   FPicture:=TPicture.Create;
   Self.Width:=160;
   FTextFont:=TFont.Create;
   FTextFont.OnChange:=FontChanged;
   FTextFont.Color:=$00505050;
   FTextFont.Style:=[fsBold];
   FColors[0]:= clBtnFace;
   FColors[1]:=clBlack;
   FColors[2]:=clBlack;
   FColors[3]:=clBtnHighlight;
   FColors[4]:=clBlack;
   FColors[5]:=clBlack;
   FColors[6]:= clBtnShadow;
   FColors[7]:=clBlack;
   FColors[8]:=clBlack;
   TabStop:=True;
   Visible:=True;
   Enabled:=True;
   ControlStyle:=[csSetCaption,csClickEvents,csCaptureMouse,csDoubleClicks,csReflector,csActionClient,csOpaque];
   FBorder:=True;
   FBorderWidth:=1;
   FPosXPicture:=10;
   FPosXText:=50;
   FText:='';
   Font.Style:=[fsBold];
   FShowScrew:=False;
   FAlignment:=taLeftJustify;
   FTextAlign:=taLeftJustify;
   FBevel[0]:=bbNone;
   FBevel[1]:=bbNone;
   FBevel[2]:=bbNone;
   FFocusRect:=0;
   FGradDir:=dHorizontal;
   FGrad:=false;
end;
destructor TSelPanel.Destroy;
begin
   Picture.Free;
   FScrew.Free;
   FTextFont.Free;
   inherited;
end;
procedure TSelPanel.SetDrawFocus(Value:Boolean);
begin
   if Value then
      FFocusRect:=4
   else
      FFocusRect:=0;
   Invalidate;
end;
function TSelPanel.GetDrawFocus:Boolean;
begin
   Result:=(FFocusRect=4)
end;
procedure TSelPanel.SetBevel(Index:Integer;Value:TBoxBevel);
begin
   if FBevel[index]<>Value then
   begin
      FBevel[index]:=Value;
      Invalidate;
   end;
end;
function TSelPanel.GetBevel(Index:Integer):TBoxBevel;
begin
   result:=FBevel[index];
end;
procedure TSelPanel.SetPicture(Value:TPicture);
begin
   FPicture.Assign(Value);
   repaint;
end;
procedure TSelPanel.Paint;
   procedure Bevel(R:TRect;Bev:TBoxBevel);
   begin
      with canvas do
      if Ctl3D then
      case Bev of
         bbNone:canvas.Rectangle(R);
         bbRaised: drawedge(Handle,R,BDR_RAISEDOUTER,BF_SOFT or BF_RECT);
         bbLowered:drawedge(Handle,R,BDR_SUNKENOUTER,BF_SOFT or BF_RECT);
         bbRaisedLine:
            begin
               Inc(R.Left);
               Inc(R.Top);
               Brush.Color := clBtnShadow;
               FrameRect(R);
               OffsetRect(R, -1, -1);
               Brush.Color := clBtnHighlight;
               FrameRect(R);
            end;
         bbLoweredLine:
            begin
               Inc(R.Left);
               Inc(R.Top);
               Brush.Color := clBtnHighlight;
               FrameRect(R);
               OffsetRect(R, -1, -1);
               Brush.Color := clBtnShadow;
               FrameRect(R);
            end;
         bbEdgeBump:drawedge(Handle,R,EDGE_BUMP,BF_SOFT or BF_RECT);
         bbEdgeEtChed:drawedge(Handle,R,EDGE_ETCHED,BF_SOFT or BF_RECT);
      end
      else
         if Bev<>bbNone then
         begin
            Brush.Color := clwindowframe;
            FrameRect(R);
         end;
   end;
const
   AAlignment : array[taLeftJustify..taCenter] of uchar=(DT_LEFT,DT_RIGHT,DT_CENTER);
var
   R:TRect;
   Flags:Integer;
   despv,desph:Integer;
   X, Y, W, H: Integer;
   BevelE:TBoxBevel;
   cgrad:TColor;
   c:TGradColors;
begin
   setlength(c,2);
   despv:=3;
   Desph:=0;
   if border then
   begin
      despv:=despv+BorderWidth;
      Desph:=BorderWidth-1;
   end;
   Flags:=AAlignment[_BiDiMode(Alignment,BiDiMode)] or DT_NOPREFIX or DT_END_ELLIPSIS;
   with Canvas do
   begin
      Font:=Self.Font;
      Pen.Width:=BorderWidth;
      Pen.Color:=BorderColor;
      Bevele:=self.Bevel;
      Brush.Style:=bsSolid;
      Brush.Color:=Color;
      cgrad:=gradcolor;
      X := Pen.Width div 2;
      Y := X;
      W := Width - Pen.Width + 1;
      H := Height - Pen.Width + 1;
      if Focused then
      begin
         Pen.Color:=FocusedBorderColor;
         Brush.Color:=FocusedColor;
         cgrad:=Focusedgradcolor;
         Bevele:=FocusedBevel;
      end;
      if FOver then
      begin
         Pen.Color:=OverBorderColor;
         Brush.Color:=OverColor;
         cgrad:=Overgradcolor;
         Bevele:=OverBevel;
      end;
      if Gradient then
      begin
         c[0]:=CGrad;
         c[1]:=brush.Color;
         drawgradient(canvas,height,width,c,ord(GradDirection));
      end
      else
         FillRect(ClientRect);
      if Assigned(Picture.Graphic) then
      begin
         Picture.Graphic.Transparent:=True;
         if Picture.Graphic.ClassName='TBitmap' then
            Picture.Bitmap.TransparentMode:=tmAuto;
         Draw(PosXPicture+desph,((Height-Picture.Graphic.Height) div 2),Picture.Graphic);
      end;
      setbkmode(Handle,TRANSPARENT);
      R:=Rect(posxText+desph+FFocusRect,despv+FFocusRect,width-desph-10{for Screw}-FFocusRect,height-despv);
      DrawText(Handle, PChar(Caption), -1, R, Flags);
      Flags:=DT_WORDBREAK or AAlignment[_BiDiMode(TextAlign,BiDiMode)] or DT_NOPREFIX;
      R:=Rect(posxText+desph+FFocusRect,TextHeight(Caption)+despv+FFocusRect,width-despv-FFocusRect,height-despv-FFocusRect);
      font:=TextFont;
      DrawText(Handle, PChar(Text), -1, R, Flags);
      Brush.Style:=bsClear;
      if Border then
         bevel(rect(x,y,x+w,y+h),Bevele);
      if Focused and ShowScrew then
      begin
         FScrew.Transparent:=True;
         FScrew.TransparentMode:=tmAuto;
         Draw(desph+2,desph+2,FScrew);
         Draw(Width-desph-2-FScrew.Width,desph+2,FScrew);
         Draw(desph+2,Height-desph-2-FScrew.Height,FScrew);
         Draw(Width-desph-2-FScrew.Width,Height-desph-2-FScrew.Height,FScrew);
      end;
      if Focused and Self.DrawFocusRect then
      begin
         DrawFocusRect(Rect(posxText+desph+(FFocusRect div 2),despv+(FFocusRect div 2),width-despv-(FFocusRect div 2),height-despv-(FFocusRect div 2)));
      end;
   end;
end;

procedure TSelPanel.WMSetFocus(var Message: TWMSetFocus);
begin
   inherited;
   Invalidate;
end;

procedure TSelPanel.WMKillFocus(var Message: TWMSetFocus);
begin
   inherited;
   Invalidate;
end;

procedure TSelPanel.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  if Assigned(FOnmouseEnter) then FOnMouseEnter(Self);
  FOver:=True;
  Invalidate;
end;

procedure TSelPanel.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if Assigned(FOnmouseLeave) then FOnMouseLeave(Self);
  FOver:=False;
  Invalidate;
end;
procedure TSelPanel.CMBiDiModeChanged(var Message: TMessage);
begin
   inherited;
   if (SysLocale.MiddleEast) and (Message.wParam = 0) then Invalidate;
end;
procedure TSelPanel.KeyPress(var Key: Char);
begin
   if (Key=#13) or (Key=#32) then
      Click;
   Key:=#0;
end;
procedure  TSelPanel.Click;
begin
   inherited;
   SetFocus;
end;
procedure TSelPanel.SetColors(Index:Integer;Value:TColor);
begin
   if FColors[Index]<>Value then
   begin
      FColors[Index]:=Value;
      Invalidate;
   end;
end;
Function TSelPanel.GetColors(Index:Integer):TColor;
begin
   Result:=FColors[Index];
end;
procedure TSelPanel.SetBorder(Value:Boolean);
begin
   if FBorder<>Value then
   begin
      FBorder:=Value;
      Invalidate;
   end;
end;

procedure TSelPanel.SetBorderWidth(Value:integer);
begin
   if FBorderWidth<>Value then
   begin
      if Value>0 then
         FBorderWidth:=Value;
      Invalidate;
   end;
end;
procedure TSelPanel.SetPosXPicture(Value:Word);
begin
   if FPosXPicture<>Value then
      if value>0 then
      begin
         FPosXPicture:=Value;
         invalidate;
      end
      else
         if (csDesigning in ComponentState) then
            raise Exception.CreateResFmt(@SInvalidValueErrMsg,['mayor que 0']);
end;
procedure TSelPanel.SetPosXText(Value:Word);
begin
   if FPosXText<>Value then
      if Value>0 then
      begin
         FPosXText:=Value;
         invalidate;
      end
      else
         if (csDesigning in ComponentState) then
            raise Exception.CreateResFmt(@SInvalidValueErrMsg,['mayor que 0']);

end;
procedure TSelPanel.SetText(Value: TCaption);
begin
   if FText<>Value then
   begin
      FText:=Value;
      invalidate;
   end;
end;
procedure TSelPanel.CMTextChanged(var Message: TMessage);
begin
   inherited;
   invalidate;
end;
procedure TSelPanel.SetScrew(Value:TBitmap);
begin
   if Assigned(Value) then
   begin
      if (Value.Width>8) or (Value.Height>8) then
         raise Exception.CreateResFmt(@sInvalidBitmapSizeErrMsg,['8x8 pixels'])
      else
         FScrew.Assign(Value);
   end
   else
      FScrew.LoadFromResourceName(Hinstance,'SCREW');
   Invalidate;
end;
procedure TSelPanel.SetTextFont(Value:TFont);
begin
   FTextFont.Assign(Value);
end;
procedure TSelPanel.FontChanged(Sender: TObject);
begin
   Invalidate;
end;
procedure TSelPanel.SetAlignment(Value: TAlignment);
begin
   if FAlignment<>Value then
   begin
      FAlignment:=Value;
      Invalidate;
   end;
end;
procedure TSelPanel.SetTextAlign(Value: TAlignment);
begin
   if FTextAlign<>Value then
   begin
      FTextAlign:=Value;
      Invalidate;
   end;
end;
procedure TSelPanel.SetGrad(Value:Boolean);
begin
   if FGrad<>Value then
   begin
      FGrad:=value;
      invalidate;
   end;
end;
procedure TSelPanel.SetGradDir(Value:TDirection);
begin
   if FGradDir<>Value then
   begin
      FGradDir:=value;
      invalidate;
   end;
end;

procedure Register;
begin
  RegisterComponents('i-griegavcl', [TSelPanel]);
end;

end.


