
{*******************************************************}
{                                                       }
{       Borland Delphi Visual Component Library         }
{                                                       }
{       Copyright (c) 1995,99 Inprise Corporation       }
{                                                       }
{*******************************************************}
{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

unit dbnavE;



interface

uses Windows, SysUtils, Messages, Classes, Controls, Forms,dialogs,
     Graphics, Menus, StdCtrls, ExtCtrls, Mask, Buttons, ComCtrls, Db,dbctrls,gradiente,dbgrids,dbtables,funciones;

const
  InitRepeatPause = 400;  { pause before repeat timer (ms) }
  RepeatPause     = 100;  { pause before hint window displays (ms)}
  SpaceSize       =  5;   { size of space between special buttons }
  WM_GRADCHANGE = WM_APP + 400;

type
  TNavButtonE = class;
  TNavDataLink = class;

  TNavGlyph = (ngEnabled, ngDisabled);
  TNavigateBtnE = (nbFirst, nbPrior, nbNext, nbLast,
                  nbInsert, nbDelete, nbEdit, nbPost, nbCancel, nbRefresh,nbFind);
  TButtonSet = set of TNavigateBtnE;
  TNavButtonStyle = set of (nsAllowTimer, nsFocusRect);

  ENavClickE = procedure (Sender: TObject; Button: TNavigateBtnE;var cancel:boolean) of object;
  EOnNavClickE = procedure (Sender: TObject; Button: TNavigateBtnE) of object;
{ TDBNavigator }
  TWindowPos=class (TPersistent)
  private
    FTop,
    FLeft,
    FWidth,
    FHeight:Integer;
  public
     constructor Create;
  published
     Property Top:integer read FTop write FTop;
     Property Left:integer read FLeft write FLeft;
     Property Width:integer read FWidth write FWidth;
     Property Height:integer read FHeight write FHeight;
  end;

  TFieldFindParam=class (TPersistent)
  private
    FLike:boolean;
    FTableName:string;
    FDatabaseName:string;
    FKeyField:String ;
    FOtherFields:String;
    FOrderBy:string;
  public
    constructor Create;
  published
    Property OrderBy:String read FOrderBy Write ForderBy;
    Property KeyField:string read FKeyField write FKeyField;
    Property OtherFields:string read FOtherFields write FOtherFields;
    property DatabaseName:string read FDatabasename write FDatabasename;
    property TableName:string read FTableName write FTableName;
    property Like:boolean read FLike write FLike;
  end;
  TDBNavigatorE = class (TCustomControl)
  private
    FDataLink: TNavDataLink;
    FVisibleButtons: TButtonSet;
    FHints: TStrings;
    FDefHints: TStrings;
    ButtonWidth: Integer;
    MinBtnSize: TPoint;
    FOnNavClick: EOnNavClickE;
    FBeforeAction: ENavClickE;
    FocusedButton: TNavigateBtnE;
    FConfirmDelete: Boolean;
    FFlat: Boolean;
    FFullRepaint:boolean;
    FGradiente:TGradiente;
    FFind:TFindDialog;
    FField:TField;
    FFieldName:string;
    FFieldFindParam:TFieldFindParam;
    FFindWindowPos:TWindowPos;
    procedure BtnMouseDown (Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FindField(Sender: TObject);
    procedure ClickHandler(Sender: TObject);
    function GetDataSource: TDataSource;
    function GetHints: TStrings;
    procedure HintsChanged(Sender: TObject);
    procedure InitButtons;
    procedure InitHints;
    procedure SetDataSource(Value: TDataSource);
    procedure SetFlat(Value: Boolean);
    procedure SetHints(Value: TStrings);
    procedure SetSize(var W: Integer; var H: Integer);
    procedure SetVisible(Value: TButtonSet);
    procedure WMSize(var Message: TWMSize);  message WM_SIZE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure WMWindowPosChanging(var Message: TWMWindowPosChanging); message WM_WINDOWPOSCHANGING;
  protected
    Buttons: array[TNavigateBtnE] of TNavButtonE;
    procedure DataChanged;
    procedure EditingChanged;
    procedure ActiveChanged;
    procedure Loaded; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure GetChildren(Proc: TGetChildProc; Root: TComponent); override;
    procedure CalcMinSize(var W, H: Integer);
    procedure SetGradiente(value:Tgradiente);
  public
    Property FieldName:String read FFieldName;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure BtnClick(Index: TNavigateBtnE); virtual;
  published
    property FieldFindParam:TFieldFindParam read FFieldFindParam write FFieldFindParam;
    property FindWindowPos:TWindowPos read FFindWindowPos write FFindWindowPos;
    property Gradiente:TGradiente read FGradiente write SetGradiente stored true;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property VisibleButtons: TButtonSet read FVisibleButtons write SetVisible
      default [nbFirst, nbPrior, nbNext, nbLast, nbInsert, nbDelete,
        nbEdit, nbPost, nbCancel, nbRefresh,nbFind];
    property Align;
    property Anchors;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FullRepaint:boolean read FFullRepaint write FFullRepaint;
    property Flat: Boolean read FFlat write SetFlat default False;
    property Ctl3D;
    property Hints: TStrings read GetHints write SetHints;
    property ParentCtl3D;
    property ParentShowHint;
    property PopupMenu;
    property ConfirmDelete: Boolean read FConfirmDelete write FConfirmDelete default True;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property BeforeAction: ENavClicke read FBeforeAction write FBeforeAction;
    property OnClick: EOnNavClicke read FOnNavClick write FOnNavClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
  end;

{ TNavButton }

  TNavButtonE = class(TSpeedButton)
  private
    FIndex: TNavigateBtnE;
    FNavStyle: TNavButtonStyle;
    FRepeatTimer: TTimer;
    procedure TimerExpired(Sender: TObject);
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    destructor Destroy; override;
    property NavStyle: TNavButtonStyle read FNavStyle write FNavStyle;
    property Index : TNavigateBtnE read FIndex write FIndex;
  end;

{ TNavDataLink }

  TNavDataLink = class(TDataLink)
  private
    FNavigator: TDBNavigatorE;
  protected
    procedure EditingChanged; override;
    procedure DataSetChanged; override;
    procedure ActiveChanged; override;
  public
    constructor Create(ANav: TDBNavigatorE);
    destructor Destroy; override;
  end;


implementation

uses Clipbrd, DBConsts,  Math;


{$R DBCTRLS1}
{ BiDiMode support routines }

const
  SFirstRecord = 'First record';
  SPriorRecord = 'Prior record';
  SNextRecord = 'Next record';
  SLastRecord = 'Last record';
  SInsertRecord = 'Insert record';
  SDeleteRecord = 'Delete record';
  SEditRecord = 'Edit record';
  SPostEdit = 'Post edit';
  SCancelEdit = 'Cancel edit';
  SRefreshRecord = 'Refresh data';
  SFind = 'Find Data';


{ TDBNavigator }
var
  BtnTypeName: array[TNavigateBtnE] of PChar = ('FIRSTE', 'PRIORE', 'NEXTE',
    'LASTE', 'INSERTE', 'DELETEE', 'EDITE', 'POSTE', 'CANCELE', 'REFRESHE','FIND');
  BtnHintId: array[TNavigateBtnE] of string = (sFirstrecord,sPriorrecord,
    sNextrecord, sLastrecord,sInsertrecord, SDeleteRecord,SEditRecord,
    SPostEdit, SCancelEdit, SRefreshRecord,SFind);
constructor TWindowPos.create;
begin
   inherited;
   FTop:=-1;
   FLeft:=-1;
   FWidth:=-1;
   FHeight:=-1;
end;
constructor TFieldFindParam.Create;
begin
   inherited;
   FLike:=true;
   FTableName:='';
   FDatabaseName:='';
   FKeyField:='';
   FOtherFields:='';
   FOrderBy:='';
end;
procedure TDBNavigatorE.SetGradiente(value:Tgradiente);
begin
   FGradiente.ColorDesde:=value.ColorDesde;
   FGradiente.ColorHasta:=value.ColorHasta;
   Fgradiente.Direccion:=value.Direccion;
   FGradiente.Name:=value.Name;
end;
procedure TDBNavigatorE.FindField(Sender: TObject);
var
   opts:TLocateOptions;
   f:Tform;
   p1,p2:tpanel;
   b1,b2:tbitbtn;
   L:TDBGrid;
   DS:TDatasource;
   Q:TQuery;
   cfields:string;
begin
   opts:=[loPartialKey];
   if frMatchCase in ffind.Options then opts:=opts+[loCaseInsensitive];
   if frWholeWord in ffind.Options then opts:=opts-[loPartialKey];
   if FieldFindParam.like and (ffield.DataType=ftString) and (loPartialKey in opts) and
      (FieldFindParam.Databasename<>'') and (FieldFindParam.TableName<>'') then
      begin
      f:=tform.Createparented(self.Parentwindow);
      if (findwindowpos.Left>-1) or (findwindowpos.top>-1) then
      begin
         f.Top:=iif(findwindowpos.Top>-1,findwindowpos.Top,0);
         f.Left:=iif(findwindowpos.Left>-1,findwindowpos.Left,0);
      end
      else
         f.Position:=poDesktopCenter;
      f.Width:=iif(findwindowpos.Width>200,findwindowpos.Width,400);
      f.Height:=iif(findwindowpos.Height>=300,findwindowpos.Height,500);
      f.Width:=400;
      f.Height:=500;
      f.icon.Transparent:=true;
      f.Icon.Handle:=loadicon(HInstance,'ICO_BUSCA');
      p1:=tpanel.Create(f);
      P2:=tpanel.Create(f);
      p1.parent:=f;
      p2.parent:=f;
      p2.Height:=50;
      p2.Align:=alBottom;
      p1.Align:=alClient;
      p1.Visible:=true;
      p2.Visible:=true;
      b1:=tbitbtn.Create(p2);
      b1.top:= (p2.Height - b1.Height) div 2;
      b1.Kind:=bkOk;
      b1.Caption:='&Aceptar';
      b2:=tbitbtn.Create(p2);
      b1.Left:=(f.Width - (b1.Width+b2.Width+2)) div 2;
      b2.Top:=b1.Top;
      b2.Kind:=bkCancel;
      b2.caption:='&Cancelar';
      b2.Left:=b1.Left+b1.Width+2;
      b1.parent:=p2;
      b2.parent:=p2;
      l:=tdbgrid.Create(p1);
      l.parent:=p1;
      l.Align:=alClient;
      DS:=tdatasource.Create(f);
      q:=tquery.Create(f);
      q.DatabaseName:=FieldFindParam.databasename;
      ds.DataSet:=q;
      l.DataSource:=ds;
      cfields:=iif(FieldFindParam.otherfields<>'',stringreplace(FieldFindParam.otherfields,',','#',[rfReplaceAll]),' ');
      cfields:=iif(pos(uppercase(ffield.fieldname),uppercase(cfields))>0,cfields,ffield.fieldname+'#'+cfields);
      cfields:=iif(pos(uppercase(FieldFindParam.keyfield),uppercase(cfields))>0,cfields,FieldFindParam.keyfield+'#'+cfields);
      cfields:=stringreplace(cfields,'#',',',[rfReplaceAll]);
      q.sql.Add('Select '+cfields+' from '+FieldFindParam.tablename);
      if (loPartialKey in opts) and (loCaseInsensitive in opts) then
         q.sql.add('where upper('+ffield.fieldname+ ') like ''%'+uppercase(ffind.FindText)+'%''')
      else
         q.sql.add('where '+ffield.fieldname+ ' like ''%'+ffind.FindText+'%''');
      if ffield.DataSet.Filter<>'' then
         q.sql.add('and ('+ffield.DataSet.Filter+')');
      if FieldFindParam.orderby<>'' then
         q.SQL.add('Order by '+FieldFindParam.orderby);
      try
         q.open;
         f.Caption:='Resultados de busqueda ['+inttostr(q.recordcount)+' registros recuperados]';
         if f.ShowModal=mrok then
         begin
            try
               if not FDataLink.DataSet.Locate(iif((uppercase(ffield.fieldname)=uppercase(FieldFindParam.keyfield)) and (FieldFindParam.keyfield<>''),ffield.fieldname,FieldFindParam.keyfield),q.fieldbyname(iif((uppercase(ffield.fieldname)=uppercase(FieldFindParam.keyfield)) and (FieldFindParam.keyfield<>''),ffield.fieldname,FieldFindParam.keyfield)).asstring,opts) then
                  showmessage('No encontrado')
               else
                  ffind.CloseDialog;
            finally
            end;
         end;
         q.close;
         q.free;
      finally
         f.free;
      end;
   end
   else
   begin
      try
         if not FDataLink.DataSet.Locate(ffield.Fieldname,ffind.FindText,opts) then
            showmessage('No encontrado')
         else
            ffind.CloseDialog;
      finally
      end;
   end;
end;
constructor TDBNavigatorE.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FFieldName:='';
  fgradiente:=tgradiente.Create(self);
  fgradiente.Align:= alClient;
  fgradiente.Name:='Grad';
  {$IFDEF D6_OR_HIGHER}
  fgradiente.SetSubComponent(true);
  {$ENDIF}
  fgradiente.Parent:=self;
  fFieldFindParam:=TFieldFindParam.Create;
  canvas.brush.Style:=Bsclear;
  ControlStyle := ControlStyle-[csAcceptsControls,csSetCaption,csOpaque];
  if not NewStyleControls then ControlStyle := ControlStyle + [csFramed];
  FDataLink := TNavDataLink.Create(Self);
  FVisibleButtons := [nbFirst, nbPrior, nbNext, nbLast, nbInsert,
    nbDelete, nbEdit, nbPost, nbCancel, nbRefresh,nbFind];
  FHints := TStringList.Create;
  TStringList(FHints).OnChange := HintsChanged;
  InitButtons;
  InitHints;
  BevelOuter := bvNone;
  BevelInner := bvNone;
  Width := 241;
  Height := 25;
  ButtonWidth := 0;
  FocusedButton := nbFirst;
  FConfirmDelete := True;
  FullRepaint := False;
  fFind:=tfinddialog.Create(self);
  ffind.Options:=[frHideUpDown,frMatchCase];
  ffind.OnFind:=FindField;
  ffindwindowpos:=twindowpos.Create;
end;

destructor TDBNavigatorE.Destroy;
begin
  FDefHints.Free;
  FDataLink.Free;
  FHints.Free;
  FDataLink := nil;
  fgradiente.free;
  fFieldFindParam.Free;
  ffindwindowpos.Destroy;
  inherited Destroy;
end;

procedure TDBNavigatorE.InitButtons;
var
  I: TNavigateBtnE;
  Btn: TNavButtonE;
  X: Integer;
  ResName: string;
begin
  MinBtnSize := Point(20, 18);
  X := 0;
  for I := Low(Buttons) to High(Buttons) do
  begin
    Btn := TNavButtonE.Create (Self);
    Btn.Flat := Flat;
    Btn.Index := I;
    Btn.Transparent:=true;
    Btn.Visible := I in FVisibleButtons;
    Btn.Enabled := True;
    Btn.SetBounds (X, 0, MinBtnSize.X, MinBtnSize.Y);
    FmtStr(ResName, 'dbn_%s', [BtnTypeName[I]]);
    Btn.Glyph.LoadFromResourceName(HInstance, ResName);
    Btn.NumGlyphs := 2;
    Btn.Enabled := False;
    Btn.Enabled := True;
    Btn.OnClick := ClickHandler;
    Btn.OnMouseDown := BtnMouseDown;
    Btn.Parent := Self;
    Buttons[I] := Btn;
    Buttons[i].Transparent:=true;
    X := X + MinBtnSize.X;
  end;
  Buttons[nbPrior].NavStyle := Buttons[nbPrior].NavStyle + [nsAllowTimer];
  Buttons[nbNext].NavStyle  := Buttons[nbNext].NavStyle + [nsAllowTimer];
end;

procedure TDBNavigatorE.InitHints;
var
  I: Integer;
  J: TNavigateBtnE;
begin
  if not Assigned(FDefHints) then
  begin
    FDefHints := TStringList.Create;
    for J := Low(Buttons) to High(Buttons) do
      FDefHints.Add(BtnHintId[J]);
  end;
  for J := Low(Buttons) to High(Buttons) do
    Buttons[J].Hint := FDefHints[Ord(J)];
  J := Low(Buttons);
  for I := 0 to (FHints.Count - 1) do
  begin
    if FHints.Strings[I] <> '' then Buttons[J].Hint := FHints.Strings[I];
    if J = High(Buttons) then Exit;
    Inc(J);
  end;
end;

procedure TDBNavigatorE.HintsChanged(Sender: TObject);
begin
  InitHints;
end;

procedure TDBNavigatorE.SetFlat(Value: Boolean);
var
  I: TNavigateBtnE;
begin
  if FFlat <> Value then
  begin
    FFlat := Value;
    for I := Low(Buttons) to High(Buttons) do
      Buttons[I].Flat := Value;
    invalidate;
  end;
end;

procedure TDBNavigatorE.SetHints(Value: TStrings);
begin
  if Value.Text = FDefHints.Text then
    FHints.Clear else
    FHints.Assign(Value);
end;

function TDBNavigatorE.GetHints: TStrings;
begin
  if (csDesigning in ComponentState) and not (csWriting in ComponentState) and
     not (csReading in ComponentState) and (FHints.Count = 0) then
    Result := FDefHints else
    Result := FHints;
end;

procedure TDBNavigatorE.GetChildren(Proc: TGetChildProc; Root: TComponent);
begin
end;

procedure TDBNavigatorE.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
{  if (Operation = opRemove) and (FGrad <> nil) and
    (AComponent = Grad) then Grad := nil;}
end;

procedure TDBNavigatorE.SetVisible(Value: TButtonSet);
var
  I: TNavigateBtnE;
  W, H: Integer;
begin
  W := Width;
  H := Height;
  FVisibleButtons := Value;
  for I := Low(Buttons) to High(Buttons) do
    Buttons[I].Visible := I in FVisibleButtons;
  SetSize(W, H);
  if (W <> Width) or (H <> Height) then
    inherited SetBounds (Left, Top, W, H);
  Invalidate;
end;

procedure TDBNavigatorE.CalcMinSize(var W, H: Integer);
var
  Count: Integer;
  I: TNavigateBtnE;
begin
  if (csLoading in ComponentState) then Exit;
  if Buttons[nbFirst] = nil then Exit;

  Count := 0;
  for I := Low(Buttons) to High(Buttons) do
    if Buttons[I].Visible then
      Inc(Count);
  if Count = 0 then Inc(Count);

  W := Max(W, Count * MinBtnSize.X);
  H := Max(H, MinBtnSize.Y);

  if Align = alNone then W := (W div Count) * Count;
end;

procedure TDBNavigatorE.SetSize(var W: Integer; var H: Integer);
var
  Count: Integer;
  I: TNavigateBtnE;
  Space, Temp, Remain: Integer;
  X: Integer;
begin
  if (csLoading in ComponentState) then Exit;
  if Buttons[nbFirst] = nil then Exit;

  CalcMinSize(W, H);

  Count := 0;
  for I := Low(Buttons) to High(Buttons) do
    if Buttons[I].Visible then
      Inc(Count);
  if Count = 0 then Inc(Count);

  ButtonWidth := W div Count;
  Temp := Count * ButtonWidth;
  if Align = alNone then W := Temp;

  X := 0;
  Remain := W - Temp;
  Temp := Count div 2;
  for I := Low(Buttons) to High(Buttons) do
  begin
    if Buttons[I].Visible then
    begin
      Space := 0;
      if Remain <> 0 then
      begin
        Dec(Temp, Remain);
        if Temp < 0 then
        begin
          Inc(Temp, Count);
          Space := 1;
        end;
      end;
      Buttons[I].SetBounds(X, 0, ButtonWidth + Space, Height);
      Inc(X, ButtonWidth + Space);
    end
    else
      Buttons[I].SetBounds (Width + 1, 0, ButtonWidth, Height);
  end;
end;

procedure TDBNavigatorE.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
var
  W, H: Integer;
begin
  W := AWidth;
  H := AHeight;
  if not HandleAllocated then SetSize(W, H);
  inherited SetBounds (ALeft, ATop, W, H);
end;

procedure TDBNavigatorE.WMSize(var Message: TWMSize);
var
  W, H: Integer;
begin
  inherited;
  W := Width;
  H := Height;
  SetSize(W, H);
end;

procedure TDBNavigatorE.WMWindowPosChanging(var Message: TWMWindowPosChanging);
begin
  inherited;
  if (SWP_NOSIZE and Message.WindowPos.Flags) = 0 then
    CalcMinSize(Message.WindowPos.cx, Message.WindowPos.cy);
end;

procedure TDBNavigatorE.ClickHandler(Sender: TObject);
begin
  BtnClick (TNavButtonE (Sender).Index);
end;

procedure TDBNavigatorE.BtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  OldFocus: TNavigateBtnE;
begin
  OldFocus := FocusedButton;
  FocusedButton := TNavButtonE (Sender).Index;
  if TabStop and (GetFocus <> Handle) and CanFocus then
  begin
    SetFocus;
    if (GetFocus <> Handle) then
      Exit;
  end
  else if TabStop and (GetFocus = Handle) and (OldFocus <> FocusedButton) then
  begin
    Buttons[OldFocus].Invalidate;
    Buttons[FocusedButton].Invalidate;
  end;
end;

procedure TDBNavigatorE.BtnClick(Index: TNavigateBtnE);
   function ReturnFieldName:string;
   begin
      result:='';
      if pos(screen.ActiveControl.ClassName,'TDBEdit#TDBText#TDBGrid#TDBCheckBox')>0 then
         if screen.ActiveControl.ClassName='TDBEdit' then
            result:=tdbedit(screen.activecontrol).field.fieldname
         else
            if screen.ActiveControl.ClassName='TDBCheckBox' then
               result:=TDBCheckBox(screen.activecontrol).field.FieldName
            else
               if screen.ActiveControl.ClassName='TDBGrid' then
                  result:=tdbgrid(screen.activecontrol).selectedfield.FieldName
               else
                  result:=tdbtext(screen.activecontrol).field.FieldName;
   end;
var
   cancel:boolean;
begin
  if (DataSource <> nil) and (DataSource.State <> dsInactive) then
  begin
    cancel:=false;
    if not (csDesigning in ComponentState) and Assigned(FBeforeAction) then
    begin
      ffieldName:=returnfieldName;
      FBeforeAction(Self, Index,cancel);
    end;
    if not cancel then
    with DataSource.DataSet do
    begin
      case Index of
        nbPrior: Prior;
        nbNext: Next;
        nbFirst: First;
        nbLast: Last;
        nbInsert: Insert;
        nbEdit: Edit;
        nbCancel: Cancel;
        nbPost: Post;
        nbRefresh: Refresh;
        nbDelete:
          if not FConfirmDelete or
            (MessageDlg('Borrar Registro?', mtConfirmation,
            mbOKCancel, 0) <> idCancel) then Delete;
        nbFind: if pos(screen.ActiveControl.ClassName,'TDBEdit#TDBText#TDBGrid#TDBCheckBox')>0 then
                   try
                      if screen.ActiveControl.ClassName='TDBEdit' then
                      begin
                        if (not tdbedit(screen.activecontrol).field.isnull) then
                        begin
                           ffield:=tdbedit(screen.activecontrol).field;
                           ffind.Execute;
                        end
                      end
                      else
                      if screen.ActiveControl.ClassName='TDBCheckBox' then
                      begin
                        if (not TDBCheckBox(screen.activecontrol).field.isnull) then
                        begin
                           ffield:=TDBCheckBox(screen.activecontrol).field;
                           ffind.Execute;
                        end
                      end
                      else
                        if screen.ActiveControl.ClassName='TDBGrid' then
                        begin
                           if (not tdbgrid(screen.activecontrol).selectedfield.isnull) then
                           begin
                              ffield:=tdbgrid(screen.activecontrol).selectedfield;
                              ffind.Execute;
                           end;
                        end
                        else
                        begin
                          if (not tdbtext(screen.activecontrol).field.isnull) then
                          begin
                              ffield:=tdbtext(screen.activecontrol).field;
                              ffind.Execute;
                          end;
                        end;
                   finally
                   end;
      end;
    end;
  end;
  if not (csDesigning in ComponentState) and Assigned(FOnNavClick) then
    FOnNavClick(Self, Index);
end;

procedure TDBNavigatorE.WMSetFocus(var Message: TWMSetFocus);
begin
  Buttons[FocusedButton].Invalidate;
end;

procedure TDBNavigatorE.WMKillFocus(var Message: TWMKillFocus);
begin
  Buttons[FocusedButton].Invalidate;
end;

procedure TDBNavigatorE.KeyDown(var Key: Word; Shift: TShiftState);
var
  NewFocus: TNavigateBtnE;
  OldFocus: TNavigateBtnE;
begin
  OldFocus := FocusedButton;
  case Key of
    VK_RIGHT:
      begin
        NewFocus := FocusedButton;
        repeat
          if NewFocus < High(Buttons) then
            NewFocus := Succ(NewFocus);
        until (NewFocus = High(Buttons)) or (Buttons[NewFocus].Visible);
        if NewFocus <> FocusedButton then
        begin
          FocusedButton := NewFocus;
          Buttons[OldFocus].Invalidate;
          Buttons[FocusedButton].Invalidate;
        end;
      end;
    VK_LEFT:
      begin
        NewFocus := FocusedButton;
        repeat
          if NewFocus > Low(Buttons) then
            NewFocus := Pred(NewFocus);
        until (NewFocus = Low(Buttons)) or (Buttons[NewFocus].Visible);
        if NewFocus <> FocusedButton then
        begin
          FocusedButton := NewFocus;
          Buttons[OldFocus].Invalidate;
          Buttons[FocusedButton].Invalidate;
        end;
      end;
    VK_SPACE:
      begin
        if Buttons[FocusedButton].Enabled then
          Buttons[FocusedButton].Click;
      end;
  end;
end;

procedure TDBNavigatorE.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end;

procedure TDBNavigatorE.DataChanged;
var
  UpEnable, DnEnable: Boolean;
begin
  UpEnable := Enabled and FDataLink.Active and not FDataLink.DataSet.BOF;
  DnEnable := Enabled and FDataLink.Active and not FDataLink.DataSet.EOF;
  Buttons[nbFirst].Enabled := UpEnable;
  Buttons[nbPrior].Enabled := UpEnable;
  Buttons[nbNext].Enabled := DnEnable;
  Buttons[nbLast].Enabled := DnEnable;
  Buttons[nbFind].Enabled := Enabled and FDataLink.Active;
  Buttons[nbDelete].Enabled := Enabled and FDataLink.Active and
    FDataLink.DataSet.CanModify and
    not (FDataLink.DataSet.BOF and FDataLink.DataSet.EOF);
end;

procedure TDBNavigatorE.EditingChanged;
var
  CanModify: Boolean;
begin
  CanModify := Enabled and FDataLink.Active and FDataLink.DataSet.CanModify;
  Buttons[nbInsert].Enabled := CanModify;
  Buttons[nbEdit].Enabled := CanModify and not FDataLink.Editing;
  Buttons[nbPost].Enabled := CanModify and FDataLink.Editing;
  Buttons[nbCancel].Enabled := CanModify and FDataLink.Editing;
  Buttons[nbRefresh].Enabled := CanModify;
  Buttons[nbFind].Enabled := CanModify;
end;

procedure TDBNavigatorE.ActiveChanged;
var
  I: TNavigateBtnE;
begin
  if not (Enabled and FDataLink.Active) then
    for I := Low(Buttons) to High(Buttons) do
      Buttons[I].Enabled := False
  else
  begin
    DataChanged;
    EditingChanged;
  end;
end;

procedure TDBNavigatorE.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  if not (csLoading in ComponentState) then
    ActiveChanged;
end;

procedure TDBNavigatorE.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
  if not (csLoading in ComponentState) then
    ActiveChanged;
  if Value <> nil then Value.FreeNotification(Self);
end;

function TDBNavigatorE.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure TDBNavigatorE.Loaded;
var
  W, H: Integer;
begin
  inherited Loaded;
  W := Width;
  H := Height;
  SetSize(W, H);
  if (W <> Width) or (H <> Height) then
    inherited SetBounds (Left, Top, W, H);
  InitHints;
  ActiveChanged;
end;

{TNavButton}

destructor TNavButtonE.Destroy;
begin
  if FRepeatTimer <> nil then
    FRepeatTimer.Free;
  inherited Destroy;
end;

procedure TNavButtonE.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown (Button, Shift, X, Y);
  if nsAllowTimer in FNavStyle then
  begin
    if FRepeatTimer = nil then
      FRepeatTimer := TTimer.Create(Self);

    FRepeatTimer.OnTimer := TimerExpired;
    FRepeatTimer.Interval := InitRepeatPause;
    FRepeatTimer.Enabled  := True;
  end;
end;

procedure TNavButtonE.MouseUp(Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);
begin
  inherited MouseUp (Button, Shift, X, Y);
  if FRepeatTimer <> nil then
    FRepeatTimer.Enabled  := False;
end;

procedure TNavButtonE.TimerExpired(Sender: TObject);
begin
  FRepeatTimer.Interval := RepeatPause;
  if (FState = bsDown) and MouseCapture then
  begin
    try
      Click;
    except
      FRepeatTimer.Enabled := False;
      raise;
    end;
  end;
end;

procedure TNavButtonE.Paint;
var
  R: TRect;
begin
  inherited Paint;
  if (GetFocus = Parent.Handle) and
     (FIndex = TDBNavigatorE (Parent).FocusedButton) then
  begin
    R := Bounds(0, 0, Width, Height);
    InflateRect(R, -3, -3);
    if FState = bsDown then
      OffsetRect(R, 1, 1);
    Canvas.Brush.Style := bsclear;
    Font.Color := clBtnShadow;
    DrawFocusRect(Canvas.Handle, R);
  end;
end;

{ TNavDataLink }

constructor TNavDataLink.Create(ANav: TDBNavigatorE);
begin
  inherited Create;
  FNavigator := ANav;
  VisualControl := True;
end;

destructor TNavDataLink.Destroy;
begin
  FNavigator := nil;
  inherited Destroy;
end;

procedure TNavDataLink.EditingChanged;
begin
  if FNavigator <> nil then FNavigator.EditingChanged;
end;

procedure TNavDataLink.DataSetChanged;
begin
  if FNavigator <> nil then FNavigator.DataChanged;
end;

procedure TNavDataLink.ActiveChanged;
begin
  if FNavigator <> nil then FNavigator.ActiveChanged;
end;

end.
