unit editc;

interface

uses
  Windows, Messages, SysUtils,dialogs, Classes, Controls, StdCtrls,buttons,graphics;
const
  AlignText:array[taLeftJustify..taCenter] of DWORD =(ES_LEFT,ES_RIGHT,ES_CENTER);
type
  TOnCheckBoxClick = procedure(Sender : TObject) of object;
  TSide=(sbLeft,sbRight);
  TCustomeditc = class(TCustomEdit)
  private
     FCheckBox:TCheckBox;
     FOnCheckBoxClick : TOnCheckBoxClick;
     FWidthButton:Integer;
     FSide:TSide;
     FAlignment: TAlignment;
     procedure SetEditRect;
     procedure ClickButton(Sender: TObject);
     Procedure SetSide(Value:TSide);
     Procedure SetAlignment(value:TAlignment);
     procedure WMSize(var Message: TWMSize); message WM_SIZE;
     procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    { Private declarations }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure SetChecked(Value:Boolean);
    function GetChecked:Boolean;
    property OnCheckBoxClick : TOnCheckBoxClick read FOnCheckBoxClick write FOnCheckBoxClick;
    property Side:TSide read FSide write SetSide default sbRight;
    property Alignment: TAlignment read FAlignment write SetAlignment;
    property Checked:Boolean read GetChecked Write SetChecked default false;
    Property ReadOnly;
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  published
    { Published declarations }
  end;
  Teditc = class(TCustomeditc)
  published
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Checked;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    property OnCheckBoxClick;
    property Side;
    property Alignment;
  end;
implementation

constructor TCustomeditc.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FAlignment:=taLeftJustify;
  FCheckBox:=TCheckBox.Create(self);
  FCheckBox.Width := 12;
  FCheckBox.Height := Height-2;
  FCheckBox.Top:=1;
  FCheckBox.Left:=1;
  FCheckBox.Visible := True;
  FCheckBox.Parent := Self;
  FCheckBox.OnClick:=clickbutton;
  FCheckBox.Cursor:=crArrow;
  FSide:=sbRight;
  FWidthButton:=trunc((FCheckBox.Width*100/width));
end;
destructor TCustomeditc.Destroy;
begin
   FCheckBox.Free;
   inherited;
end;
procedure TCustomeditc.SetChecked(Value:Boolean);
begin
   if Value<>FCheckBox.Checked then
      FCheckBox.Checked:=Value;
end;
function TCustomeditc.GetChecked:Boolean;
begin
   Result:=FCheckBox.Checked;
end;
procedure TCustomeditc.Clickbutton(sender:tobject);
begin
   if not (csDesigning in ComponentState) then
   begin
      if assigned(fOnCheckBoxClick) then
      begin
         fOnCheckBoxClick(sender);
      end;
      FCheckBox.Parent.SetFocus
   end;
end;
procedure TCustomeditc.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN or ES_MULTILINE  or AlignText[FAlignment] or ES_AUTOHSCROLL;
end;
procedure TCustomeditc.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

procedure TCustomeditc.SetEditRect;
var
  Loc: TRect;
begin
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@Loc));
  if fside=sbLeft then
  begin
     Loc.Bottom := ClientHeight + 1;
     Loc.Right := ClientWidth - 2;
     Loc.Top := 0;
     Loc.Left := FCheckBox.Width + 2;
  end
  else
  begin
     Loc.Bottom := ClientHeight + 1;
     Loc.Right := ClientWidth - 2 - FCheckBox.Width;
     Loc.Top := 0;
     Loc.Left := 0;
  end;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;
procedure TCustomeditc.WMSize(var Message: TWMSize);
begin
  inherited;
  if ctl3d then
     FCheckBox.Height:=ClientHeight-5
  else
     FCheckBox.Height:=ClientHeight-2;
  SetEditRect;
end;
procedure TCustomeditc.WMPaint(var Message: TWMPaint);
begin
  if FSide=sbLeft then
     FCheckBox.Left:=1
  else
     FCheckBox.Left:=(ClientWidth - 2 -FCheckBox.Width);
  if ctl3d then
     FCheckBox.Height:=ClientHeight-5
  else
     FCheckBox.Height:=ClientHeight-2;
  SetEditRect;
  inherited;
end;
Procedure TCustomeditc.SetSide(Value:TSide);
begin
   if fside<>value then
   begin
      fside:=value;
      if value=sbLeft then
         FCheckBox.Left:=1
      else
         FCheckBox.Left:=(ClientWidth - 2 -FCheckBox.Width);
      invalidate;
      SetEditRect;
   end;
end;
Procedure TCustomeditc.SetAlignment(value:TAlignment);
begin
   if FAlignment<>value then
   begin
      FAlignment:=value;
      ReCreateWnd;
   end;
end;
end.
