{$IFNDEF VER90} //If not D2
  {$DEFINE D3_OR_hIGHER}
  {$IFNDEF VER100} //If not D3
    {$DEFINE D4_OR_HIGHER}
    {$IFNDEF VER120} //If not D4
      {DEFINE D5_OR_HIGHER}        //2.4
      {$IFNDEF VER130} //If not D5 //2.4
        {$DEFINE D6_OR_HIGHER}
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
unit funciones;

interface
uses
  windows,ComObj,Graphics,forms,Controls,
  Messages,Dialogs,sysutils,classes,math,igriegastrs;
{const
   maxnumbercolors=100;
   MinNumberPoints=0;
   MaxNumberPoints=20;}
type
   pSplitRGBArray  =  ^TSplitRGBArray;
   TSplitRGBarray  =  ARRAY[0..32768] OF TRGBTriple;
   TSplitRGB  = (sRed,sGreen,sBlue);
   TDecodeString = array[1..2]of array of string;
   TGradColors =array of TColor;
   TFormatMask = type string;
   TLogFileName=Type String;
   TNavBarMask=Type String;
// Colecciones relacionadas con controles
  TControlItem=class(TCollectionItem)
     private
        FControl:TControl;
        procedure SetControl(value:TControl);
     protected
        function GetDisplayName: string; override;
     public
        constructor Create(Collection:TCollection);override;
     published
        property Control:TControl read FControl Write SetControl;
  end;
  TControls=Class(TCollection)
     private
        FOwner:TPersistent;
        function GetItem(Index:Integer):TControlItem;
        Procedure SetItem(Index:Integer;Value:TControlItem);
     protected
        function GetOwner:TPersistent;override;
        procedure Notify(Item: TCollectionItem; Action: TCollectionNotification);override;
     public
         Constructor Create(Owner:TPersistent);
         Function Add:TControlItem;
         property Items[Index:Integer]:TControlItem read Getitem write SetItem; default;
     published
  end;
  TBoolean=Class(TObject)
     private
        FValue:Boolean;
     public
        constructor Create;overload;
        constructor Create(V:Boolean);overload;
        constructor Create(V:Integer);overload;
        constructor Create(v:String);overload;
        property Value:Boolean read FValue write FValue;
        Function F_OR(V:Boolean):Boolean;
        Function F_AND(V:Boolean):Boolean;
        Function F_XOR(V:Boolean):Boolean;
        Function toString:String;
        Function toInt:Integer;
  end;

  TPoints=array of TPoint;
procedure Cross(Canvas:TCanvas;p:Tpoint;radius:integer=5;color:TColor=clRed);
function Decode(cond:string;valores:TDecodeString;ifnoexist:string):string;
function Iif(cond:boolean;ctrue:string;cfalse:string):string; overload;
function Iif(cond:boolean;ctrue:integer;cfalse:integer):integer; overload;
function Iif(cond:boolean;ctrue:double;cfalse:double):double; overload;
function Iif(cond:boolean;ctrue:boolean;cfalse:boolean):boolean; overload;
function IfThen(AValue: Boolean; const ATrue: TRect; const AFalse: TRect): TRect; overload;
function Between(value,n1,n2:integer):boolean; overload;
function Between(value,n1,n2:Real):boolean; overload;
function Between(value,n1,n2:double):boolean; overload;
function Between(value,n1,n2:String):boolean; overload;
function Between(value,n1,n2:Word):boolean; overload;
function ColorToHtml(DColor:TColor):string; overload;
function ComponentToString(Component: TComponent): string;
procedure StringToComponent(Component: TComponent;Value: string);
Procedure SaveComponent(Component: TComponent;filename:tfilename);
Procedure LoadComponent(Component:TComponent;filename:tfilename);
Function FileTemp(prefix:string):string;
Function FileTempCurrent(prefix:string):string;
procedure IncPoint(var P:TPoint;N:longint=1);
procedure DecPoint(var P:TPoint;N:longint=1);
procedure Sleep(MSeconds : integer);
procedure SetChanelRGB(Bmp:TBitmap;Color:TSplitRGB);
procedure SetChanelRGBRed(Bmp:TBitmap);
procedure SetChanelRGBGreen(Bmp:TBitmap);
procedure SetChanelRGBBlue(Bmp:TBitmap);
procedure MergeChanelRGB(bmp:TBitmap;bmpR:TBitmap;bmpG:TBitmap;bmpB:TBitmap);
procedure brightness(Bmp:TBitmap;value:integer);
function BitmapToRegion(hBmp: HBITMAP; cTransparentColor: COLORREF=0;
  cTolerance: COLORREF=$010101): HRGN;
procedure DrawGradient(B:TBitmap;C:TGradColors;dir:integer);overload;
procedure DrawGradient(B:TCanvas;h,w:integer;C:TGradColors;dir:integer);overload;
function BevelToEdge(value:TBevelCut;Inner:Boolean):Cardinal;
implementation
{---
Felipe Rocha Machado
BitmapToRegion - The code below is a translation from the original C
   language version by Jean-Edouard Lachand-Robert

hBmp : Source bitmap
cTransparentColor: Color base for the "transparent" pixels(default black)
cTolerance : Color tolerance for the "transparent" pixels.

A pixel is assumed to be transparent if the value of each of its 3 components
(blue, green and red) is greater or equal to the corresponding value
in cTransparentColor and is lower or equal to the corresponding value
in cTransparentColor + cTolerance.
--- }

function BitmapToRegion(hBmp: HBITMAP; cTransparentColor: COLORREF=0;
  cTolerance: COLORREF=$010101): HRGN;
const
  AllocUnit = 100;
type
  TRectArray = Array[0..0] of TRect;
  LONG = LongInt;
  PLONG = ^LONG;
var
  h, Rgn: HRGN;
  hMemDC, h_DC: HDC;
  hBmp32, HoldBmp: HBITMAP;
  bm, bm32: BITMAP;
  RGB32BITSBITMAPINFO: BITMAPINFOHEADER;
  BITMAP_INFO: ^BITMAPINFO;
  pbBits32: pointer;
  hData: THandle;
  pData: PRgnData;
  lr, lg, lb, hr, hg, hb: Byte;
  b: Byte;
  p32: PByte;
  p: PLONG;
  x,y, x0: Integer;
  pr: ^TRectArray;
  MaxRects: DWORD;
begin 
  Rgn := 0;

  { Create a memory DC inside which we will scan the bitmap content } 
  hMemDC := CreateCompatibleDC(0); 
  if hMemDC > 0 then
  begin 
    { get Bitmap size }
    GetObject(hBmp, SizeOf(bm), @bm); 

    { Create a 32-bit depth bitmap and select it into the memory DC }
    with RGB32BITSBITMAPINFO do
    begin 
      biSize := sizeof(BITMAPINFOHEADER); // biSize 
      biWidth := bm.bmWidth; // biWidth; 
      biHeight := bm.bmHeight; // biHeight; 
      biPlanes := 1; // biPlanes; 
      biBitCount := 32; // biBitCount 
      biCompression := BI_RGB; // biCompression;
      biSizeImage := 0; // biSizeImage; 
      biXPelsPerMeter := 0; // biXPelsPerMeter;
      biYPelsPerMeter := 0; // biYPelsPerMeter;
      biClrUsed := 0; // biClrUsed; 
      biClrImportant := 0; // biClrImportant; 
    end;
    BITMAP_INFO := @RGB32BITSBITMAPINFO; // points to the previous structure

    hBmp32 := CreateDIBSection(hMemDC, BITMAP_INFO^, DIB_RGB_COLORS,
    pbBits32, 0, 0);
    if hBmp32 > 0 then 
    begin
      HoldBmp := SelectObject(hMemDC, hBmp32); 

      { Create DC just to copy bitmap into the memory DC }
      h_DC := CreateCompatibleDC(hMemDC); 
      if h_DC > 0 then 
      begin
        { Get how many bytes per row we have for the bitmap bits (rounded up 
        to 32 bits) }
        GetObject(hBmp32, SizeOf(bm32), @bm32);
        while (bm32.bmWidthBytes mod 4 <> 0) do 
          Inc(bm32.bmWidthBytes); 

        { Copy the bitmap into the memory DC } 
        HoldBmp := SelectObject(h_DC, hBmp); 
        BitBlt(hMemDC, 0, 0, bm.bmWidth, bm.bmHeight, h_DC, 0, 0, SRCCOPY); 

        { For better performance, we will use the ExtCreateRegion() function
        to create the region. This function take a RGNDATA structure on 
        entry. We will add rectangles by amount of ALLOC_UNIT number in this 
        structure. } 
        MaxRects := AllocUnit;
        hData := GlobalAlloc(GMEM_MOVEABLE, SizeOf(RGNDATAHEADER) +
        (SizeOf(TRect) * maxRects));
        pData := GlobalLock(hData); 
        with pData^.rdh do
        begin 
          dwSize := SizeOf(RGNDATAHEADER); 
          iType := RDH_RECTANGLES;
          nCount := 0;
          nRgnSize := 0; 
          SetRect(rcBound, MAXLONG, MAXLONG, 0, 0);
        end; 

        { Keep on hand highest and lowest values for the "transparent"
        pixels } 
        lr := GetRValue(cTransparentColor); 
        lg := GetGValue(cTransparentColor);
        lb := GetBValue(cTransparentColor); 
        hr := Min($ff, lr + GetRValue(cTolerance));
        hg := Min($ff, lg + GetGValue(cTolerance)); 
        hb := Min($ff, lb + GetBValue(cTolerance)); 

        { Scan each bitmap row from bottom to top (the bitmap is inverted 
        vertically) }
        p32 := PByte(Integer(bm32.bmBits) + (bm32.bmHeight - 1) * 
        bm32.bmWidthBytes); 
        for y := 0 to bm.bmHeight - 1 do 
        begin 
          { Scan each bitmap pixel from left to right } 
          // for x := 0 to bm.bmWidth - 1 do 
          x := 0;
          while x < bm.bmWidth do
          begin
            { Search for a continuos range of "non transparent pixels" } 
            x0 := x; 
            p := PLONG(Integer(p32)+x*SizeOf(LONG));
            while x < bm.bmWidth do 
            begin 
              b := GetRValue(p^);
              if (b >= lr) and (b <= hr) then
              begin 
                b := GetGValue(p^);
                if (b >= lg) and (b <= hg) then 
                begin
                  b := GetBValue(p^);
                  if (b >= lb) and (b <= hb) then 
                  begin 
                    Break; // this pixel is transparent
                  end; 
                end;
              end; 
              inc(p);
              inc(x); 
            end; // while x < bm.bmWidth 

            if x > x0 then 
            begin 
              { Add the pixels (x0, y) to (x, y+1) as a new rectangle in 
              the region }
              if pData^.rdh.nCount >= maxRects then 
              begin
                GlobalUnlock(hData);
                Inc(maxRects,AllocUnit);
                hData := GlobalReAlloc(hData, SizeOf(RGNDATAHEADER) +
                (SizeOf(TRect) * MaxRects), GMEM_MOVEABLE); 
                pData := GlobalLock(hData); 
              end;

              pr := @pData^.Buffer;
              SetRect(pr^[pData^.rdh.nCount], x0, y, x, y+1);
              with pData^.rdh do
              begin 
                if x0 < rcBound.Left then rcBound.Left := x0;
                if y < rcBound.Top then rcBound.Top := y; 
                if x > rcBound.Right then rcBound.Right := x;
                if y+1 > rcBound.Bottom then rcBound.Bottom := y+1; 
                Inc(nCount); 
              end; 
            end;

            { On Windows98, ExtCreateRegion() may fail if the number of
            rectangles is too large (ie: > 4000). Therefore, we have to 
            create the region by multiple steps. } 
            if pData^.rdh.nCount = 2000 then
            begin 
              h := ExtCreateRegion(nil, SizeOf(RGNDATAHEADER) +
              (SizeOf(TRect) * maxRects), pData^);
              if Rgn > 0 then 
              begin 
                CombineRgn(Rgn, Rgn, h, RGN_OR); 
                DeleteObject(h); 
              end 
              else 
                Rgn := h;
              pData^.rdh.nCount := 0;
              SetRect(pData^.rdh.rcBound, MAXLONG, MAXLONG, 0, 0); 
            end; 

            Inc(x);
          end; { for x := 0 to bm.Width - 1 (used a While loop to be able 
          to make Inc(x);) }
          { Go to next row (remember, the bitmap is inverted vertically) }
          Dec(p32, bm32.bmWidthBytes);
        end;  // for y := 0 to bm.Height - 1

        { Create or extend the region with the remaining rectangles }
        h := ExtCreateRegion(nil, SizeOf(RGNDATAHEADER) + (SizeOf(TRect) * 
        MaxRects), pData^);
        if Rgn > 0 then 
        begin
          CombineRgn(Rgn, Rgn, h, RGN_OR); 
          DeleteObject(h);
        end
        else
          Rgn := h;

        GlobalFree(hData);
        SelectObject(h_DC, holdBmp);
        DeleteDC(h_DC);
      end; // if h_DC > 0
      DeleteObject(SelectObject(hMemDC, holdBmp));
    end; // if hBmp32 > 0
    DeleteObject(hMemDC);
  end; // if hMemDC > 0
  Result := Rgn;
end;
procedure Cross(Canvas:TCanvas;p:Tpoint;radius:integer=5;color:TColor=clRed);
var
   c:TColor;
begin
   c:=canvas.Pen.Color;
   canvas.Pen.Color:=color;
   canvas.MoveTo(p.X-radius,p.Y);
   canvas.LineTo(p.X+radius,p.Y);
   canvas.MoveTo(p.X,p.Y-radius);
   canvas.LineTo(p.X,p.Y+radius);
   canvas.Pen.Color:=c;
end;
// Colecciones relacionadas con controles
constructor TControlItem.Create;
begin
   inherited;
end;
Procedure TControlItem.SetControl(value:TControl);
var
   i:integer;
   existe:boolean;
begin
  existe:=false;
  if (value<>nil) and (fcontrol<>value) then
  begin
     for i:=0 to Collection.Count-1 do
        if assigned(TControlItem(Collection.Items[i]).Control) then
           if TControlItem(Collection.Items[i]).Control.Name=value.Name then
           begin
              raise Exception.CreateResFmt(@sControlExistErrMsg, [value.Name]);
              existe:=true;
              break;
           end;
     if not existe then
     begin
        FControl := value;
     end;
  end
  else
     FControl := value;
end;
function TControlItem.GetDisplayName: string;
begin
   if assigned(FControl) then
      result:=self.Control.Name
   else
       result:='Control'+inttostr(index);
end;
constructor TControls.Create(Owner:TPersistent);
begin
   inherited Create(TControlItem);
   Fowner:=owner;
end;
procedure TControls.Notify(Item: TCollectionItem; Action: TCollectionNotification);
begin
//   if action=cnDeleting then showmessage('Borrar');
   inherited Notify(Item, Action);
end;
function TControls.GetItem(Index:Integer):TControlItem;
begin
   result:=TControlItem(inherited GetItem(Index));
end;
Procedure TControls.SetItem(Index:Integer;Value:TControlItem);
begin
   inherited SetItem(Index,Value);
end;
Function TControls.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TControls.Add:TControlItem;
begin
   result:=TControlItem(Inherited Add);
end;
//
procedure brightness(Bmp:TBitmap;value:integer);
var i, j: integer;
    SourceRow: pSplitRGBArray;
begin
     for i := 0 to bmp.Height - 1 do
     begin
       SourceRow := bmp.ScanLine[i];
       for j := 0 to bmp.Width - 1 do
       begin
       if value<0 then
       begin
           SourceRow[j].rgbtRed := Max(0, SourceRow[j].rgbtRed + value);
           SourceRow[j].rgbtGreen := Max(0, SourceRow[j].rgbtGreen + value);
           SourceRow[j].rgbtBlue := Max(0, SourceRow[j].rgbtBlue + value);
       end
       else
       begin
           SourceRow[j].rgbtRed := min(255, SourceRow[j].rgbtRed + value);
           SourceRow[j].rgbtGreen := min(255, SourceRow[j].rgbtGreen + value);
           SourceRow[j].rgbtBlue := min(255, SourceRow[j].rgbtBlue + value);
       end
       end;
     end;
end;
procedure MergeChanelRGB(bmp:TBitmap;bmpR:TBitmap;bmpG:TBitmap;bmpB:TBitmap);
var i, j: integer;
    SourceRow,sR,sG,sB: pSplitRGBArray;
begin
     for i := 0 to bmp.Height - 1 do
     begin
       SourceRow := bmp.ScanLine[i];
       sR:=bmpR.ScanLine[i];
       sB:=bmpB.ScanLine[i];
       sG:=bmpG.ScanLine[i];
       for j := 0 to bmp.Width - 1 do
       begin
           SourceRow[j].rgbtRed := sR[j].rgbtRed;
           SourceRow[j].rgbtGreen := sG[j].rgbtGreen;
           SourceRow[j].rgbtBlue := sB[j].rgbtBlue;
       end;
     end;
end;
procedure SetChanelRGBRed(Bmp:TBitmap);
begin
   SetChanelRGB(Bmp,sRed);
end;
procedure SetChanelRGBGreen(Bmp:TBitmap);
begin
   SetChanelRGB(Bmp,sGreen);
end;
procedure SetChanelRGBBlue(Bmp:TBitmap);
begin
   SetChanelRGB(Bmp,sBlue);
end;
procedure SetChanelRGB(Bmp:TBitmap;Color:TSplitRGB);
var i, j: integer;
    SourceRow: pSplitRGBArray;
    n:byte;
begin
  n:=0;
     for i := 0 to bmp.Height - 1 do
     begin
       SourceRow := bmp.ScanLine[i];
       for j := 0 to bmp.Width - 1 do
       begin
           case Color of
              sRed:n:=SourceRow[j].rgbtRed;
              sGreen:n:=SourceRow[j].rgbtGreen;
              sBlue :n:=SourceRow[j].rgbtBlue;
           end;
           SourceRow[j].rgbtRed := n;
           SourceRow[j].rgbtGreen := n;
           SourceRow[j].rgbtBlue := n;
       end;
     end;
end;
procedure Sleep(MSeconds : integer);
var
  initial,
  tmpSecs: cardinal;
begin
 Initial    := GetTickCount;
 tmpSecs:=MSeconds;
 While ((GetTickCount - Initial) <= tmpSecs) do
  Application.ProcessMessages;
end;

procedure IncPoint(var P:TPoint;N:longint=1);
begin
   inc(p.x,N);
   inc(p.y,N);
end;
procedure DecPoint(var P:TPoint;N:longint=1);
begin
   dec(p.x,N);
   dec(p.y,N);
end;
Function FileTemp(prefix:string):string;
var
   TmpDir: array [0..MAX_PATH-1] of char;
begin
   SetLength(result, MAX_PATH + 1);
   if GetTempPath(MAX_PATH, TmpDir)>0 then
      gettempfilename(TmpDir,pchar(prefix),0,pchar(result))
   else
      gettempfilename(pchar(getcurrentdir),pchar(prefix),0,pchar(result));
end;
Function FileTempCurrent(prefix:string):string;
begin
   SetLength(result, MAX_PATH + 1);
   gettempfilename(pchar(getcurrentdir),pchar(prefix),0,pchar(result));
end;
function Decode(cond:string;valores:TDecodeString;ifnoexist:string):string;
var i:integer;
begin
   for I:=low(valores) to high(valores) do
      if valores[i,1]=cond then
      begin
         result:=valores[i,2];
         break;
      end;
end;
Procedure SaveComponent(Component: TComponent;filename:tfilename);
var
   S:tstringlist;
begin
   s:=tstringlist.Create;
   s.Add(ComponentToString(Component));
   s.SaveToFile(filename);
   s.Free
end;
Procedure LoadComponent(Component:TComponent;filename:tfilename);
var
   S:tstringlist;
   i:integer;
   cad:string;
begin
   cad:='';
   s:=tstringlist.Create;
   s.LoadFromFile(filename);
   s.Insert(1,'object '+component.Name+': '+component.ClassName);
   for i:=1 to s.Count-1 do
      cad:=cad+s.Strings[i]+#10;
   try
      StringToComponent(component,cad);
   finally
      s.Free
   end;
end;
function ComponentToString(Component: TComponent): string;

var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

procedure StringToComponent(Component: TComponent;Value: string);
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      BinStream.ReadComponent(component);
    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;
function ColorToHtml(DColor:TColor):string;
 var
   tmpRGB : Tcolor;
begin
   tmpRGB := ColorToRGB(DColor);
   Result:=Format('#%.2x%.2x%.2x',
                  [GetRValue(tmpRGB),
                   GetGValue(tmpRGB),
                   GetBValue(tmpRGB)]);
end; {function ColorToHtml}
function IfThen(AValue: Boolean; const ATrue: TRect; const AFalse: TRect): TRect;
begin
   if AValue then result:=ATrue else result:=AFalse;
end;
function Iif(cond:boolean;ctrue:string;cfalse:string):string;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:integer;cfalse:integer):integer;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:double;cfalse:double):double;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Iif(cond:boolean;ctrue:boolean;cfalse:boolean):boolean;
begin
   if cond then result:=ctrue else result:=cfalse;
end;
function Between(value,n1,n2:integer):boolean; overload;
Begin
   result:=iif((value>=n1) and (value<=n2),true,false);
end;
function Between(value,n1,n2:Real):boolean; overload;
Begin
   result:=iif((value>=n1) and (value<=n2),true,false);
end;
function Between(value,n1,n2:double):boolean; overload;
Begin
   result:=iif((value>=n1) and (value<=n2),true,false);
end;
function Between(value,n1,n2:String):boolean; overload;
Begin
   result:=iif((value>=n1) and (value<=n2),true,false);
end;
function Between(value,n1,n2:Word):boolean; overload;
Begin
   result:=iif((value>=n1) and (value<=n2),true,false);
end;
constructor TBoolean.Create;
begin
   FValue:=False;
end;
constructor TBoolean.Create(V:Boolean);
begin
   fvalue:=v;
end;
constructor TBoolean.Create(V:integer);
begin
   fvalue:=iif(v=1,true,false);
end;
constructor TBoolean.Create(V:String);
begin
   fvalue:=iif((uppercase(v)='YES') or
               (uppercase(v)='TRUE')or
               (uppercase(v)='SI')or
               (uppercase(v)='S') ,true,false);
end;
Function TBoolean.F_OR(V:Boolean):Boolean;
begin
   result:=(Value or V);
end;
Function TBoolean.F_AND(V:Boolean):Boolean;
begin
   result:=(Value AND V);
end;

Function TBoolean.F_XOR(V:Boolean):Boolean;
begin
   result:=(Value xor V);
end;
Function TBoolean.toString:String;
begin
   result:=iif(value,'TRUE','FALSE');
end;
Function TBoolean.toInt:Integer;
begin
   result:=iif(value,1,0);
end;
//-------------------
procedure DrawGradient(B:TCanvas;h,w:integer;C:TGradColors;dir:integer);
var
  RGBDesde, RGBHasta, RGBDif : array[0..2] of byte;  {Colores inicial y final y diferencia de colores}
  contador, Rojo, Verde, Azul : integer;
  Banda : TRect;                                     {Coordenadas del recuadro a pintar}
  Factor : array[0..2] of shortint;                  {+1 si gradiente creciente o -1 en caso decreciente}
  esp,i,ancho,alto:integer;
  rancho,ralto:integer;
  colordesde,colorhasta:TColor;
  BTmp:TBitmap;
begin
  Btmp:=TBitmap.Create;
  try
     BTmp.Width:=W;
     BTmp.Height:=H;
     with BTMP.Canvas do
     begin
        esp:=high(C);
        ancho:=W div esp;
        alto:=H div esp;
        rancho:=0;
        ralto:=0;
        for i:=0 to esp-1 do
        begin
           if i=(esp-1) then
           begin
              rancho:=(W mod esp);
              ralto:=(H mod esp);
           end;
           ColorDesde:=c[i];
           ColorHasta:=c[i+1];
           RGBDesde[0]:=GetRValue(ColorToRGB(ColorDesde));
           RGBDesde[1]:=GetGValue(ColorToRGB(ColorDesde));
           RGBDesde[2]:=GetBValue(ColorToRGB(ColorDesde));    {Se descomponen los colores en rojo, verde y azul}
           RGBHasta[0]:=GetRValue(ColorToRGB(ColorHasta));
           RGBHasta[1]:=GetGValue(ColorToRGB(ColorHasta));
           RGBHasta[2]:=GetBValue(ColorToRGB(ColorHasta));
           for contador:=0 to 2 do         {Calculo de RGBDif[] y factor[]}
           begin
              RGBDif[contador]:=Abs(RGBHasta[contador]-RGBDesde[contador]);
              If RGBHasta[contador]>RGBDesde[contador] then factor[contador]:=1 else factor[contador]:=-1;
           end;
           Pen.Style:=psSolid;            {Asignamos el estilo del pen}
           Pen.Mode:=pmCopy;              {Idem modo}
           copymode:=cmSrcPaint;
           if Dir = 0 then      {Si el canvas es horizontal...}
           begin
              Banda.Left:=0;                      {Coordenadas recuadro}
              Banda.Right:=W;
              for contador:=0 to 255 do
              begin
                 Banda.Top:=(Alto*i)+MulDiv(contador,alto+ralto,256);
                 Banda.Bottom:=(Alto*i)+MulDIv(contador+1,alto+ralto,256);
                 Rojo:=RGBDesde[0]+factor[0]*MulDiv(contador,RGBDif[0],255);
                 Verde:=RGBDesde[1]+factor[1]*MulDiv(contador,RGBDif[1],255);
                 Azul:=RGBDesde[2]+factor[2]*MulDiv(contador,RGBDif[2],255);
                 Brush.Color:=RGB(Rojo,Verde,Azul);
                 FillRect(Banda);           {Pintamos el recuadro}
              end;
           end;
           if Dir = 1 then         {Gradiente vertical}
           begin
              Banda.Top:=0;
              Banda.Bottom:=H;
              for contador:=0 to 255 do
              begin
                 Banda.Left:=(ancho*i)+MulDiv(contador,ancho+rancho,256);
                 Banda.Right:=(ancho*i)+MulDIv(contador+1,ancho+rancho,256);
                 Rojo:=RGBDesde[0]+factor[0]*MulDiv(contador,RGBDif[0],255);
                 Verde:=RGBDesde[1]+factor[1]*MulDiv(contador,RGBDif[1],255);
                 Azul:=RGBDesde[2]+factor[2]*MulDiv(contador,RGBDif[2],255);
                 Brush.Color:=RGB(Rojo,Verde,Azul);
                 FillRect(Banda);
              end;
           end;
        end;
     end;
     b.Draw(0,0,btmp);
  finally
     btmp.Free;
  end;
end;
procedure DrawGradient(B:TBitmap;C:TGradColors;dir:integer);
begin
   DrawGradient(B.Canvas,b.height,b.width,C,dir);
end;
//-------------------
function BevelToEdge(value:TBevelCut;inner:Boolean):Cardinal;
begin
   if inner then
      case value of
         bvLowered:result:=BDR_SUNKENINNER;
         bvRaised,
         bvSpace  :result:=BDR_RAISEDINNER;
      else
         result:=0;
      end
   else
      case value of
         bvLowered:result:=BDR_SUNKENOUTER;
         bvRaised,
         bvSpace  :result:=BDR_RAISEDOUTER;
      else
         result:=0;
      end;
end;
end.
