unit igriegaClasses;

interface
uses
  Windows, Messages, SysUtils,Classes,Graphics,funciones,igriegastrs,math,controls,strutils;
type
   TLinkOperation=(loOpen,loPrint,loExplore);
   TBoxBevel=(bbRaised,bbLowered,bbNone,bbLoweredLine,bbRaisedLine,bbEdgeBump,bbEdgeEtChed);
   TShowCmd=(scHide,scMaximize,scMinimize,scRestore,scShow,scShowDefault,
             scShowMaximized,scShowMinimized,scShowMinNoActive,scShowNa,
             scShowNoActivate,scShowNormal);
   TPolygonType=(ptRect,ptOther,ptRoundRect,ptOval);
   TArrPoint=array of TPoint;
   TPolyFillMode=(pfmWinding,pfmAlternate);
   TDirection = (dHorizontal, dVertical);  {Tipo de direccin del gradiente}
   TVAlign = (vaTop,vaMiddle,vaBottom);
const
  APolyFillMode:Array[pfmWinding..pfmAlternate] of integer=(WINDING,ALTERNATE);
type
  TBorderLine=Class(TPersistent)
  private
     FTop,
     FBottom,
     FLeft,
     FRight:Boolean;
     FOwner:TComponent;
     procedure SetTop(Value:Boolean);
     procedure SetBottom(Value:Boolean);
     procedure SetLeft(Value:Boolean);
     procedure SetRight(Value:Boolean);
  protected
     Function GetOwner:TPersistent;override;
  public
     constructor Create(AOwner:TComponent);
  published
     Property Top:Boolean read FTop write SetTop default true;
     Property Bottom:Boolean read FBottom write SetBottom default true;
     Property Left:Boolean read FLeft write SetLeft default true;
     Property Right:Boolean read FRight write SetRight default true;
  end;
//=======================================================
//TLinkClass
//-------------------------------------------------------
// Define operaciones sobre un link
//=======================================================  
  TLinkClass=Class(TPersistent)
     private
        FFileName:TFilename;
        FOperation:TLinkOperation;
        FParameters:String;
        FDefaultDir:String;
        FshowCmd :TShowCmd; // TShowCmd definido en Funciones.pas
     public
        Constructor Create;
     published
        property Filename:TFilename read FFilename write FFilename;
        property Operation:TLinkOperation read FOperation write FOperation;
        property Parameters:String read FParameters write FParameters;
        property DefaultDir:String read FDefaultDir write FDefaultDir;
        property ShowCmd:TShowCmd read FShowCmd write FShowCmd default scSHOWNORMAL;
  end;
//=======================================================
  TCustomObjectItem=class(TCollectionItem)
     private
        FObj:TObject;
     public
        constructor Create(Collection:TCollection);override;
        destructor Destroy;override;
        property Obj:TObject read FObj Write FObj;
  end;
  TCustomObjectCollection=Class(TCollection)
     private
        FOwner:TPersistent;
        function GetItem(Index:Integer):TCustomObjectItem;
        Procedure SetItem(Index:Integer;Value:TCustomObjectItem);
     protected
        function GetOwner:TPersistent;override;
     public
         Constructor Create(Owner:TPersistent);
         Function Add:TCustomObjectItem; overload;
         property Items[Index:Integer]:TCustomObjectItem read Getitem write SetItem; default;
     END;
//=======================================================
//--------------------------------
// TPointType --------------------
//-------------------------------------------------
// Clase que define coordenadas X,Y
//-------------------------------------------------
  TPointType=class(TPersistent)
     private
        FX:integer;
        FY:integer;
        FOnChange:TNotifyEvent;
        FLimit:Boolean;
        FXLimit:array[0..1] of integer;
        FYLimit:array[0..1] of integer;
        Procedure SetX(Value:integer);
        Procedure SetY(Value:integer);
     protected
     public
        constructor Create;overload;
        constructor Create(px,py:Integer);overload;
        constructor Create(p:TPoint);overload;
        property Onchange:TNotifyEvent read FOnChange write FOnchange;
        Function GetPoint:TPoint;
        procedure SetPoint(Value:TPoint);overload;
        procedure SetPoint(px,py:Integer);overload;
        procedure SetLimit(Lim:Boolean;X0:integer=0;X1:integer=0;Y0:integer=0;Y1:integer=0);
     published
        property X:integer read FX write SetX default 0;
        property Y:integer read FY write SetY default 0;
     end;

//----------------------------------
// TPointColItem -------------------
//----------------------------------
//
  TCustomPointColItem=class(TCollectionItem)
     private
        FPoint:TPointType;
     protected
        function GetDisplayName: string; override;
     public
        constructor Create(Collection:TCollection);override;
        property Point:TPointType read FPoint Write FPoint;
//        property PointCol:TPointType read FPoint Write FPoint;
        Function GetPoint:TPoint;
     end;
  TPointColItem=class(TCustomPointColItem)
     published
//        property PointCol;
        property Point;
  end;
//----------------------------------
// TPolygon ------------------------
//--------------------------------------------------------
// Clase que define un polgono (una coleccin de puntos)
//--------------------------------------------------------
  TPolygon=Class(TCollection)
     private
        FOwner:TPersistent;
        FNumberFoundPoint:Integer;
        function GetItem(Index:Integer):TPointColItem;
        Procedure SetItem(Index:Integer;Value:TPointColItem);
     protected
        function GetOwner:TPersistent;override;
     public
         Constructor Create(Owner:TPersistent);
         Function Add:TPointColItem; overload;
         procedure Add(Point:TPoint); overload;
         property Items[Index:Integer]:TPointColItem read Getitem write SetItem; default;
         function ArrPolygon(var Arr:array of tpoint):Boolean;
         Procedure OffSet(p:TPoint);overload;
         Procedure OffSet(x,y:integer);overload;
         function FindPoint(p:TPoint;radius:integer=0):Boolean;
         Property NumberFoundPoint:Integer read FNumberFoundPoint;
         Function FoundPoint:TPoint;
         Function Rectangle(p1:integer=0;p2:integer=1):TRect;
         procedure SubtractPoints(p:tpoint;minpoints:integer=3);
         procedure SetMaxPoints(n:integer);
         procedure Turn(p:tpoint;degrees:Double);
         Function GetCenterPoint:TPoint;
         function MaxXY:TPoint;
         function MinXY:TPoint;
         Function GetRect:TRect;
         procedure Mirror;overload;
         procedure Flip; overload;
         procedure Mirror(P:TPoint);overload;
         procedure Flip(P:TPoint);overload;
         procedure Pivot;overload;
         procedure Pivot(P:TPoint);overload;
  end;
//----------------------------------
// TPolygonItem --------------------
//----------------------------------
  TPolygonItem=class(TCollectionItem)
     private
        FPolygon:TPolygon;
        FPolType:TPolygonType;
        FCorners:TPointType;
        FCenter:TPointType;
        FHasCenter:Boolean;
        FName:String;
        FTemp:Integer;
        FPolyFillMode:TPolyFillMode;
        procedure SetName(Value:String);
        procedure SetPolyFillMode(Value:TPolyFillMode);
     protected
        function GetDisplayName: string; override;
        procedure DefineProperties(Filer: TFiler);override;
     public
        constructor Create(Collection:TCollection);override;
        destructor Destroy;override;
        procedure LoadCenterProperty(Reader: TReader);
        procedure LoadHasCenterProperty(Reader: TReader);
        procedure StoreCenterProperty(Writer: TWriter);
        procedure StoreHasCenterProperty(Writer: TWriter);
        procedure Turn(p:tpoint;degrees:Double);
        property Center:TPointType read FCenter write FCenter;
        Property HasCenter:Boolean read FHascenter write FHascenter default false;
        Procedure GetXMLDef(L:TStringList;Ident:integer=3);
     published
        Property Corners:TPointType read FCorners Write FCorners;
        property Points:TPolygon read FPolygon Write FPolygon;
        property Name:String read FName write SetName;
        property PolType:TPolygonType read FPolType write FPoltype default ptOther;
        property PolyFillMode:TPolyFillMode read FPolyFillMode write SetPolyFillMode default pfmWinding;
     end;
//----------------------------------
// TCustomPolygons -----------------
//----------------------------------
// Define una coleccin de polgonos
//----------------------------------
  TLoadType=(ltAppend,ltReplace);
  TCustomPolygons=Class(TCollection)
       private
        FOwner:TPersistent;
        FIdent:byte;
        FLoadType:TLoadType;
        FLoading:Boolean;
        function GetItem(Index:Integer):TPolygonItem;
        Procedure SetItem(Index:Integer;Value:TPolygonItem);
     protected
        function GetOwner:TPersistent;override;
        property Loading:Boolean read FLoading default False;
     public
        Constructor Create(Owner:TPersistent);
        property Items[Index:Integer]:TPolygonItem read Getitem write SetItem; default;
        property Ident:byte read FIdent write FIdent;
        property LoadType:TLoadType read FLoadType write FLoadType default ltReplace;
        Function Add:TPolygonItem;
        procedure SaveToFile(Filename:TFilename);
        procedure LoadFromFile(Filename:TFilename);
        procedure AddFromStringList(SL:TStringList);
        procedure GetXMLDef(L:TStringList);
        function MaxXY:TPoint;
        function MinXY:TPoint;
        procedure MoveToOrigin;
        function FindPoint(P:TPoint;radius:integer=0):Integer;
        procedure Draw(Canvas:TCanvas;drawpoint:Boolean=false);
        Procedure DrawPolygon(Canvas:TCanvas;NPol:integer;drawpoint:Boolean=false);
        Function GetRect:TRect;
  end;
//----------------------------------------
// TCustomFramed -------------------------
//----------------------------------------
// Define Propiedades para marcos/paneles-
//----------------------------------------

  TCustomFramed=Class(TPersistent)
     private
        FPen:TPen;
        FBrush:TBrush;
        FSize:Integer;
        FOnChange:TNotifyEvent;
        FBevel:TBoxBevel;
        procedure SetSize(Value:Integer);
        procedure SetBevel(Value:TBoxBevel);
     protected
        property Onchange:TNotifyEvent read FOnChange write FOnchange;
        property Pen:TPen read FPen Write FPen;
        property Brush:TBrush read FBrush Write FBrush;
        property Size:Integer read FSize Write SetSize default 1;
        property Bevel:TBoxBevel read FBevel Write SetBevel default bbNone;
        procedure Change(Sender:TObject);
     public
        constructor Create;
        destructor Destroy;override;
     published
  end;
  TCustomString=Class(TObject)
  private
     FStr:String;
  public   
     Property Str:String Read FStr write FStr;
  end;
  TStringsList=class(TStringlist)
   private
      FFromIndex:Boolean;
   public
      Constructor Create;
      function Locate(strn:string;var Index:integer):Boolean;
      Function Contains(SubStrn:String;var Index:integer):boolean;
      Function BeginWith(SubStrn:String;var Index:integer):boolean;
      property FromIndex:Boolean read FFromIndex write fFromIndex default false;
   end;
  //-----------------------------------------------------------
  // TString
  //-----------------------------------------------------------
  TString=Class(TCustomString)
  private
     FIndex:Integer;
     FFound:Boolean;
  public
     Constructor Create; overload;
     Constructor Create(AValue:String);overload;
     Constructor Create(AValue:TStrings;Const Adelimiter:Char=#0);overload;
     Destructor Destroy;  override;
     Function Upper:String;
     Function Lower:String;
     Function IndexOf(ASubStr:string;BSensitive:Boolean=true):integer;overload;
     Function IndexOf(ASubStr:string;ACount:Integer;BSensitive:Boolean=true):integer;overload;
     Function IndexOf(ASubStr,ASubStart:string;BSensitive:Boolean=true):integer;overload;
     Function LastIndexOf(ASubStr:string;BSensitive:Boolean=true):integer;
     Function Contains(ASubText: string): Boolean;
     Function Dupe(ACount: Integer): string;
     Function Reverse:String;
     Function Left(const ACount:Integer):string;
     Function Right(const ACount:Integer):string;
     function Mid(const AStart, ACount: Integer): string;
     Function Length:Integer;
     function Replace(const AFromText, AToText: string): string;
     Procedure ReplaceIn(const AFromText, AToText: string);
     Procedure StrsToStr(AValue:TStrings;Const Adelimiter:Char=#0);
     Procedure Append(Const AText:String);
     Function Count(ASubStr:string;BSensitive:Boolean=true):integer;
     property Index:Integer read FIndex; //Last index found
     property Found:boolean read FFound; //Last operation index result found
  end;
const
   Poltypes:array[ptRect..ptOval] of string=('Rect','Other','RoundRect','Oval');
function ShowNumber(Value:TShowCmd):Integer;
function DupeString(const AText: string; ACount: Integer): string;
implementation
Constructor TStringsList.Create;
begin
   Inherited;
   FFromIndex:=false;
end;
function TStringsList.Locate(strn:string;var Index:integer):Boolean;
var i:integer;
   function CaseSensit:Boolean;
   begin
      if self.CaseSensitive then
         result:=(uppercase(self.Strings[i])=uppercase(strn))
      else
         result:=(Strings[i]=strn);
   end;
begin
   result:=false;
   index:=ifthen(FFromIndex,Index,-1);
   for i:=index+1 to self.Count - 1 do
      if CaseSensit then
      begin
         result:=true;
         index:=i;
         exit
      end;
end;
function TStringsList.Contains(SubStrn:string;var Index:integer):boolean;
var i:integer;
begin
   result:=false;
   index:=ifthen(FFromIndex,Index,-1);
   for i:=index+1 to self.Count - 1 do
      if AnsiContainsText(uppercase(self.Strings[i]),uppercase(SubStrn)) then
      begin
         result:=true;
         index:=i;
         exit
      end;
end;
Function TStringsList.BeginWith(SubStrn:String;var Index:integer):boolean;
var i:integer;
begin
   result:=false;
   index:=ifthen(FFromIndex,Index,-1);
   for i:=index+1 to self.Count - 1 do
      if copy(uppercase(self.Strings[i]),1,length(substrn))=uppercase(SubStrn) then
      begin
         result:=true;
         index:=i;
         exit
      end;
end;
Constructor TString.Create;
begin
   Inherited;
   FStr:='';
   FIndex:=0;
   FFound:=false;
end;
Constructor TString.Create(AValue:String);
begin
   Inherited Create;
   FStr:=AValue;
   FIndex:=0;
   FFound:=false;
end;
Constructor TString.Create(AValue:TStrings;Const Adelimiter:Char=#0);
var
   i:integer;
begin
   Inherited Create;
   for i:=0 to Avalue.Count-1 do
      FStr:=FStr+Avalue[i]+ifthen(ADelimiter=#0,'',ADelimiter);
end;
Destructor TString.Destroy;
begin
   inherited;
end;
Procedure TString.StrsToStr(AValue:TStrings;Const Adelimiter:Char=#0);
var
   i:integer;
begin
   Str:='';
   for i:=0 to Avalue.Count-1 do
      Str:=str+Avalue[i]+ifthen(ADelimiter=#0,'',ADelimiter);
end;
Procedure TString.Append(Const AText:String);
begin
   str:=str+Atext;
end;
function TString.Replace(const AFromText, AToText: string): string;
begin
   result:=AnsiReplaceText(Str,AFromText, AToText);
end;
Procedure TString.ReplaceIn(const AFromText, AToText: string);
begin
   Str:=AnsiReplaceText(Str,AFromText, AToText);
end;
Function TString.Left(const ACount:Integer):String;
Begin
   result:=leftstr(Str,Acount);
end;
Function TString.Right(const ACount:Integer):String;
Begin
   result:=RightStr(Str,Acount);
end;
Function TString.Upper:String;
begin
   result:=uppercase(Str);
end;
Function TString.Lower:String;
begin
   result:=lowercase(Str);
end;
function TString.Mid(const AStart, ACount: Integer): string;
begin
   result:=MidStr(str,AStart,ACount);
end;
Function TString.Length:Integer;
begin
   result:=System.Length(Str);
end;
Function TString.Count(ASubStr:string;BSensitive:Boolean=true):integer;
var
   cad,
   sub: String;
   n:integer;
begin
   n:=0;
   cad:=ifthen(BSensitive,str,uppercase(str));
   sub:=ifthen(BSensitive,ASubStr,uppercase(ASubStr));
   while pos(sub,cad)>0 do
   begin
      inc(n);
      cad:=rightstr(cad,system.length(cad)-pos(sub,cad));
   end;
   result:=n;
end;
Function TString.IndexOf(ASubStr,ASubStart:string;BSensitive:Boolean=true):integer;
var
   CadR,CadL,Cad,
   sub,subs: String;
   Stmp:String;
   n:integer;
begin
   cad:=ifthen(BSensitive,str,uppercase(str));
   sub:=ifthen(BSensitive,ASubStr,uppercase(ASubStr));
   subs:=ifthen(BSensitive,ASubStart,uppercase(ASubStart));
   if pos(subs,cad)>0 then
   begin
      CadL:=leftstr(cad,pos(subs,cad));
      CadR:=copy(cad,pos(subs,cad)+1,system.length(cad));
      Stmp:=Str;
      Str:=cadR;
      n:=self.IndexOf(Sub);
      if n>0 then
         result:=system.length(cadl)+n
      else
         result:=0;
      str:=stmp;
      if result>0 then
      begin
         FFound:=true;
         FIndex:=result;
      end
      else
         FFound:=False;
   end
   else
   begin
      Result:=0;
      FFound:=false;
   end;
end;

Function TString.IndexOf(ASubStr:string;ACount:Integer;BSensitive:Boolean=true):integer;
var
   CadR,CadL,
   sub: String;
   n:integer;
begin
   n:=0;
   CadL:='';
   CadR:=ifthen(BSensitive,str,uppercase(str));
   sub:=ifthen(BSensitive,ASubStr,uppercase(ASubStr));
   while (pos(sub,cadR)>0) and (n<ACount) do
   begin
      cadl:=cadl+leftstr(cadr,pos(sub,cadR));
      FIndex:=system.length(CadL);
      inc(n);
      cadR:=rightstr(cadR,system.length(cadR)-Findex);
   end;
   if (n=ACount) then
   begin
      result:=FIndex;
      FFound:=true;
   end
   else
   begin
      result:=0;
      FFound:=false;
   end;
end;
Function TString.IndexOf(ASubStr:string;BSensitive:Boolean=true):integer;
begin
   if BSensitive then
      result:=Pos(ASubStr,Str)
   else
      result:=Pos(uppercase(ASubStr),uppercase(Str));
   if result>0 then
   begin
      FFound:=true;
      FIndex:=Result;
   end
   else
      FFound:=false;
end;
Function TString.LastIndexOf(ASubStr:string;BSensitive:Boolean=true):integer;
var
   N:Integer;
begin
   if BSensitive then
      n:=Pos(ASubStr,ReverseString(Str))
   else
      n:=Pos(ASubStr,uppercase(ReverseString(Str)));
   if n>0 then
      result:=System.length(str)-n+1
   else
      result:=0;
   if result>0 then
   begin
      FFound:=true;
      FIndex:=Result;
   end
   else
      FFound:=false;
end;
Function TString.Dupe(ACount: Integer): string;
begin
   result:=StrUtils.DupeString(Str, ACount);
end;
Function TString.Reverse:String;
begin
   Result:=ReverseString(Str);
end;
Function TString.Contains(ASubText: string): Boolean;
begin
   result:=AnsiContainsText(Str,ASubText);
end;
function ShowNumber(Value:TShowCmd):Integer;
var
   vshow:Integer;
begin
  case Value of
     scHIDE:vshow:=SW_HIDE;
     scMAXIMIZE:vshow:=SW_MAXIMIZE;
     scMINIMIZE:vshow:=SW_MINIMIZE;
     scRESTORE:vshow:=SW_RESTORE;
     scSHOW:vshow:=SW_SHOW;
     scSHOWDEFAULT :vshow:=SW_SHOWDEFAULT;
     scSHOWMAXIMIZED:vshow:=SW_SHOWMAXIMIZED;
     scSHOWMINIMIZED:vshow:=SW_SHOWMINIMIZED;
     scSHOWMINNOACTIVE:vshow:=SW_SHOWMINNOACTIVE;
     scSHOWNA:vshow:=SW_SHOWNA;
     scSHOWNOACTIVATE:vshow:=SW_SHOWNOACTIVATE;
     scSHOWNORMAL:vshow:=SW_SHOWNORMAL;
  else
     vshow:=SW_SHOWNORMAL;
  end;
  result:=vshow;
end;

function DupeString(const AText: string; ACount: Integer): string;
   var
     P: PChar;
     C: Integer;
   begin
     C := Length(AText);
     SetLength(Result, C * ACount);
     P := Pointer(Result);
     if P = nil then Exit;
     while ACount > 0 do
     begin
       Move(Pointer(AText)^, P^, C);
       Inc(P, C);
       Dec(ACount);
     end;
   end;
//-----------------------------------------
constructor TBorderLine.Create(AOwner:TComponent);
begin
   FOwner:=AOwner;
   FTop:=true;
   FBottom:=true;
   FLeft:=true;
   FRight:=true;
end;
function TBorderLine.GetOwner:TPersistent;
begin
   result:=FOwner;
end;
procedure TBorderLine.SetTop(Value:Boolean);
begin
   if FTop<>Value then
   begin
      FTop:=Value;
      tcontrol(self.GetOwner).perform(CM_BORDERCHANGED,0,0);
   end;
end;
procedure TBorderLine.SetBottom(Value:Boolean);
begin
   if FBottom<>Value then
   begin
      FBottom:=Value;
      tcontrol(self.GetOwner).perform(CM_BORDERCHANGED,0,0);
   end;
end;
procedure TBorderLine.SetLeft(Value:Boolean);
begin
   if FLeft<>Value then
   begin
      FLeft:=Value;
      tcontrol(self.GetOwner).perform(CM_BORDERCHANGED,0,0);
   end;
end;
procedure TBorderLine.SetRight(Value:Boolean);
begin
   if FRight<>Value then
   begin
      FRight:=Value;
      tcontrol(self.GetOwner).perform(CM_BORDERCHANGED,0,0);
   end;
end;
//--------------------------------------------
constructor TLinkClass.Create;
begin
   FShowCmd:=scSHOWNORMAL;
end;
//----------------------------------------
// TCustomFramed -------------------------
//----------------------------------------
constructor TCustomFramed.Create;
begin
   inherited;
   FBrush:=TBrush.Create;
   FBrush.OnChange:=Change;
   FPen:=TPen.Create;
   FPen.OnChange:=Change;
   FSize:=1;
   FBevel:=bbNone;
end;
destructor TCustomFramed.Destroy;
begin
   FBrush.Free;
   FPen.Free;
end;
procedure TCustomFramed.SetSize(Value:Integer);
begin
   if FSize<>Value then
   begin
      FSize:=Value;
      Change(Self);
   end;
end;

procedure TCustomFramed.Change(Sender:TObject);
begin
   if Assigned(FOnChange) then
      FOnchange(Self);
end;
procedure TCustomFramed.SetBevel(Value:TBoxBevel);
begin
   if FBevel<>Value then
   begin
      FBevel:=Value;
      change(Self);
   end;
end;
//--------------------------------
// TPointType -----------------------
//--------------------------------
constructor TPointType.Create;
begin
   inherited;
   FX:=0;
   FY:=0;
   FLimit:=False;
end;
constructor TPointType.Create(px,py:integer);
begin
   Create;
   X:=px;
   Y:=py;
end;
constructor TPointType.Create(p:TPoint);
begin
   Create;
   X:=p.X;
   Y:=p.Y;
end;
procedure TPointType.SetLimit(Lim:Boolean;X0:integer=0;X1:integer=0;Y0:integer=0;Y1:integer=0);
begin
   FXLimit[0]:=X0;
   FXLimit[1]:=X1;
   FYLimit[0]:=Y0;
   FYLimit[1]:=Y1;
   FLimit:=Lim;
   if assigned(fonchange) then fonchange(Self);
end;
Procedure TPointType.SetX(Value:integer);
begin
   if (value<>FX) then
   if (FLimit and between(Value,FXLimit[0],FXLimit[1])) or not FLimit then
   begin
      FX:=Value;
      if assigned(fonchange) then fonchange(Self);
   end;
end;

Procedure TPointType.SetY(Value:integer);
begin
   if value<>FY then
   if (FLimit and between(Value,FYLimit[0],FYLimit[1])) or not FLimit then
   begin
      FY:=Value;
      if assigned(fonchange) then fonchange(Self);
   end;
end;
function TPointType.GetPoint:TPoint;
begin
   Result.X:=X;
   Result.Y:=Y;
end;
Procedure TPointType.SetPoint(Value:TPoint);
begin
   Self.X:=Value.X;
   Self.Y:=Value.Y;
end;
Procedure TPointType.SetPoint(px,py:Integer);
begin
   Self.X:=px;
   Self.Y:=py;
end;
//==========================================
constructor TCustomObjectItem.Create(Collection:TCollection);
begin
   inherited;
   FObj:=TObject.Create;
end;
destructor TCustomObjectItem.Destroy;
begin
   FObj.Free;
   inherited;
end;
constructor TCustomObjectCollection.Create(Owner:TPersistent);
begin
   inherited Create(TCustomObjectItem);
   Fowner:=owner;
end;
function TCustomObjectCollection.GetItem(Index:Integer):TCustomObjectItem;
begin
   result:=TCustomObjectItem(inherited GetItem(Index));
end;
Procedure TCustomObjectCollection.SetItem(Index:Integer;Value:TCustomObjectItem);
begin
   inherited SetItem(Index,Value);
end;
Function TCustomObjectCollection.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TCustomObjectCollection.Add:TCustomObjectItem;
begin
   result:=TCustomObjectItem(Inherited Add);
end;
//==========================================
//----------------------------------
// TPointColItem -------------------
//----------------------------------
constructor TCustomPointColItem.Create(Collection:TCollection);
begin
   inherited;
   Fpoint:=TPointType.Create;
end;
function TCustomPointColItem.GetDisplayName: string;
begin
   result:='Point_'+inttostr(index);
end;
function TCustomPointColItem.GetPoint:Tpoint;
begin
   result:=Point.GetPoint
end;
//------------------------
// TPolygon --------------
//------------------------
constructor TPolygon.Create(Owner:TPersistent);
begin
   inherited Create(TPointColItem);
   Fowner:=owner;
end;
function TPolygon.GetItem(Index:Integer):TPointColItem;
begin
   result:=TPointColItem(inherited GetItem(Index));
end;
Procedure TPolygon.SetItem(Index:Integer;Value:TPointColItem);
begin
   inherited SetItem(Index,Value);
end;
Function TPolygon.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TPolygon.Add:TPointColItem;
begin
   result:=TPointColItem(Inherited Add);
end;
procedure TPolygon.Add(Point:TPoint);
var
   A:TPointColItem;
begin
   A:=Self.Add;
   A.Point.SetPoint(Point);
end;
function TPolygon.ArrPolygon(var Arr:array of tpoint):Boolean;
var
   i:Integer;
begin
   Result:=(Count>0);
   if high(Arr)>=(count-1) then
//   SetLength(Arr,Self.Count);
      for i:=0 to Self.Count-1 do
         Arr[i]:=Items[i].Point.GetPoint
   else
      result:=false;
end;
Procedure TPolygon.OffSet(p:TPoint);
var
   i:integer;
begin
   for i:=0 to Count-1 do
   begin
      items[i].Point.X:=items[i].Point.X+p.X;
      items[i].Point.Y:=items[i].Point.Y+p.Y;
   end;
end;
Procedure TPolygon.OffSet(x,y:integer);
begin
   self.OffSet(Point(X,Y));
end;
function TPolygon.FindPoint(p:TPoint;radius:integer=0):Boolean;
var i:integer;
    p1:TPoint;
begin
   result:=false;
   for i:=0 to Count-1 do
   begin
      p1:=self.Items[i].GetPoint;
      if between(p1.X,p.X-radius,p.X+radius) and between(p1.y,p.y-radius,p.y+radius) then
      begin
         result:=true;
         FNumberFoundPoint:=i;
         break;
      end;
   end;
end;
Function TPolygon.FoundPoint:TPoint;
begin
   result:=self[self.numberfoundpoint].GetPoint;
end;
Function TPolygon.Rectangle(p1:integer=0;p2:integer=1):TRect;
begin
   if between(p1,0,Count-1) and between(p2,0,Count-1) then
      result:=Classes.rect(Items[p1].Point.getpoint,Items[p2].Point.getpoint)
   else
      result:=Classes.rect(0,0,100,100);
end;
procedure TPolygon.SubtractPoints(p:tpoint;minpoints:integer=3);
var
   pt:TPointType;
   i:integer;
begin
   if self.Count>=minpoints then
   begin
      pt:=items[0].Point;
      i:=1;
      while (i<count-1) and (count>minpoints) do
      begin
         if (abs(items[i].Point.X-pt.X)<p.X) and (abs(items[i].Point.y-pt.y)<p.y) then
            self.Delete(i)
         else
         begin
            pt:=items[i].Point;
            i:=i+1;
         end;
      end;
   end;
end;
procedure TPolygon.SetMaxPoints(n:integer);
var i:integer;
begin
   if n<3 then n:=3;
   i:=1;
   while count>n do
   begin
      self.SubtractPoints(point(i,i),n);
      i:=i+1;
   end;
end;
procedure TPolygon.Turn(p:tpoint;degrees:Double);
var
   i:integer;
   radius:real;
   p1:TPoint;
   ang:extended;
begin
//   degrees:=(round(degrees) div 360);
   degrees:=-degrees;
   for i:=0 to Count-1 do
   begin
      p1:=items[i].Point.GetPoint;
      p1.X:=p1.X-p.X;
      p1.y:=p1.y-p.y;
      if (p1.x<>0) or (p1.y<>0) then
      begin
         radius:=sqrt(power(p1.X,2)+Power(p1.y,2));
         ang:=arccos(p1.X/radius);
         if p1.Y<0 then ang:=-ang;
         items[i].Point.X:=round(radius*cos(ang+degtorad(degrees)))+p.X;
         items[i].Point.y:=round(radius*sin(ang+degtorad(degrees)))+p.y;
      end;
   end;
end;
function TPolygon.MaxXY:TPoint;
var
   j:integer;
begin
   result.X:=0;
   result.Y:=0;
   for j:=0 to Count-1 do
   with self[j].Point do
   begin
      result.X:=iif(result.X>X,result.X,X);
      result.Y:=iif(result.Y>Y,result.Y,Y);
   end;
end;
function TPolygon.MinXY:TPoint;
var
   j:integer;
begin
   result.X:=high(integer);
   result.Y:=high(integer);
   for j:=0 to Count-1 do
      with self[j].Point do
      begin
         result.X:=iif(result.X<X,result.X,X);
         result.Y:=iif(result.Y<Y,result.Y,Y);
      end;
end;
Function TPolygon.GetRect:TRect;
begin
   result:=Rect(minxy,maxxy);
end;
Function TPolygon.GetCenterPoint:TPoint;
var
   r:trect;
begin
   r:=GetRect;
   with R do
   begin
     Result.X := (Right - Left) div 2 + Left;
     Result.Y := (Bottom - Top) div 2 + Top;
   end;
end;
procedure TPolygon.Mirror;
var
   P:TPoint;
   i:integer;
begin
   P:=GetCenterPoint;
   for i:=0 to Count-1 do
   begin
       self[i].Point.X:=(2*p.X) -Self[i].Point.X
   end;
end;
procedure TPolygon.Flip;
var
   P:TPoint;
   i:integer;
begin
   P:=GetCenterPoint;
   for i:=0 to Count-1 do
   begin
       self[i].Point.Y:=(2*p.Y) -Self[i].Point.Y
   end;
end;
procedure TPolygon.Pivot;
var
   P:TPoint;
   i:integer;
begin
   P:=GetCenterPoint;
   for i:=0 to Count-1 do
   begin
       self[i].Point.X:=(2*p.X) -Self[i].Point.X;
       self[i].Point.Y:=(2*p.Y) -Self[i].Point.Y;
   end;
end;
procedure TPolygon.Mirror(P:TPoint);
var
   i:integer;
begin
   for i:=0 to Count-1 do
   begin
       self[i].Point.X:=(2*p.X) -Self[i].Point.X
   end;
end;
procedure TPolygon.Flip(P:TPoint);
var
   i:integer;
begin
   for i:=0 to Count-1 do
   begin
       self[i].Point.Y:=(2*p.Y) -Self[i].Point.Y
   end;
end;
procedure TPolygon.Pivot(P:TPoint);
var
   i:integer;
begin
   for i:=0 to Count-1 do
   begin
       self[i].Point.X:=(2*p.X) -Self[i].Point.X;
       self[i].Point.Y:=(2*p.Y) -Self[i].Point.Y;
   end;
end;
//----------------------------------
// TPolygonItem --------------------
//----------------------------------
constructor TPolygonItem.Create(Collection:TCollection);
begin
   inherited;
   FPolygon:=TPolygon.Create(tpolygon(Collection).Owner);
   FName:='Polygon_'+inttostr(index);
   FPolType:=ptOther;
   FCorners:=TPointType.Create(0,0);
   FCenter:=TPointType.Create(0,0);
   FHascenter:=false;
   FTemp:=0;
   FPolyFillMode:=pfmWinding;
end;
destructor TPolygonItem.destroy;
begin
   FCorners.Free;
   FCenter.Free;
   inherited;
end;
procedure TPolygonItem.SetName(Value:String);
begin
   if Value<>'' then
      FName:=Value
   else
      FName:='Polygon_'+inttostr(index);

end;
procedure TPolygonItem.SetPolyFillMode(Value:TPolyFillMode);
begin
   if FPolyFillMode<>Value then
   begin
      Collection.BeginUpdate;
      FPolyFillMode:=Value;
      Collection.EndUpdate;
   end;
end;
function TPolygonItem.GetDisplayName: string;
begin
   if (Name<>'') and (Name<>'Polygon_'+inttostr(index)) then
      result:=name
   else
      result:='Polygon_'+inttostr(index);
end;
procedure TPolygonItem.Turn(p:tpoint;degrees:Double);
begin
   Points.Add(center.getpoint);
   Points.Turn(p,degrees);
   center:=Points[Points.Count-1].Point;
   Points.Delete(Points.Count-1);
end;

Procedure TPolygonItem.GetXMLDef(L:TStringList;Ident:integer=3);
var
   s1:string;
   j:integer;
begin
   s1:=dupestring(' ',ident);
   l.Add(s1+'<Polygon Name="'+name+'" Type="'+Poltypes[PolType]+'">');
   l.Add(s1+s1+'<Corners X="'+inttostr(Corners.X)+'" Y="'+inttostr(Corners.Y)+'"/>');
   l.Add(s1+s1+'<Center X="'+inttostr(Center.X)+'" Y="'+inttostr(Center.Y)+'" Value="'+iif(hascenter,'True','False')+'"/>');
   for j:=0 to Points.Count-1 do
   begin
      l.Add(s1+s1+'<Point X="'+inttostr(Points[j].Point.X)+'" Y="'+inttostr(Points[j].Point.Y)+'"/>');
   end;
   l.Add(s1+'</Polygon>');
end;
procedure TPolygonItem.LoadCenterProperty(Reader: TReader);
begin
  Reader.ReadListBegin;
  Center.X:= Reader.ReadInteger;
  Center.Y:= Reader.ReadInteger;
  Reader.ReadListEnd
end;
procedure TPolygonItem.LoadHasCenterProperty(Reader: TReader);
begin
  FHasCenter:=Reader.ReadBoolean;
end;
procedure TPolygonItem.StoreCenterProperty(Writer: TWriter);
begin
  Writer.WriteListBegin;
  writer.WriteInteger(Center.X);
  Writer.WriteInteger(Center.Y);
  Writer.WriteListEnd;
end;
procedure TPolygonItem.StoreHasCenterProperty(Writer: TWriter);
begin
  Writer.WriteBoolean(HasCenter);
end;
procedure TPolygonItem.DefineProperties(Filer: TFiler);
begin
  inherited;
  Filer.DefineProperty('Center', LoadCenterProperty, StoreCenterProperty, True);
  Filer.DefineProperty('HasCenter', LoadHasCenterProperty, StoreHasCenterProperty, True);
end;
//----------------------------------
// TCustomPolygons -----------------
//----------------------------------

constructor TCustomPolygons.create(Owner:TPersistent);
begin
   inherited Create(TPolygonItem);
   Fowner:=owner;
   FIdent:=3;
   FLoadType:=ltReplace;
   FLoading:=false;
end;
function TCustomPolygons.GetItem(Index:Integer):TPolygonItem;
begin
   result:=TPolygonItem(inherited GetItem(Index));
end;
Procedure TCustomPolygons.SetItem(Index:Integer;Value:TPolygonItem);
begin
   inherited SetItem(Index,Value);
end;
Function TCustomPolygons.GetOwner:Tpersistent;
begin
   result:=Fowner;
end;
Function TCustomPolygons.Add:TPolygonItem;
begin
   result:=TPolygonItem(Inherited Add);
end;
procedure TCustomPolygons.Draw(Canvas:TCanvas;DrawPoint:Boolean=false);
Var
   i:integer;
begin
   for i:=0 to Count-1 do
      DrawPolygon(canvas,i,drawpoint);
end;
Procedure TCustomPolygons.DrawPolygon(Canvas:TCanvas;NPol:integer;drawpoint:Boolean=false);
var
   a:array[0..1000] of tpoint;
   j:integer;
begin
      with items[NPol] do
      case PolType of
         ptOther:
            begin
               Points.ArrPolygon(A);
               canvas.Polygon(Slice(A, Points.count));
            end;
         ptOval:
            begin
               canvas.Ellipse(rect(Points[0].point.getpoint,Points[1].point.getpoint));
            end;
         ptRect:
            begin
               canvas.Rectangle(rect(Points[0].point.getpoint,Points[1].point.getpoint));
            end;
         ptRoundRect:
            begin
               canvas.RoundRect(Points[0].point.X,Points[0].point.Y,
                                Points[1].point.X,Points[1].point.Y,
                                Corners.X,items[NPol].Corners.y);
            end;
      end;
      if DrawPoint then
         begin
            items[NPol].Points.ArrPolygon(A);
            for j:=0 to items[NPol].Points.count-1 do
            begin
                cross(canvas,A[j],5,clblue);
                if items[NPol].HasCenter then
                   cross(canvas,items[NPol].Center.GetPoint,5,clGreen)
            end;
         end;
end;
procedure TCustomPolygons.GetXMLDef(L:TStringList);
var
   i:integer;
begin
   l.Add(sXMLEncoding);
   l.Add('<Polygons>');
   for i:=0 to count-1 do
      items[i].GetXMLDef(l);
   l.Add('</Polygons>');
end;
procedure TCustomPolygons.SaveToFile(Filename:TFilename);
var
   L:TStringList;
   s1:string;
begin
   s1:=DupeString(' ',ident);
   L:=tstringlist.Create;
   GetXMLDef(L);
   l.SaveToFile(Filename);
   l.Free;
end;
procedure TCustomPolygons.AddFromStringList(SL:TStringList);
var
   l:String;
   i:integer;
   n,n1:integer;
   Pol:Boolean;
const
   Poltypes:array[ptRect..ptOval] of string=('Rect','Other','RoundRect','Oval');
   function GetPolType(s:string):TPolygonType;
   var i:TPolygonType;
   begin
      result:=ptOther;
      for i:=low(TPolygonType) to high(TpolygonType) do
         if s=poltypes[i] then
         begin
            result:=i;
            break;
         end;
   end;
begin
   FLoading:=true;
   try
      BeginUpdate;
      Pol:=False;
      for i:=0 to SL.Count-1 do
      begin
         L:=trim(SL[i]);
         if pos('<Polygon ',L)>0 then
         begin
            Add;
            pol:=true;
            if pos('Name="',L)>0 then
            begin
               n:=pos('Name="',L);
               n1:=n+6;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[self.Count-1].Name:=copy(l,n+6,n1-6-n);
            end;
            if pos('Type="',L)>0 then
            begin
               n:=pos('Type="',L);
               n1:=n+6;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[self.Count-1].PolType:=GetPolType(copy(l,n+6,n1-6-n));
            end;
         end;
         if pos('</Polygon',L)>0 then
            Pol:=false;
         if (pos('<Point ',L)>0) and pol then
         begin
            Items[Count-1].Points.add;
            if pos(' X="',L)>0 then
            begin
               n:=pos(' X="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].Points[Items[Count-1].Points.count-1].Point.X:=strtoint(copy(l,n+4,n1-4-n));
            end;
            if pos(' Y="',L)>0 then
            begin
               n:=pos(' Y="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].Points[Items[Count-1].Points.count-1].Point.Y:=strtoint(copy(l,n+4,n1-4-n));
            end;
         end;
         if (pos('<Corners ',L)>0) and pol then
         begin
            if pos(' X="',L)>0 then
            begin
               n:=pos(' X="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].corners.x:=strtoint(copy(l,n+4,n1-4-n));
            end;
            if pos(' Y="',L)>0 then
            begin
               n:=pos(' Y="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].corners.Y:=strtoint(copy(l,n+4,n1-4-n));
            end;
         end;
         if (pos('<Center ',L)>0) and pol then
         begin
            if pos(' X="',L)>0 then
            begin
               n:=pos(' X="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].center.x:=strtoint(copy(l,n+4,n1-4-n));
            end;
            if pos(' Y="',L)>0 then
            begin
               n:=pos(' Y="',L);
               n1:=n+4;
               while (L[n1]<>'"') and (n1<1000) do n1:=n1+1;
               Items[Count-1].center.Y:=strtoint(copy(l,n+4,n1-4-n));
            end;
            if pos('Value="True"',L)>0 then
               Items[Count-1].HasCenter:=true;
         end;
      end;
   finally
      FLoading:=false;
      EndUpdate;
   end;
end;
procedure TCustomPolygons.LoadFromFile(Filename:TFilename);
var
   SL:TStringList;
begin
   FLoading:=true;
   if LoadType=ltReplace then
      Clear;
   SL:=TStringList.Create;
   try
      sl.LoadFromFile(Filename);
      self.AddFromStringList(sl);
   finally
      SL.Free;
      FLoading:=false;
      EndUpdate;
   end;
end;
function TCustomPolygons.MaxXY:TPoint;
var
   i,j:integer;
begin
   result.X:=0;
   result.Y:=0;
   for i:=0 to count-1 do
      for j:=0 to items[i].Points.Count-1 do
      with items[i].Points[j].Point do
      begin
         result.X:=iif(result.X>X,result.X,X);
         result.Y:=iif(result.Y>Y,result.Y,Y);
      end;
end;
function TCustomPolygons.MinXY:TPoint;
var
   i,j:integer;
begin
   result.X:=high(integer);
   result.Y:=high(integer);
   for i:=0 to count-1 do
      for j:=0 to items[i].Points.Count-1 do
         with items[i].Points[j].Point do
         begin
            result.X:=iif(result.X<X,result.X,X);
            result.Y:=iif(result.Y<Y,result.Y,Y);
         end;
end;
Function TCustomPolygons.GetRect:TRect;
begin
   result:=Rect(minxy,maxxy);
end;

procedure TCustomPolygons.MoveToOrigin;
var
   i:integer;
   p:tpoint;
begin
   p:=MinXY;
   for i:=0 to Count-1 do
   begin
      if items[i].HasCenter then
      begin
         items[i].Center.X:=items[i].Center.X-p.X;
         items[i].Center.y:=items[i].Center.y-p.y;
      end;
      items[i].Points.OffSet(-p.x,-p.y);
   end;
end;
function  TCustomPolygons.FindPoint(P:TPoint;radius:integer=0):Integer;
var
   i:integer;
begin
   result:=-1;
   for i:=0 to count -1 do
      if Items[i].Points.FindPoint(P,radius) then
      begin
         result:=i;
         break;
      end;
end;
end.
