unit propShell ;
interface
uses windows, sysutils, dialogs, controls, forms, shlobj, activex, comobj,
     shellapi, classes;

type
  TRootFolder = (rtStartMenu, rtPrograms, rtDrives, rtDesktopDir, rtPersonal,
                 rtAppData, rtFavorites, rtTemplates, rtDesktop,rtControls,rtSendTo);

function browseFolderDialog(Title: string; rootType: TRootFolder;
                                           InitialDir: string): string;

implementation
function BrowseCallBack(hwnd: HWND; msg: UINT; lParam, lpData: LPARAM): Integer stdcall;
begin
  if (msg=BFFM_INITIALIZED) and (lpData <> 0)  then
    SendMessage(hwnd, BFFM_SETSELECTION, integer(TRUE), lpData);
  result := 0;
end;
function browseFolderDialog(Title: string; rootType: TRootFolder; InitialDir: string): string;
var
  csidl: Integer;
  namebuffer: Array [0..MAX_PATH] of Char;
  BrowseInfo: TBrowseInfo;
  pidl, pidlBrowse: pItemIDList;
  alloc: IMalloc;
begin
  Result := '';

  case rootType of
    rtDrives: csidl := CSIDL_DRIVES;
    rtPrograms: csidl := CSIDL_PROGRAMS;
    rtStartMenu: csidl := CSIDL_STARTMENU;
    rtDesktopDir: csidl := CSIDL_DESKTOPDIRECTORY;
    rtDesktop: csidl := CSIDL_DESKTOP;
    rtPersonal: csidl := CSIDL_PERSONAL;
    rtAppData: csidl := CSIDL_APPDATA;
    rtFavorites: csidl := CSIDL_FAVORITES;
    rtTemplates: csidl := CSIDL_TEMPLATES;
    rtControls: csidl := CSIDL_CONTROLS;
    rtSendTo: csidl := CSIDL_SENDTO;
  else
    exit;
  end;

  if SUCCEEDED(SHGetSpecialFolderLocation(Application.handle, csidl, pidl)) then
  begin
    If pidl <> Nil Then
    Begin
      With BrowseInfo Do
      Begin
      	hwndOwner := Application.handle;
	pidlRoot := pidl;
	pszDisplayName := @namebuffer;
	lpszTitle := pchar(Title);
	ulFlags := BIF_RETURNONLYFSDIRS;
	lpfn := BrowseCallBack;
	lParam := 0;
        if InitialDir <> '' then
          lParam := integer(pchar(InitialDir));
	pidlBrowse := SHBrowseForFolder(BrowseInfo);
        If pidlBrowse <> Nil Then
        begin
          If SHGetPathFromIDList(pidlBrowse, namebuffer) Then
            Result := StrPas(namebuffer);
            If Succeeded(SHGetMalloc(alloc)) Then
               alloc.Free(pidlBrowse);
        end;
        If Succeeded(SHGetMalloc(alloc)) Then 
           alloc.Free(pidl);
      end;  
    End;
  end;
end;
end.


