unit PropPol;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList, Menus, Spin,igriegastrs;

type
  TfrmPropPol = class(TForm)
    btnOk: TBitBtn;
    sbPoints: TStatusBar;
    tvPoints: TTreeView;
    Label3: TLabel;
    mnuPoints: TPopupMenu;
    Delete1: TMenuItem;
    ilPoints: TImageList;
    Insert1: TMenuItem;
    AddAfter1: TMenuItem;
    N1: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    txtName: TEdit;
    Label4: TLabel;
    Label1: TLabel;
    lblType: TLabel;
    Label5: TLabel;
    SpinCenterX: TSpinEdit;
    Label6: TLabel;
    SpinCenterY: TSpinEdit;
    btnCancel: TBitBtn;
    btnUp: TSpeedButton;
    btnDown: TSpeedButton;
    SpinCornerY: TSpinEdit;
    lblCornerY: TLabel;
    SpinCornerX: TSpinEdit;
    lblCornerX: TLabel;
    chkHasCenter: TCheckBox;
    procedure tvPointsEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure tvPointsEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure Delete1Click(Sender: TObject);
    procedure mnuPointsPopup(Sender: TObject);
    procedure Insert1Click(Sender: TObject);
    procedure AddAfter1Click(Sender: TObject);
    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure btnUpClick(Sender: TObject);
    procedure btnDownClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPropPol: TfrmPropPol;
  np:integer;
  x,y:integer;
implementation

{$R *.dfm}

procedure TfrmPropPol.tvPointsEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
   if copy(node.Text,1,5)='Point' then AllowEdit:=false;
end;

procedure TfrmPropPol.tvPointsEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
var
   n:Integer;
begin
   try
      N:=strtoint(S);
      s:=inttostr(N);
   except
      S:='0';
   end;
end;

procedure TfrmPropPol.Delete1Click(Sender: TObject);
begin
   if np>3 then
   begin
      tvpoints.Selected.Free;
      np:=np-1;
      self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
   end
   else
      raise Exception.CreateRes(@sWrongNumbersOfPoints);
end;

procedure TfrmPropPol.mnuPointsPopup(Sender: TObject);
var
   t:ttreenode;
begin
   t:=tvpoints.Selected;
   if copy(t.Text,1,5)='Point' then
   begin
      mnuPoints.Items[0].Visible:=true;
      mnuPoints.Items[1].Visible:=true
   end
   else
   begin
      mnuPoints.Items[0].Visible:=false;
      mnuPoints.Items[1].Visible:=false;
   end;
end;

procedure TfrmPropPol.Insert1Click(Sender: TObject);
var
 t,tt:TTreenode;
begin
  t:=tvpoints.Items.insert(tvpoints.Selected,'Point Added');
  t.ImageIndex:=4;
  t.SelectedIndex:=4;
  tt:=tvPoints.Items.AddChild(t,inttostr(x));
  tt.ImageIndex:=1;
  tt.SelectedIndex:=1;
  tt:=tvPoints.Items.AddChild(t,inttostr(Y));
  tt.ImageIndex:=2;
  tt.SelectedIndex:=2;
  np:=np+1;
  self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
end;

procedure TfrmPropPol.AddAfter1Click(Sender: TObject);
var
 t,tt:TTreenode;
begin
  t:=tvpoints.Items.Add(nil,'Point Added');
  t.ImageIndex:=4;
  t.SelectedIndex:=4;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=1;
  tt.SelectedIndex:=1;
  tt:=tvPoints.Items.AddChild(t,'0');
  tt.ImageIndex:=2;
  tt.SelectedIndex:=2;
  np:=np+1;
  self.sbPoints.SimpleText:='Number of points : '+inttostr(np);
end;

procedure TfrmPropPol.ExpandAll1Click(Sender: TObject);
begin
   tvpoints.FullExpand;
end;

procedure TfrmPropPol.CollapseAll1Click(Sender: TObject);
begin
   tvPoints.FullCollapse;
end;

procedure TfrmPropPol.FormActivate(Sender: TObject);
begin
   sbPoints.SimpleText:='Number of points : '+inttostr(np);
   if lblType.Caption='RoundRect' then
    begin
       SpinCornerX.Visible:=True;
       SpinCornerY.Visible:=True;
       lblCornerX.Visible:=True;
       lblCornerY.Visible:=True;
    end
    else
    begin
       SpinCornerX.Visible:=False;
       SpinCornerY.Visible:=False;
       lblCornerX.Visible:=False;
       lblCornerY.Visible:=False;
    end;

end;

procedure TfrmPropPol.FormCreate(Sender: TObject);
var
   tmpimage:TBitmap;
begin
   X:=0;
   y:=0;
   tmpimage:=TBitmap.Create;
   try
      tmpimage.Handle:=LoadBitmap( 0,makeintresource(OBM_UPARROWD));
      btnup.Glyph.Assign(tmpimage);
      btnup.NumGlyphs:=1;
      DeleteObject(tmpimage.Handle);
      tmpimage.Handle:=LoadBitmap( 0,makeintresource(OBM_DNARROWD));
      btnDown.Glyph.Assign(tmpimage);
      btnDown.NumGlyphs:=1;
      DeleteObject(tmpimage.Handle);
   finally
      tmpimage.Free;
   end;

end;

procedure TfrmPropPol.sBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
var
   t,t1:ttreenode;
begin
   t:=tvpoints.Selected;
   if t<>nil then
   if copy(t.Text,1,5)='Point' then
      if scLineUp=ScrollCode then
      begin
         t1:=t.getPrevSibling;
         t.MoveTo(t1,naInsert);
         t.selected:=true;
      end
      else
      begin
         t1:=t.getNextSibling;
         t.MoveTo(t1,naAdd);
      end;
end;

procedure TfrmPropPol.btnUpClick(Sender: TObject);
var
   t,t1:ttreenode;
begin
   t:=tvpoints.Selected;
   if t<>nil then
   if copy(t.Text,1,5)='Point' then
      begin
         t1:=t.getPrevSibling;
         if t1<>nil then
         begin
            t.MoveTo(t1,naInsert);
            t.selected:=true;
         end;
      end;
end;

procedure TfrmPropPol.btnDownClick(Sender: TObject);
var
   t,t1:ttreenode;
begin
   t:=tvpoints.Selected;
   if t<>nil then
   if copy(t.Text,1,5)='Point' then
      begin
         t1:=t.getNextSibling;
         if t1<>nil then
         begin
            t1.MoveTo(t,naInsert);
            t.Selected:=true;
         end;
      end;
end;

end.
